;;; Sierra Script 1.0 - (do not remove this comment)
(script# 695)
(include sci.sh)
(use Main)
(use Monster)
(use Motion)
(use Actor)
(use System)

(public
	jackalMan 0
)

(local
	local0
	[local1 8] = [0 0 2 1 0 2 1]
	[local9 8] = [1 1 1 2 2 2 3 3]
	[local17 15] = [0 0 0 0 200 90 0 262 122 0 241 88 0 159 55]
)
(instance jackalMan of Monster
	(properties
		x 173
		y 106
		noun '/jackal,jackal,(man<jackal),monster,creature'
		description {the Jackalman.}
		lookStr {Jackalmen travel in packs, and prefer attacking things previously wounded.}
		yStep 3
		view 695
		priority 5
		xStep 5
		strength 70
		intell 70
		agil 70
		vit 70
		luck 70
		weap 70
		parry 60
		dodge 80
		armorValue 3
		weapValue 4
		barMessage {Jackalman}
		chaseDelay 6
		attackRange 50
	)
	
	(method (dispose)
		(if (not (lilHelpers isEmpty:))
			(lilHelpers dispose: release:)
		)
		(super dispose:)
	)
	
	(method (die)
		(cond 
			((< local0 0) (super die:) (return))
			((not local0))
			(else ([local17 (* local0 3)] setScript: takeOverS))
		)
		(jackalMan setScript: jackalDeathS)
		(= health (self calcHealth:))
		(= stamina (self calcStamina:))
		(self setHealth: health)
		(self setStamina: stamina)
	)
	
	(method (initCombat param1 &tmp temp0 temp1 temp2 temp3 temp4 temp5)
		(asm
			lag      jackalmenInRoom
			sat      temp0
code_0171:
			-at      temp0
			push    
			ldi      0
			gt?     
			bnt      code_0207
			lst      temp0
			ldi      3
			mul     
			sat      temp1
			pushi    #new
			pushi    0
			class    Actor
			send     4
			push    
			lat      temp1
			sali     local17
			lat      temp1
			lali     local17
			sat      temp2
			+at      temp1
			lali     local17
			sat      temp3
			+at      temp1
			lali     local17
			sat      temp4
			pushi    2
			pushi    1
			pushi    10
			callk    Random,  4
			sat      temp5
			pushi    5
			pushi    1
			pushi    698
			pushi    6
			pushi    1
			push    
			ldi      5
			gt?     
			bnt      code_01bd
			ldi      1
			jmp      code_01bf
code_01bd:
			ldi      0
code_01bf:
			push    
			pushi    237
			pushi    2
			lst      temp3
			lst      temp4
			pushi    102
			pushi    0
			pushi    139
			pushi    1
			lst      temp5
			ldi      5
			gt?     
			bnt      code_01dd
			lofsa    Bay
			jmp      code_01df
code_01dd:
			class    Fwd
code_01df:
			push    
			lat      temp2
			send     30
			lsg      gSeconds
			ldi      0
			eq?     
			bt       code_01fc
			lsg      gSeconds
			ldi      1
			eq?     
			bnt      code_0171
			lst      temp0
			ldi      2
			gt?     
			bnt      code_0171
code_01fc:
			pushi    #stopUpd
			pushi    0
			lat      temp2
			send     4
			jmp      code_0171
code_0207:
			lofsa    jackalCombatS
			aTop     combatScript
			lsg      jackalmenInRoom
			ldi      1
			sub     
			sal      local0
			ldi      0
			sag      centimesOnMonster
			pushi    #initCombat
			pushi    0
			&rest    param1
			super    Monster,  4
			pushi    #cycles
			pushi    1
			pushi    0
			pushi    128
			pushi    1
			pushi    2
			lofsa    jackalCombatS
			send     12
			ret     
		)
	)
	
	(method (endCombat)
		(if centimesOnMonster
			(= jackalmenInRoom (- jackalmenInRoom centimesOnMonster))
			(= global304 58)
			(if (not jackalmenInRoom) (= health 0))
		)
		(super endCombat:)
	)
	
	(method (initAmbush &tmp theJackalmenInRoom temp1 temp2 temp3 newActor)
		(super initAmbush:)
		(= theJackalmenInRoom jackalmenInRoom)
		(= temp1 (if (< (ego x?) 160) 355 else -35))
		(= temp2 165)
		(= temp3 (if (== temp1 355) -80 else 80))
		(while (> (-- theJackalmenInRoom) 0)
			((= newActor (Actor new:))
				view: 696
				x:
					(switch theJackalmenInRoom
						(4 (= temp1 (- temp1 20)))
						(3 (= temp1 (- temp1 15)))
						(2 (= temp1 (- temp1 10)))
						(1 (= temp1 (- temp1 5)))
					)
				y:
					(switch theJackalmenInRoom
						(4 (= temp2 (+ temp2 17)))
						(3 (= temp2 (+ temp2 12)))
						(2 (= temp2 (+ temp2 7)))
						(1 (= temp2 (- temp2 7)))
					)
				init:
				ignoreActors: 1
				setCycle: Walk
				setMotion: (MoveToStop new:) (+ temp1 temp3) temp2
			)
			(lilHelpers addToEnd: newActor)
		)
	)
)

(instance jackalCombatS of Script
	(properties)
	
	(method (changeState newState &tmp clientOpponent temp1)
		(switch (= state newState)
			(0 (= cycles 3))
			(1
				(= temp1 (Random 3 10))
				(client
					action: [local9 (- temp1 3)]
					attDirection: [local1 (- temp1 3)]
					setLoop: temp1
					cel: 0
				)
				(= cycles (Random 5 15))
			)
			(2 (client setCycle: End self))
			(3
				(= clientOpponent (client opponent?))
				(if
					(and
						(== (client action?) 1)
						(client tryAttack: clientOpponent 0)
					)
					(client doDamage: clientOpponent 0 1)
				)
				(= cycles 2)
			)
			(4 (client setCycle: Beg self))
			(5
				(client action: 0 setLoop: 0)
				(self changeState: 1)
			)
		)
	)
)

(instance jackalDeathS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					canFight: 0
					action: 0
					setLoop: 2
					setCel: 0
					setCycle: End self
				)
			)
			(1
				(switch (++ centimesOnMonster)
					(1
						(bodyPile setLoop: 2 setCel: 3 init:)
					)
					(2
						(bodyPile setLoop: 12 setCel: 0)
					)
					(3
						(bodyPile setLoop: 13 setCel: 0)
					)
					(4
						(DrawFeature picPile)
						(bodyPile
							x: (- (bodyPile x?) 5)
							y: (+ (bodyPile y?) 5)
							setLoop: 2
							setCel: 3
						)
					)
					(5
						(bodyPile setLoop: 12 setCel: 0)
					)
				)
				(client hide:)
				(if (< (-- local0) 0) (client die:))
				(self dispose:)
			)
		)
	)
)

(instance takeOverS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((jackalMan opponent?) canFight: 0)
				(client setLoop: 2 setCel: 0 setCycle: End self)
			)
			(1
				(client
					view: 696
					setLoop: -1
					illegalBits: 0
					ignoreActors: 1
					setCycle: Walk
					setMotion: MoveTo 173 106 self
				)
			)
			(2
				(jackalMan loop: 0 show:)
				(client hide: dispose:)
				((jackalMan opponent?) canFight: 1)
			)
		)
	)
)

(instance bodyPile of View
	(properties
		x 178
		y 111
		view 695
	)
)

(instance picPile of PicView
	(properties
		x 178
		y 111
		view 695
		loop 13
	)
)

(class Bay of Cycle
	(properties
		client 0
		caller 0
		cycleDir 1
		cycleCnt 0
		completed 0
		waitCnt 0
		howlCnt 0
		done 0
	)
	
	(method (doit &tmp clientCel bayNextCel)
		(= clientCel (client cel?))
		(= bayNextCel (self nextCel:))
		(cond 
			(howlCnt (if (not (-- howlCnt)) (= cycleDir -1)))
			(done (if (not (-- waitCnt)) (= cycleDir 1) (= done 0)))
			((== clientCel bayNextCel))
			((> bayNextCel (client lastCel:)) (= howlCnt (Random 10 20)))
			((< bayNextCel 1) (self cycleDone:))
			(else (client cel: bayNextCel))
		)
	)
	
	(method (cycleDone)
		(= waitCnt (Random 20 30))
		(= done 1)
	)
)

(instance MoveToStop of MoveTo
	(properties)
	
	(method (moveDone)
		(client stopUpd:)
		(super moveDone:)
	)
)

(instance lilHelpers of List
	(properties)
)
