;;; Sierra Script 1.0 - (do not remove this comment)
(script# 310)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use n003)
(use Talker)
(use Plaza)
(use FountainPlaza)
(use Merchant)
(use MsgMerchant)
(use PlazaDoor)
(use Polygon)
(use Feature)
(use LoadMany)
(use Actor)

(public
	FPN 0
)

(local
	[local0 4] = [44 '//basket,reed,merchandise']
	[local4 16] = [60 '//merchandise' 53 '//brass,merchandise,metal,mineral' 54 '//brazier' 55 '//((server,cup)[<tea,about]),teacup' 56 '//lamp,lamp' 57 '//bottle' 66 '//grease']
	[local20 6] = [67 '//bouquet,merchandise,plant,green' 68 '//earth,dirt']
)
(instance FPN of FountainPlaza
	(properties
		north 704
		south 315
		west 704
	)
	
	(method (init &tmp temp0)
		(LoadMany 128 301 310 315)
		(super init:)
		(magicEye init:)
		(magicDoor init:)
		(proc1_31 flowerBox)
		(DrawFeature northSign magicSign leftWindow)
		(self
			addObstacle:
				(poly1
					init:
						0
						161
						48
						150
						99
						116
						125
						117
						150
						96
						147
						6
						169
						6
						171
						95
						179
						96
						219
						94
						236
						102
						259
						116
						251
						137
						266
						162
						276
						170
						319
						169
						319
						0
						309
						0
						0
						0
					yourself:
				)
				(poly2
					init: 104 189 92 173 121 147 159 139 199 147 228 172 219 189
					yourself:
				)
		)
		(if
			(and
				(<= 0 currentTimeZone)
				(<= currentTimeZone 4)
				(not (proc80_0))
			)
			(tashtari init:)
			(saba init:)
			(lasham init:)
			(= saveIllegal -18432)
		)
	)
)

(instance magicDoor of PlazaDoor
	(properties
		x 252
		y 117
		noun '/door[<magic]'
		description {the door to the Magic Shop}
		lookStr {The sign above the door is keeping an eye out for you.__Perhaps the door leads to the optometrist's office.}
		view 301
		loop 3
		priority 6
		signal $4010
		entranceTo 250
		exitDir 1
		xOut 278
		yOut 115
		xIn 230
		yIn 115
		barred 1
	)
)

(instance saba of MsgMerchant
	(properties
		x 117
		y 103
		description {Saba, the basket merchant}
		lookStr {It is Saba, the basket merchant.}
		priority 6
		signal $0010
		myName '//(maker[<basket,about]),saba,weaver,basketmaker,identity,family,daughter,merchant,tasman,catperson'
		title {Saba:}
		clothesColor 1
		firstMsgNum 47
	)
	
	(method (init)
		(super init:)
		(proc1_31 baskets)
		(basketStand init:)
		(self addWares: basket)
		(= lastMsgSaid gLastMsgSaid)
	)
	
	(method (dispose)
		(= gLastMsgSaid lastMsgSaid)
		(super dispose:)
	)
	
	(method (showSelf)
		(Say self 310 1)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((Said 'ask//plant,bouquet') (Say self 310 2))
			((Said 'ask//lasham') (Say self 310 3))
			((Said 'ask//brass,lamp') (Say self 310 4))
			((Said 'ask//tashtari') (Say self 310 5))
			((Said 'ask//keapon,keapon,(shop<magic)') (Say self 310 6))
			(else (super handleEvent: pEvent))
		)
	)
	
	(method (egoCanBuy &tmp superEgoCanBuy)
		(if (= superEgoCanBuy (super egoCanBuy:))
			(HighPrint 310 0)
		)
		(return superEgoCanBuy)
	)
	
	(method (sayBargainSuccess)
		(Say self self 350 45)
	)
	
	(method (sayBargainFailure)
		(Say self self 350 46)
	)
	
	(method (atIndividualSpec param1)
		(return [local0 param1])
	)
)

(instance basket of Class_84_1
	(properties
		invItem 34
		noun '//basket>'
		price 100
		lowPrice 75
		canBuyMultiple 0
	)
	
	(method (saidMe param1)
		(return
			(if (super saidMe: param1)
				(if (or (< currentDay 12) (> elementalsStatus 5))
					(HighPrint 310 7)
					(return -1)
				else
					(return 1)
				)
			else
				(return 0)
			)
		)
	)
)

(instance basketStand of PicView
	(properties
		x 105
		y 108
		noun '/stand[<basket]'
		description {the basket merchant's stand}
		lookStr {The basket merchant's stand smells of wicker and straw.}
		view 315
		priority 6
		signal $4010
	)
)

(class Class_310_5
	(properties)
	
	(method (doit)
		(Say lasham self 310 8)
	)
	
	(method (cue)
		(ego get: 32)
		(= global293 (+ global293 6))
		(HighPrint 310 9)
	)
)

(instance lasham of MsgMerchant
	(properties
		x 293
		y 158
		description {Lasham, the plant merchant}
		lookStr {It is Lasham, the plant merchant.}
		priority 10
		signal $0010
		myName '//lasham,(merchant[<bouquet,plant]),catperson'
		title {Lasham:}
		isSeated 0
		isOnLeft 0
		clothesColor 6
		firstMsgNum 69
	)
	
	(method (init)
		(super init:)
		(proc1_31 flowers)
		(self addWares: plant)
		(DrawFeature plant1 plant2 flowerStand)
		(= lastMsgSaid gLastMsgSaid_2)
	)
	
	(method (dispose)
		(= gLastMsgSaid_2 lastMsgSaid)
		(super dispose:)
	)
	
	(method (showSelf)
		(Say self 310 10)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1)
		(cond 
			((Said 'get,acquire,buy/earth,dirt') (Class_310_5 doit:))
			((Said 'tell,talk,chat//elemental<air')
				(if (ego has: 32)
					(pEvent claimed: 0)
					(super handleEvent: pEvent)
				else
					(Class_310_5 doit:)
				)
			)
			((Said 'gave/dinar,cent,alm>')
				(if (Said '/dinar')
					(= temp0 (proc3_2 (= temp1 100)))
				else
					(pEvent claimed: 1)
					(= temp0 (proc3_2 (= temp1 1)))
				)
				(if temp0
					(Say self 310 11)
					(SkillUsed 14 (/ (+ temp1 4) 5))
				else
					(HighPrint 310 12)
				)
			)
			((Said 'ask//basket,reed') (Say self 310 13))
			((Said 'ask//lasham') (Say self 310 3))
			((Said 'ask//brass,lamp') (Say self 310 14))
			((Said 'ask//tashtari') (Say self 310 3))
			((Said 'ask//keapon,keapon,(shop<magic)') (Say self 310 6))
			(else
				(super handleEvent: pEvent)
				(if
					(or
						(Said 'search,look,examine[<at,around][/room,area][/!*]')
						(Said 'look,examine/courtyard')
					)
					(HighPrint 310 15)
				)
			)
		)
		(pEvent claimed?)
	)
	
	(method (atIndividualSpec param1)
		(return [local20 param1])
	)
)

(instance plant of Class_84_1
	(properties
		noun '//plant,bouquet>'
		price 100
	)
	
	(method (saidMe)
		(return
			(if (super saidMe:)
				(HighPrint 310 16)
				(return -1)
			else
				(return 0)
			)
		)
	)
)

(instance flowerStand of PicView
	(properties
		x 286
		y 161
		noun '/stand[<bouquet,plant]'
		description {the plant merchant's stand}
		lookStr {It is the stand of Lasham, the plant merchant.}
		view 300
		loop 7
		priority 10
		signal $4010
	)
)

(instance plant1 of PicView
	(properties
		x 279
		y 162
		noun '/plant'
		description {a plant}
		lookStr {It doesn't appear to have aphids.}
		view 300
		loop 8
		cel 2
		priority 11
		signal $4010
	)
)

(instance plant2 of PicView
	(properties
		x 303
		y 161
		noun '/plant'
		description {another plant}
		lookStr {It doesn't appear to have boreworms.}
		view 300
		loop 8
		cel 3
		priority 11
		signal $4010
	)
)

(instance tashtari of MsgMerchant
	(properties
		x 60
		y 120
		description {Tashtari, the lamp merchant}
		lookStr {It is Tashtari, the lamp merchant.}
		priority 6
		signal $0010
		myName '//tashtari,(merchant[<lamp]),catperson'
		title {Tashtari:}
		isSeated 0
		clothesColor 5
		firstMsgNum 60
	)
	
	(method (init)
		(super init:)
		(proc1_31 lampTable hangingLamps)
		(DrawFeature lampStand)
		(self addWares: lamp)
		(= lastMsgSaid gLastMsgSaid_3)
	)
	
	(method (dispose)
		(= gLastMsgSaid_3 lastMsgSaid)
		(super dispose:)
	)
	
	(method (showSelf)
		(Say self 310 18)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((Said 'ask//plant,bouquet') (Say self 310 2))
			((Said 'ask//lasham') (Say self 310 3))
			((Said 'ask//basket,reed') (Say self 310 19))
			((Said 'ask//saba') (Say self 310 5))
			((Said 'ask//keapon,keapon,(shop<magic)') (Say self 310 6))
			((Said 'tell,talk,chat//elemental<fire')
				(if (ego has: 33)
					(pEvent claimed: 0)
					(super handleEvent: pEvent)
				else
					(AddToScore 624 7)
					(ego get: 33)
					(Say self 310 20)
				)
			)
			(else (super handleEvent: pEvent))
		)
		(pEvent claimed?)
	)
	
	(method (sell)
		(if (== curWare lamp) (AddToScore 624 7))
		(super sell: &rest)
	)
	
	(method (saySoldBegin)
		(Say tashtari self 310 17)
	)
	
	(method (sayBargainSuccess)
		(Say self self 350 58)
	)
	
	(method (sayBargainFailure)
		(Say self self 350 59)
	)
	
	(method (atIndividualSpec param1)
		(return [local4 param1])
	)
	
	(method (sayMsg param1)
		(if (not (if (== param1 61) (ego has: 33)))
			(super sayMsg: param1)
		)
	)
)

(instance lamp of Class_84_1
	(properties
		invItem 33
		noun '//lamp>'
		price 1500
		lowPrice 1000
		canBuyMultiple 0
	)
)

(instance lampStand of PicView
	(properties
		x 52
		y 131
		noun '/stand[<lamp]'
		description {the lamp merchant's stand}
		lookStr {It is the stand of Tashtari, the lamp merchant.}
		view 310
		loop 3
		priority 7
		signal $4010
	)
)

(instance magicSign of PicView
	(properties
		x 251
		y 54
		noun '/eye,sign'
		description {the EYE}
		lookStr {The sign above the door is keeping an eye out for you.__Perhaps the door leads to the optometrist's office.}
		view 301
		cel 2
		priority 0
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance magicEye of Prop
	(properties
		x 250
		y 44
		noun '/eye,sign'
		description {the EYE}
		lookStr {QUIT STARING AT ME!!}
		view 301
		loop 1
		priority 6
		signal $4011
	)
	
	(method (doit &tmp temp0 theCel)
		(if modelessDialog (return))
		(if
			(!=
				cel
				(= theCel
					(cond 
						((< (ego y?) 110) 3)
						(
						(< (= temp0 (GetAngle (ego x?) (ego y?) x y)) 20) 1)
						((< temp0 55) 2)
						((< temp0 320) 3)
						(else 0)
					)
				)
			)
			(= cel theCel)
			(self forceUpd:)
		)
		(super doit:)
	)
)

(instance northSign of PicView
	(properties
		x 160
		y 46
		noun '/sign[<alley,bearing,street]'
		description {the alley sign}
		view 310
		loop 2
		priority 6
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance leftWindow of PicView
	(properties
		x 69
		y 51
		noun '/window'
		description {It's a window}
		lookStr {The window has a lovely view of the Plaza.}
		view 300
		loop 1
		cel 2
		priority 6
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance lampTable of Feature
	(properties
		x 33
		y 123
		noun '/table[<little,lamp]'
		nsTop 116
		nsLeft 25
		nsBottom 131
		nsRight 42
		description {a small table with lamps on it}
		lookStr {The small table is used for display.}
	)
)

(instance hangingLamps of Feature
	(properties
		x 33
		y 90
		noun '/lamp[<hang]'
		nsTop 85
		nsLeft 25
		nsBottom 95
		nsRight 41
		description {hanging lamps}
		lookStr {Some of the lamps are intended to be hung.}
	)
)

(instance flowerBox of Feature
	(properties
		x 74
		y 40
		noun '/plant,box[<bouquet,plant]'
		nsTop 34
		nsLeft 62
		nsBottom 46
		nsRight 86
		description {a lovely planter box}
		lookStr {The planter box in the window is in full flower.}
	)
)

(instance flowers of Feature
	(properties
		x 278
		y 116
		noun '/pan,bouquet[<pan]'
		nsTop 105
		nsLeft 263
		nsBottom 128
		nsRight 294
		description {flowers in pots}
		lookStr {The flowering plants are truly beautiful to behold in this desert land.}
	)
)

(instance baskets of Feature
	(properties
		x 95
		y 95
		noun '/basket'
		nsTop 84
		nsLeft 79
		nsBottom 106
		nsRight 111
		description {the basket merchant's wares}
		lookStr {The snake charmer's snake wishes his basket was as fine as these.}
	)
)

(instance poly1 of Polygon
	(properties
		type $0002
	)
)

(instance poly2 of Polygon
	(properties
		type $0002
	)
)
