;;; Sierra Script 1.0 - (do not remove this comment)
(script# 30)
(include sci.sh)
(use Main)
(use Bar)
(use TargActor)
(use Motion)
(use System)


(class Combatant of TargActor
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		strength 0
		intell 0
		agil 0
		vit 0
		luck 0
		weap 0
		parry 0
		dodge 0
		magic 0
		stamina 0
		mana 0
		armorValue 0
		armorEnc 0
		shieldValue 0
		weapValue 0
		canFight 0
		action 0
		nextMove -1
		attDirection 0
		opponent 0
		barX 25
		barY 8
		barTitle 0
		barHealth 0
		barStamina 0
		barMana 0
		barMessage 0
		type $0035
		mode 55
		combatScript 0
		hurtScript 0
		deathScript 0
	)
	
	(method (init)
		(= canFight 1)
		(super init: &rest)
	)
	
	(method (dispose)
		(if (== mode 55) (self endCombat:))
		(= opponent 0)
		(super dispose:)
	)
	
	(method (hurtMe param1 param2)
		(= calmTimer 0)
		(if (< (= health (- health param1)) 0) (= health 0))
		(if (> health (self calcHealth:))
			(= health (self calcHealth:))
		)
		(self setHealth: health)
		(cond 
			((== health 0) (self die:))
			(
			(and (or (< argc 2) (!= param2 self)) hurtScript) (self setScript: (hurtScript new:)))
		)
		(return 1)
	)
	
	(method (attackLevel param1 &tmp temp0)
		(= temp0
			(/
				(+ (* weap 8) (* agil 4) strength strength intell luck)
				16
			)
		)
		(if (<= stamina 50)
			(= temp0 (- temp0 10))
			(if (<= stamina 25) (= temp0 (- temp0 20)))
		)
		(= temp0 (+ temp0 param1))
	)
	
	(method (defenseLevel param1 &tmp temp0 temp1 temp2)
		(= temp0
			(- (/ (+ (* agil 5) intell intell luck) 8) armorEnc)
		)
		(if (<= stamina 50)
			(= temp0 (- temp0 5))
			(if (<= stamina 25) (= temp0 (- temp0 10)))
		)
		(= temp0 (+ temp0 param1))
		(= temp1 (= temp2 0))
		(if parry (= temp1 (+ parry shieldValue (/ agil 10))))
		(if dodge (= temp2 (+ dodge (/ agil 5))))
		(switch action
			(2 (= temp0 (+ temp0 temp1)))
			(3 (= temp0 (+ temp0 temp2)))
			(4 (= temp0 (+ temp0 temp2)))
		)
		(return temp0)
	)
	
	(method (tryAttack param1 param2 &tmp temp0)
		(cond 
			(
				(>
					(= temp0
						(+
							(- (self attackLevel: param2) (param1 defenseLevel: 0))
							50
						)
					)
					80
				)
				(= temp0 80)
			)
			((< temp0 20) (= temp0 20))
		)
		(return
			(if (>= temp0 (Random 1 100))
				(return 1)
			else
				(return 0)
			)
		)
	)
	
	(method (doDamage param1 param2 param3 &tmp temp0)
		(= temp0
			(+
				(- (+ weapValue (/ strength 10)) (param1 armorValue?))
				(Random 1 10)
			)
		)
		(if (>= argc 2) (= temp0 (+ temp0 param2)))
		(cond 
			((< temp0 0) (= temp0 0))
			((or (< argc 3) param3) (param1 hurtMe: temp0 self))
			(else (param1 getTired: (+ temp0 temp0) self))
		)
		(return temp0)
	)
	
	(method (getTired param1 param2 &tmp temp0)
		(= temp0 (if (< argc 2) self else param2))
		(cond 
			((< (= stamina (- stamina param1)) 0) (self hurtMe: (/ (- 0 stamina) 2) temp0) (= stamina 0))
			((and (!= temp0 self) hurtScript) (self setScript: (hurtScript new:)))
		)
		(self setStamina: stamina)
	)
	
	(method (die)
		(self endCombat: setScript: deathScript)
	)
	
	(method (calcHealth &tmp temp0)
		(return (+ (= temp0 (/ (+ strength vit vit) 3)) temp0))
	)
	
	(method (calcStamina)
		(return (* (+ agil vit) 2))
	)
	
	(method (calcMana)
		(return
			(if magic
				(return (/ (+ intell magic magic) 3))
			else
				(return 0)
			)
		)
	)
	
	(method (setHealth theHealth)
		(= health theHealth)
		(if barHealth (barHealth value: theHealth draw:))
	)
	
	(method (setStamina theStamina)
		(= stamina theStamina)
		(if barStamina (barStamina value: theStamina draw:))
	)
	
	(method (setMana theMana)
		(= mana theMana)
		(if barMana (barMana value: theMana draw:))
	)
	
	(method (drawStatus)
		(if (not barMessage) (return))
		(= barTitle
			(Display
				barMessage
				dsWIDTH
				80
				dsCOORD
				(- barX 12)
				barY
				dsALIGN
				0
				dsFONT
				300
				dsCOLOR
				hpFontColor
				dsSAVEPIXELS
			)
		)
		((= barHealth (Bar new:))
			x: barX
			y: (+ barY 20)
			cel: 0
			priority: 10
			max: (self calcHealth:)
			value: health
			init:
		)
	)
	
	(method (initCombat)
		(= illegalBits (= attDirection (= action 0)))
		(self ignoreActors: drawStatus:)
		(if (not hurtScript) (= hurtScript dftHurt))
		(self init: &rest)
		(if combatScript (self setScript: combatScript))
	)
	
	(method (endCombat)
		(if opponent (opponent canFight: 0))
		(self setScript: 0 setCycle: 0 setMotion: 0)
		(= canFight 0)
		(= action 5)
		(if barMana (barMana dispose:) (= barMana 0))
		(if barStamina (barStamina dispose:) (= barStamina 0))
		(if barTitle
			(barHealth dispose:)
			(Display 30 0 108 barTitle)
			(= barHealth (= barStamina (= barTitle 0)))
		)
	)
)

(instance dftHurt of Script
	(properties)
	
	(method (changeState newState &tmp clientCombatScript)
		(switch (= state newState)
			(0
				(client
					canFight: 0
					action: 7
					setCycle: 0
					setLoop: 1
					setCel: 0
				)
				(= cycles 2)
			)
			(1
				(client setCel: 1)
				(= cycles
					(switch gSeconds
						(0 2)
						(1 4)
						(2 6)
						(3 8)
					))
			)
			(2
				(if (<= (NumCels client) 2)
					(self cue:)
				else
					(client setCycle: End self)
				)
			)
			(3
				(client canFight: 1 action: 0 setLoop: 0)
				(if (= clientCombatScript (client combatScript?))
					(client setScript: clientCombatScript)
				else
					(self dispose:)
				)
			)
		)
	)
)
