;;; Sierra Script 1.0 - (do not remove this comment)
(script# 75)
(include sci.sh)
(use Main)
(use n001)
(use Intrface)
(use Motion)
(use File)
(use System)


(class Dance of Script
	(properties
		client 0
		state $ffff
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
		stepType 0
		repCnt 0
		pauseCnt 0
		baseIndex 0
		fp 0
	)
	
	(method (dispose)
		(if (and (= repCnt (= pauseCnt 0)) fp)
			(fp close: dispose:)
		)
		(super dispose:)
	)
	
	(method (changeState newState &tmp [temp0 50])
		(= state newState)
		(= baseIndex (* state 4))
		(= stepType (self at: baseIndex))
		(if (OneOf stepType 2 3 4)
			(= repCnt (self at: (+ baseIndex 2)))
			(if (> repCnt 0) (-- repCnt))
		)
		(if (OneOf stepType 1 2 3)
			(= pauseCnt (self at: (+ baseIndex 3)))
		)
		(if (OneOf stepType 1 2 3 4)
			(client setLoop: (self at: (+ baseIndex 1)))
		)
		(self setDir: 0)
		(if 0
			(fp
				writeString:
					(Format
						@temp0
						75
						0
						state
						(switch stepType
							(0 {DanceView})
							(1 {DanceCel})
							(2 {DanceEndLoop})
							(3 {DanceBegLoop})
							(4 {DanceMove})
							(5 {DanceRelPosn})
							(6 {DancePosn})
							(7 {DanceSpecial})
							(8 {DanceEnd})
						)
					)
			)
		)
		(self doState:)
	)
	
	(method (cue)
		(cond 
			(repCnt (-- repCnt) (self doState:))
			(pauseCnt (= cycles pauseCnt) (= pauseCnt 0))
			(else (super cue: &rest))
		)
	)
	
	(method (at)
		(Printf 75 1 name)
	)
	
	(method (doState &tmp temp0)
		(switch stepType
			(0
				(client
					view: (self at: (+ baseIndex 1))
					setLoop: (self at: (+ baseIndex 2))
					cel: (self at: (+ baseIndex 3))
				)
				(self cue:)
			)
			(1
				(client cel: (self at: (+ baseIndex 2)))
			)
			(2 (self endLoop:))
			(3 (self begLoop:))
			(4
				(if
				(OneOf (= temp0 (self at: (+ baseIndex 3))) 5 3)
					(self endLoop:)
				else
					(self begLoop:)
				)
				(self setDir: temp0)
			)
			(6
				(client
					posn: (self at: (+ baseIndex 1)) (self at: (+ baseIndex 2))
				)
				(self cue:)
			)
			(5
				(client
					x: (+ (client x?) (self at: (+ baseIndex 1)))
					y: (+ (client y?) (self at: (+ baseIndex 2)))
				)
				(self cue:)
			)
			(7
				(self doSpecial: (self at: (+ baseIndex 1)))
			)
			(8 (self dispose:))
		)
	)
	
	(method (doSpecial)
		(Printf 75 2 name)
	)
	
	(method (begLoop)
		(client cel: (client lastCel:) setCycle: Beg self)
	)
	
	(method (endLoop)
		(client cel: 0 setCycle: End self)
	)
	
	(method (setDir param1)
		(client setMotion: param1)
	)
)

(class DQSnd of Dance
	(properties
		client 0
		state $ffff
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
		stepType 0
		repCnt 0
		pauseCnt 0
		baseIndex 0
		fp 0
		cycleDir 0
		theMusic 0
		moveDir 0
		saveSpeed 0
		disposeUs 0
		prevTime 0
	)
	
	(method (init theClient theTheMusic)
		(= saveSpeed gSaveSpeed)
		(= gSaveSpeed 0)
		(if 0
			(= prevTime (GetTime))
			(= fp (Class_993_0 new:))
			(fp name: {dqsnd.dbg} open: 2)
		)
		((= client theClient) script: self)
		((= theMusic theTheMusic) playBed: self)
		(self changeState: start)
	)
	
	(method (doit)
		(if disposeUs
			(LockEgo)
			(= disposeUs 0)
			(self dispose:)
		)
		(super doit:)
	)
	
	(method (dispose)
		(= gSaveSpeed saveSpeed)
		(if theMusic (theMusic dispose:) (= theMusic 0))
		(= disposeUs 0)
		(super dispose:)
	)
	
	(method (changeState newState)
		(= cycleDir 0)
		(super changeState: newState)
		(= pauseCnt 0)
	)
	
	(method (cue &tmp thePrevTime temp1 [temp2 50])
		(if 0
			(Display
				(Format @temp2 75 3 (theMusic prevSignal?))
				dsCOORD
				0
				10
				dsCOLOR
				15
				dsBACKGROUND
				0
			)
		)
		(if cycleDir
			(cond 
				((== cycleDir 1)
					(if (== (client cel?) (client lastCel:))
						(= cycleDir 0)
					else
						(client cel: (+ (client cel?) 1))
					)
				)
				((not (client cel?)) (= cycleDir 0))
				(else (client cel: (- (client cel?) 1)))
			)
			(if (not cycleDir)
				(self cue:)
			else
				(switch moveDir
					(1
						(client y: (- (client y?) 1))
					)
					(5
						(client y: (+ (client y?) 1))
					)
					(3
						(client x: (+ (client x?) 1))
					)
					(7
						(client x: (- (client x?) 1))
					)
				)
			)
		else
			(super cue: &rest)
		)
		(if 0
			(if
			(> (= temp1 (- (= thePrevTime (GetTime)) prevTime)) 1)
				(theMusic pause: 1)
				(fp
					writeString: (Format
						@temp2
						75
						4
						(- (theMusic prevSignal?) 128)
						temp1
					)
				)
				(fp
					writeString:
						(Format
							@temp2
							75
							5
							(client loop?)
							(client cel?)
							(client x?)
							(client y?)
						)
				)
				(theMusic pause: 0)
			)
			(= prevTime thePrevTime)
		)
	)
	
	(method (doState)
		(if (== stepType 8)
			(= disposeUs 1)
		else
			(super doState:)
		)
	)
	
	(method (begLoop)
		(client cel: (client lastCel:))
		(= cycleDir -1)
	)
	
	(method (endLoop)
		(client cel: 0)
		(= cycleDir 1)
	)
	
	(method (setDir theMoveDir)
		(= moveDir theMoveDir)
	)
)
