;;; Sierra Script 1.0 - (do not remove this comment)
(script# 88)
(include sci.sh)
(use Main)
(use TargActor)
(use PolyPath)
(use Motion)


(class Elemental of TargActor
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		following 0
		wandering 0
		igniter 25
		lastWander 0
		newX 0
		newY 0
		attackDist 15
		wanderList 0
	)
	
	(method (init)
		(super init: &rest)
		(self setCycle: Fwd cue:)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			(script)
			(
				(and
					(< (self distanceTo: ego) attackDist)
					(not (ego script?))
					(< (ego z?) 30)
				)
				(self setMotion: 0)
				(self attack:)
			)
			(following)
			((not (-- igniter)) (= igniter (Random 15 50)) (self ignite:))
			((not mover) (self wander:))
		)
	)
	
	(method (cue)
		(cond 
			(following (self follow:))
			(wandering (self wander:))
		)
	)
	
	(method (attack)
		(if (not (ego script?)) (ego hurtMe: 0 0))
	)
	
	(method (follow &tmp temp0 temp1 temp2)
		(= temp0 (* 5 (= temp2 (- x (ego x?)))))
		(if (< (= temp1 (Random 1 100)) temp0)
			(= newX (- x (Random 1 (+ 20 temp2))))
		else
			(= temp2 (Abs temp2))
			(= newX (+ x (Random 1 (+ 20 temp2))))
		)
		(cond 
			((ego script?))
			((< y 105) (= newX 160) (= newY 70))
			((> y (ego y?)) (= newY (- y 7)))
			(else (= newY (ego y?)))
		)
		(self setMotion: PolyPath newX newY self)
	)
	
	(method (wander &tmp theWandering)
		(= theWandering wandering)
		(while
			(or
				(== theWandering wandering)
				(== theWandering lastWander)
			)
			(= theWandering (Random 1 wanderList))
		)
		(= lastWander wandering)
		(= wandering theWandering)
	)
	
	(method (ignite)
		(return 0)
	)
)
