;;; Sierra Script 1.0 - (do not remove this comment)
(script# 81)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TryToMoveTo)
(use Plaza)
(use Elemental)
(use Intrface)
(use LoadMany)
(use Reverse)
(use Avoider)
(use Motion)
(use Actor)
(use System)

(public
	fountainWater 0
)

(local
	[local0 18] = [0 0 130 189 129 179 136 165 195 189 195 180 188 165 162 160 162 200]
	local18
	local19
)
(procedure (localproc_000c param1)
	(= local19 (* param1 2))
	(waterElemental
		newX: [local0 local19]
		newY: [local0 (+ local19 1)]
	)
)

(procedure (localproc_054a param1)
	(if (> param1 159)
		(= param1 (Max 230 param1))
	else
		(= param1 (Min 80 param1))
	)
	(return param1)
)

(class FountainPlaza of Plaza
	(properties
		script 0
		number 0
		timer 0
		keep 0
		initialized 0
		picture 300
		style $000d
		horizon 82
		controls 0
		north 0
		east 0
		south 0
		west 0
		curPic 0
		picAngle 0
		vanishingX 160
		vanishingY -30000
		obstacles 0
		inOut 0
		edgeHit 0
		entranceScript 0
		topFromX 160
		topFromY 80
		topExit 1
		topToX 160
		topToY 100
		bottomFromX 160
		bottomFromY 250
		bottomExit 3
		bottomToX 160
		bottomToY 188
		rightFromX 330
		rightFromY 162
		rightExit 2
		rightToX 310
		rightToY 162
		leftFromX -10
		leftFromY 162
		leftExit 4
		leftToX 10
		leftToY 162
		saveIllegal 0
		saveSig 0
		whereTo 0
		merchants 0
		xIn 0
		yIn 0
		xOut 0
		yOut 0
	)
	
	(method (init &tmp temp0)
		(if (== prevRoomNum south)
			(= bottomToX
				(= bottomFromX (localproc_054a (- 319 (ego x?))))
			)
		else
			(self style: 7)
		)
		(super init:)
		(DrawFeature fountainSpout fountainBasin)
		(if (Btst 16) (fountainWater init:))
		(if (== elementalsStatus 7)
			(waterElemental cycleSpeed: 1 setCycle: Fwd init:)
		)
	)
	
	(method (setDoorPos param1)
		(if (!= param1 3)
			(super setDoorPos: param1)
		else
			(= xOut (localproc_054a (- 319 (ego x?))))
			(= xIn xOut)
			(= yOut bottomFromY)
			(= yIn (- bottomToY 10))
		)
	)
)

(instance fountainBasin of PicView
	(properties
		x 161
		y 197
		noun '/basin,fount'
		description {the city fountain}
		view 310
		priority 14
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if (Btst 16) (HighPrint 81 0) else (HighPrint 81 1))
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance fountainSpout of PicView
	(properties
		x 160
		y 197
		z 9
		noun '/fount'
		description {the city fountain}
		view 310
		cel 1
		signal $4000
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 1)
			(if (< curRoomNum 380)
				(HighPrint 81 0)
			else
				(HighPrint 81 1)
			)
		else
			(super doVerb: theVerb &rest)
		)
	)
)

(instance fountainWater of Prop
	(properties
		x 160
		y 192
		noun '/water,splash'
		description {the splashing water}
		lookStr {The water splashes into the fountain in a most inviting way.}
		view 310
		loop 1
		signal $0200
	)
	
	(method (init)
		(super init: &rest)
		(if (!= (gCMusic number?) 310)
			(gCMusic number: 310 loop: -1 playBed:)
		)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
		(self setCycle: Fwd)
	)
	
	(method (dispose)
		(if (not (OneOf newRoomNum 310 315)) (gCMusic fade:))
		(super dispose: &rest)
	)
	
	(method (handleEvent pEvent &tmp [temp0 100])
		(cond 
			((Said 'drink')
				(if
					(or
						(ego inRect: 92 150 233 300)
						(ego inRect: 110 135 215 160)
					)
					(Bclr 3)
					(Bclr 137)
					(HighPrint 81 2)
				else
					(PrintNotCloseEnough)
				)
			)
			(
			(Said 'get,acquire,fill/water,waterbag,(skin<water)')
				(cond 
					((not (ego has: 37))
						(HighPrint 81 3)
						(if (Btst 3) (Bclr 3) (Bclr 137) (HighPrint 81 4))
					)
					(
						(not
							(if (ego inRect: 92 150 233 300)
							else
								(ego inRect: 110 135 215 160)
							)
						)
						(PrintNotCloseEnough)
					)
					((== currentWater (* [invNum 37] 10))
						(if (== [invNum 37] 1)
							(HighPrint 81 5)
						else
							(HighPrint 81 6)
						)
					)
					(else
						(Bclr 3)
						(Bclr 137)
						(= currentWater (* [invNum 37] 10))
						(HighPrint
							(Format @temp0 81 7 (if (> [invNum 37] 1) 115 else 0))
						)
					)
				)
			)
			(else (super handleEvent: pEvent))
		)
	)
)

(instance waterElemental of Elemental
	(properties
		x 160
		y 180
		noun '/elemental[<water]'
		description {the Water Elemental}
		lookStr {Watery tart!}
		view 346
		loop 1
		priority 14
		signal $4810
		wandering 1
		attackDist 35
		wanderList 8
	)
	
	(method (init)
		(super init: &rest)
		(LoadMany 128 47 342 346)
		(LoadMany 130 985)
		(self baseSetter: waterBase)
		(if
		(and (!= elementalsStatus 7) (== gTheGGNorth curRoom))
			(waterSkin
				x: (* (/ global291 100) 10)
				y: (* (mod global291 100) 10)
				init:
			)
		)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			(script)
			((ego script?))
			(
				(and
					(or
						(ego inRect: 92 150 233 300)
						(ego inRect: 110 135 215 160)
					)
					wandering
				)
				(self
					following: 0
					wandering: 0
					setMotion: TryToMoveTo (ego x?) (ego y?) 50
					setAvoider: Avoid
				)
			)
			(
				(not
					(if
						(or
							(ego inRect: 92 150 233 300)
							(ego inRect: 110 135 215 160)
						)
					else
						wandering
					)
				)
				(self wandering: 1 cue:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(Said
					'deposit,use,set,(put<down)/waterbag,water,(skin<water)'
				)
				(if (== elementalsStatus 7)
					(if (ego has: 37)
						(ego setScript: doSkin 0 1)
					else
						(PrintDontHaveIt)
					)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'use/bellows,(elemental<air)')
				(if (ego has: 25)
					(ego setScript: useBellows)
				else
					(PrintDontHaveIt)
				)
			)
			((Said 'talk,chat/elemental,water') (HighPrint 81 8))
			(
				(Said
					'drink,get,acquire,fill/water,waterbag,(skin<water)'
				)
				(HighPrint 81 9)
			)
		)
	)
	
	(method (attack)
		(ego hurtScript: getDrained)
		(super attack:)
	)
	
	(method (wander)
		(super wander:)
		(localproc_000c wandering)
		(self setMotion: TryToMoveTo newX newY 250 self)
	)
)

(instance waterBase of Code
	(properties)
	
	(method (doit param1 &tmp temp0)
		(= temp0 (param1 x?))
		(BaseSetter param1)
		(param1 brLeft: (- temp0 9) brRight: (+ temp0 9))
	)
)

(instance windBag of Prop
	(properties
		noun '/wind,air'
		description {the wind bag}
		lookStr {It's a lot of hot air.}
		view 342
	)
)

(instance getDrained of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (> (ego x?) 160)
					(= register 1)
					(ego setHeading: 225 self)
				else
					(= register 0)
					(ego setHeading: 135 self)
				)
			)
			(1
				(if register
					(ego
						setLoop: (ego loop?)
						setCycle: Rev
						setMotion: MoveTo (+ (ego x?) 10) (- (ego y?) 10)
					)
					(waterElemental
						setMotion: TryToMoveTo (- (ego x?) 18) (+ (ego y?) 11) 25 self
					)
				else
					(ego
						setLoop: (ego loop?)
						setCycle: Rev
						setMotion: MoveTo (- (ego x?) 10) (- (ego y?) 10)
					)
					(waterElemental
						setMotion: TryToMoveTo (+ (ego x?) 18) (+ (ego y?) 11) 25 self
					)
				)
			)
			(2
				(waterElemental hide:)
				(ego
					view: 346
					setPri: 15
					setLoop: (+ register 6)
					setCel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(3
				(ego
					setLoop: (+ register 8)
					setCel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(4
				(ego
					setLoop: (+ register 10)
					setCel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(5
				(Die 0 81 10 80 {You feel drained...} 82 346 1 0)
			)
		)
	)
)

(instance doSkin of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo 165 145 self)
				(if (== register 1)
					(if (> (waterElemental x?) 160)
						(waterElemental wandering: 0 setMotion: MoveTo 185 200)
					else
						(waterElemental wandering: 0 setMotion: MoveTo 135 200)
					)
				)
			)
			(1 (ego setHeading: 270 self))
			(2
				(ego view: 47 setLoop: 1 setCel: 0 setCycle: End self)
			)
			(3
				(if (== register 1)
					(waterSkin init:)
					(= local18 1)
					(= gTheGGNorth curRoom)
					(= temp0 (+ (waterSkin x?) 5))
					(= temp1 (+ (waterSkin y?) 5))
					(= global291 (+ (* (/ temp0 10) 100) (/ temp1 10)))
					(ego use: 37 1)
					(if (> currentWater (* [invNum 37] 10))
						(= currentWater (* [invNum 37] 10))
					)
				else
					(waterSkin dispose:)
					(= gTheGGNorth 0)
					(= local18 0)
					(ego get: 43)
				)
				(ego setCycle: Beg self)
			)
			(4
				(if (== register 1)
					(ChangeEgoWalk 0 0)
					(ego
						setLoop: -1
						setMotion: MoveTo 180 (- (ego y?) 15) self
					)
				else
					(if (== elementalsStatus 8)
						(Print 81 11)
					else
						(HighPrint 81 12)
					)
					(self changeState: 6)
				)
			)
			(5
				(FaceObject ego waterSkin 0 self)
			)
			(6
				(if (== register 1) (waterElemental wandering: 1 cue:))
				(proc1_19)
				(self dispose:)
			)
		)
	)
)

(instance useBellows of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(cond 
					((ego inRect: 160 0 300 150) (ego setMotion: MoveTo 240 175 self))
					((ego inRect: 0 0 160 150) (ego setMotion: MoveTo 80 175 self))
					(else (self cue:))
				)
			)
			(1
				(= register (ego x?))
				(cond 
					(
						(or
							(ego inRect: 185 170 225 200)
							(ego inRect: 95 170 135 200)
						)
						(self cue:)
					)
					((> register 160) (ego setMotion: MoveTo 220 190 self))
					(else (ego setMotion: MoveTo 100 190 self))
				)
			)
			(2
				(if (> register 160)
					(ego setHeading: 315 self)
				else
					(ego setHeading: 45 self)
				)
			)
			(3
				(ego
					view: 342
					setLoop: (if (> register 160) 6 else 5)
					cycleSpeed: 1
					setCycle: Fwd
				)
				(if (> register 160)
					(= temp0 (- (ego x?) 19))
					(= temp1 (- (ego y?) 45))
				else
					(= temp0 (+ (ego x?) 19))
					(= temp1 (- (ego y?) 45))
				)
				(windBag
					posn: temp0 temp1
					setLoop: (if (> register 160) 8 else 7)
					setCel: 0
					setPri: 15
					setCycle: End self
					init:
				)
				(waterElemental setScript: jumpIntoWaterskin)
			)
			(4
				(ego loop: 7)
				(proc1_19)
				(windBag dispose:)
				(= cycles 1)
			)
			(5
				(if (> register 160)
					(ego setMotion: MoveTo 240 175 self)
				else
					(ego setMotion: MoveTo 80 175 self)
				)
			)
			(6
				(FaceObject ego waterElemental)
				(self dispose:)
			)
		)
	)
)

(instance jumpIntoWaterskin of Script
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(= temp0 (+ (waterSkin x?) 2))
				(= temp1 (- (waterSkin y?) 6))
				(waterElemental
					following: 0
					wandering: 0
					illegalBits: 0
					setMotion: MoveTo temp0 temp1 self
				)
			)
			(1
				(if local18
					(waterElemental
						setLoop: 2
						setCel: 0
						cycleSpeed: 1
						setCycle: End self
					)
				else
					(self changeState: 4)
				)
			)
			(2
				(waterSkin setCel: 1)
				(waterElemental
					setLoop: 4
					setCel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(3
				(AddToScore 623 20)
				(SkillUsed 14 100)
				(waterSkin setCel: 2)
				(++ elementalsStatus)
				(waterElemental dispose:)
			)
			(4
				(waterElemental setMotion: MoveTo 140 160 self)
			)
			(5
				(HighPrint 81 13)
				(waterElemental wandering: 1 cue:)
				(= cycles 1)
			)
			(6 (self dispose:))
		)
	)
)

(instance waterSkin of Prop
	(properties
		x 156
		y 142
		noun '/waterbag,(skin<water)'
		description {the waterskin}
		lookStr {It's a waterskin.}
		view 346
		loop 12
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '(lockpick<up)/waterbag,(skin<water)') (self doVerb: 7))
		)
	)
	
	(method (doVerb theVerb)
		(if (== theVerb 7) (ego setScript: doSkin 0 0))
	)
)
