;;; Sierra Script 1.0 - (do not remove this comment)
(script# 84)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use n003)
(use Talker)
(use PlazaTalker)
(use Intrface)
(use System)


(local
	[local0 300]
	[local300 66] = [300 '//bouquet,lisha' {Lisha} {lovely flowers} {Gate} 310 '//plant,lasham' {Lasham} {hardy plants} {Fountain} 310 '//basket,reed,saba' {Saba} {sturdy baskets} {Fountain} 310 '//brass,lamp' {Tashtari} {brass and lamps} {Fountain} 310 '//keapon,keapon,(shop<magic)' {Keapon Laffin} {magical items} {Fountain} 315 '//food,sloree,nephew' {Sloree and Scoree} {delicious food} {Fountain} 315 '//pan,clay,toshur' {Toshur} {fine pottery} {Fountain} 315 '//attar,attar,drug,pill,potion,apothecary' {Harik Attar} {potions and pills} {Fountain} 330 '//cloth,clothes,veil,kiram' {Kiram} {sturdy clothing} {Fighters} 330 '//issur,weapon,blade,dagger,shield' {Issur} {weapons} {Fighters} 330 '//leather,leatherwork,waterbag,mirak' {Mirak} {leather goods} {Fighters} 335 '//carpet,tiram' {Tiram} {carpets} {Palace} 335 '//gem,gem,necklace,bracelet,gold,silver,sashanan' {Sashanan} {fine jewelry} {Palace}]
)
(class Merchant of PlazaTalker
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		caller 0
		tWindow 0
		tLoop 0
		talkSpeed 2
		said 0
		myName 0
		title 0
		color 0
		back 15
		msgFile 0
		s1 0
		s2 0
		s3 0
		s4 0
		s5 0
		s6 0
		s7 0
		s8 0
		tCount 0
		oldLoop 0
		oldCel 0
		oldSpeed 0
		oldCycler 0
		state $0000
		seconds 0
		lastSeconds 0
		endCycles 0
		cycles 0
		wares 0
		curWare 0
		cueMethod 0
	)
	
	(method (init)
		(super init:)
		(Load rsTEXT 11)
		(self ignoreActors: 1)
		((= wares (Collect new:)) add:)
		((curRoom merchants?) add: self)
	)
	
	(method (dispose)
		(wares release: dispose:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((or (Said 'ask/cost') (Said 'ask//cost')) (self givePriceList:))
			((Said 'buy,bargain>')
				(cond 
					((not (self egoCloseEnough:)) (self sayNotCloseEnough:))
					((self dontHave: pEvent))
					((not (self egoCanBuy:)) (self sayYouAlreadyHave:))
					((Said 'buy') (curWare curPrice: (curWare price?)) (self buy:))
					(else (self bargain:))
				)
				(pEvent claimed: 1)
			)
			((Said 'grab') (HighPrint 84 2))
			((Said 'sell') (HighPrint 84 3))
			((Said 'tell') (Say self 84 4))
			((Said 'thank') (Say self 84 5))
			((Said 'hello,greet') (Say self 84 6))
			((self askAboutOthers: pEvent))
			(else (super handleEvent: pEvent))
		)
		(pEvent claimed?)
	)
	
	(method (cue &tmp theCueMethod)
		(cond 
			(
			(or (self script?) (== state -1) (> tCount 0)) (super cue:))
			(cueMethod
				(= theCueMethod cueMethod)
				(= cueMethod 0)
				(self theCueMethod?)
			)
			(suckBlueFrog (Printf 84 16 name))
		)
	)
	
	(method (addWares param1 &tmp temp0)
		(= temp0 0)
		(while (< temp0 argc)
			([param1 temp0] init:)
			(wares add: [param1 temp0])
			(++ temp0)
		)
	)
	
	(method (dontHave param1)
		(if
			(or
				(and (Said '[/!*]>') (Said '/[/!*]'))
				(and (Said '/[/!*]>') (Said (+ myName 1)))
				(and (Said '[/!*]>') (Said myName))
			)
			(Say self 84 8)
			(param1 claimed: 1)
			(return 1)
		)
		(return
			(if
			(or (not (= curWare (self has:))) (== curWare -1))
				(if (not curWare) (self sayDoesntHave:))
				(return 1)
			else
				(return 0)
			)
		)
	)
	
	(method (has &tmp temp0 waresFirst temp2)
		(= waresFirst (wares first:))
		(while waresFirst
			(if
			(= temp0 ((= temp2 (NodeValue waresFirst)) saidMe:))
				(if (== temp0 -1) (return -1) else (return temp2))
			)
			(= waresFirst (wares next: waresFirst))
		)
		(return 0)
	)
	
	(method (buy &tmp temp0)
		(switch (= temp0 (proc3_1 (curWare curPrice?)))
			(2 (self sell:))
			(3 (self sell:))
			(0 (self sayNotEnoughMoney:))
			(1
				(self sayMoneyNeedsChanging:)
			)
			(suckBlueFrog
				(Printf 84 9 temp0)
			)
		)
	)
	
	(method (bargain)
		(if (TestSkill 13 (curWare bargainSkill?))
			(curWare curPrice: (curWare lowPrice?))
			(= cueMethod 642)
			(self sayBargainSuccess:)
		else
			(curWare curPrice: (curWare highPrice?))
			(= cueMethod 642)
			(self sayBargainFailure:)
		)
	)
	
	(method (sell)
		(proc3_2 (curWare curPrice?))
		(if (curWare invItem?) (ego get: (curWare invItem?)))
		(= cueMethod 654)
		(self saySoldBegin:)
	)
	
	(method (egoCloseEnough)
		(return (< (self distanceTo: ego) 50))
	)
	
	(method (egoCanBuy)
		(if (not (ego has: (curWare invItem?)))
		else
			(curWare canBuyMultiple?)
		)
	)
	
	(method (givePriceList &tmp waresFirst [temp1 100])
		(if (wares isEmpty:)
			(HighPrint 84 0)
		else
			(= local0 0)
			(= waresFirst (wares first:))
			(while waresFirst
				(Format
					(StrEnd @local0)
					84
					1
					((NodeValue waresFirst) priceStr: @temp1)
				)
				(= waresFirst (wares next: waresFirst))
			)
			(Say self @local0)
		)
	)
	
	(method (askAboutOthers param1 &tmp temp0)
		(if
		(or (not (Said 'ask>')) (not (self saidMe: param1)))
			(return 0)
		)
		(= temp0 0)
		(while [local300 temp0]
			(if
				(and
					(!= curRoomNum [local300 temp0])
					(Said [local300 (+ temp0 1)])
				)
				(Say
					self
					(Format
						@local0
						84
						7
						[local300 (+ temp0 2)]
						[local300 (+ temp0 3)]
						[local300 (+ temp0 4)]
					)
				)
				(return 1)
			)
			(= temp0 (+ temp0 5))
		)
		(return 0)
	)
	
	(method (sayYouAlreadyHave &tmp [temp0 20] [temp20 50])
		(HighPrint
			(Format @temp20 84 10 (curWare showStr: @temp0))
		)
	)
	
	(method (sayDoesntHave)
		(Say self 84 12)
	)
	
	(method (sayNotEnoughMoney)
		(HighPrint 84 13)
	)
	
	(method (sayMoneyNeedsChanging)
		(Say self 84 14)
	)
	
	(method (saySoldBegin)
		(self cue:)
	)
	
	(method (saySoldEnd &tmp [temp0 50] [temp50 25])
		(HighPrint
			(Format @temp0 84 11 (curWare showStr: @temp50))
		)
	)
	
	(method (sayNotCloseEnough)
		(Say self 84 15)
	)
	
	(method (sayBargainSuccess)
	)
	
	(method (sayBargainFailure)
	)
)

(class Class_84_1
	(properties
		invItem 0
		noun 0
		price 0
		lowPrice 0
		highPrice 0
		bargainSkill 40
		canBuyMultiple 1
		curPrice 0
	)
	
	(method (init)
		(if (not highPrice) (= highPrice price))
	)
	
	(method (showStr param1 &tmp [temp0 50])
		(if invItem
			(proc2_22 @temp0 11 (* invItem 2))
			(Format param1 @temp0 {})
		else
			(StrCpy param1 name)
		)
		(return param1)
	)
	
	(method (priceStr param1 &tmp [temp0 50])
		(Format
			param1
			84
			17
			(self showStr: @temp0)
			(self price?)
		)
	)
	
	(method (saidMe)
		(if (Said noun) else (Said (+ noun 1)))
	)
)
