;;; Sierra Script 1.0 - (do not remove this comment)
(script# 31)
(include sci.sh)
(use Main)
(use n001)
(use HandsOffScript)
(use Combatant)
(use Chase)
(use Avoider)
(use Music)
(use Motion)
(use System)

(public
	battleSound 0
)

(procedure (localproc_0616 param1 &tmp temp0)
	(return
		(+
			(= temp0 (- (= temp0 (param1 view?)) (mod temp0 5)))
			1
		)
	)
)

(class Monster of Combatant
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		strength 0
		intell 0
		agil 0
		vit 0
		luck 0
		weap 0
		parry 0
		dodge 0
		magic 0
		stamina 0
		mana 0
		armorValue 0
		armorEnc 0
		shieldValue 0
		weapValue 0
		canFight 0
		action 0
		nextMove -1
		attDirection 0
		opponent 0
		barX 240
		barY 8
		barTitle 0
		barHealth 0
		barStamina 0
		barMana 0
		barMessage 0
		type $0035
		mode 0
		combatScript 0
		hurtScript 0
		deathScript 0
		ateEgo 0
		chaseDelay 0
		attackRange 60
		battleMusic 50
		endMusic 51
		ambushScript 0
		chaseScript 0
	)
	
	(method (init)
		(if (not (= health gHealth))
			(= gHealth (= health (self calcHealth:)))
			(= stamina (self calcStamina:))
			(= mana (self calcMana:))
		)
		(super init: &rest)
		(if (not deathScript) (= deathScript dftDeath))
	)
	
	(method (doit)
		(cond 
			((<= health 0) (super doit:))
			(dazzleTimer (-- dazzleTimer) (= calmTimer 0))
			(calmTimer (-- calmTimer))
			(else (super doit:))
		)
	)
	
	(method (dispose)
		(= gHealth health)
		(if (sounds contains: battleSound)
			(battleSound stop: dispose:)
			(if (not (Btst 159))
				(gMiscMusic
					number: (if (<= health 0) endMusic else 23)
					priority: 6
					loop: 0
					play:
				)
			else
				(Bclr 159)
			)
		)
		(super dispose:)
	)
	
	(method (cue)
		(if (or (== mode 52) (== mode 53))
			(curRoom notify: 54)
		else
			(super cue: &rest)
		)
	)
	
	(method (calmMe)
		(if (== mode 55)
			(= calmTimer (+ calmTimer (/ [skills 24] 2)))
		else
			(= calmTimer (+ calmTimer [skills 24]))
		)
	)
	
	(method (dazzleMe)
		(if (== mode 55)
			(= dazzleTimer (+ dazzleTimer (/ [skills 22] 4)))
		else
			(= dazzleTimer (+ dazzleTimer (/ (* [skills 22] 2) 3)))
		)
	)
	
	(method (die)
		(= mode 58)
		(if opponent (opponent canFight: 0))
		(if
		(and (== curRoomNum 665) (!= monsterInRoom 655))
			(self setScript: dieInCombat)
		else
			(super die:)
		)
	)
	
	(method (setStamina param1)
		(super setStamina: param1)
		(if (<= stamina 0) (curRoom notify: 57))
	)
	
	(method (initCombat)
		(= mode 55)
		(= opponent (ScriptID 32 0))
		(if battleMusic
			(battleSound
				number: battleMusic
				loop: -1
				priority: 2
				playBed:
			)
		)
		(super initCombat: &rest)
	)
	
	(method (initAmbush)
		(= mode 52)
		(if (not ambushScript) (= ambushScript dftAmbush))
		(self init: &rest setScript: ambushScript)
	)
	
	(method (initChase param1)
		(= mode 53)
		(if (not chaseScript) (= chaseScript dftChase))
		(self init: &rest setScript: chaseScript 0 param1 self)
	)
	
	(method (searchMe)
		(HighPrint 31 0)
		(return 0)
	)
)

(instance battleSound of Sound
	(properties
		priority 5
		loop -1
	)
)

(instance dftAmbush of Script
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(client hide:)
				(if global161 (= cycles 10) else (self changeState: 2))
			)
			(1 (self changeState: 0))
			(2 (= cycles 1))
			(3
				(= temp0 (if (< (ego x?) 160) 350 else -30))
				(= temp1 165)
				(client
					view: (localproc_0616 client)
					posn: temp0 temp1
					setCycle: Walk
					show:
					setAvoider: Avoid
					setMotion: Chase ego (client attackRange?) client
				)
				(self dispose:)
			)
		)
	)
)

(instance dftChase of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					view: (localproc_0616 client)
					illegalBits: 0
					ignoreActors:
				)
				(if register
					(client
						posn: (if (> (ego x?) 160) -30 else 350) (ego y?)
						hide:
						setMotion: 0
					)
					(= cycles
						(* 6 (+ (client chaseDelay?) (/ register 40)))
					)
				else
					(= cycles 8)
				)
			)
			(1
				(client
					show:
					illegalBits: -32768
					ignoreActors: 0
					setCycle: Walk
				)
				(= cycles 1)
			)
			(2
				(client
					setCycle: Walk
					setAvoider: Avoid
					setMotion: Chase ego (client attackRange?) client
				)
				(self dispose:)
			)
		)
	)
)

(instance dftDeath of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					canFight: 0
					action: 0
					setLoop: 2
					setCel: 0
					cycleSpeed: 0
				)
				(= cycles 2)
			)
			(1 (client setCycle: End self))
			(2
				(self dispose:)
				(curRoom notify: 58)
			)
		)
	)
)

(instance dieInCombat of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (ego script?)
					(= cycles 1)
				else
					(= gHealth 0)
					(curRoom newRoom: 666)
				)
			)
			(1 (self changeState: 0))
		)
	)
)
