;;; Sierra Script 1.0 - (do not remove this comment)
(script# 90)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TargActor)
(use Motion)
(use System)


(class PlazaDoor of TargActor
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		hitX 0
		hitY 0
		calmTimer 0
		dazzleTimer 0
		health 0
		entranceTo 0
		exitDir 0
		openSnd 0
		closeSnd 0
		doorControl 16
		state $0000
		xOut 0
		yOut 0
		xIn 0
		yIn 0
		savePri 0
		barred 0
	)
	
	(method (init)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
		(if (== prevRoomNum entranceTo)
			(= state 2)
			(= cel (self lastCel:))
		else
			(= cel (= state 0))
		)
		(super init:)
		(self ignoreActors:)
		(if (== prevRoomNum entranceTo) (self enter:))
	)
	
	(method (doit)
		(super doit:)
		(if
			(and
				(& (ego onControl: 1) doorControl)
				(or (!= cel 0) (not (self isLocked:)))
				(not script)
				(not (ego script?))
				(not (curRoom script?))
			)
			(self setScript: (exitDoor new:))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((Said 'close,shut[/door]') (HighPrint 90 2))
			((Said 'open,open[/door]')
				(cond 
					((or (== state 3) (== state 2)) (HighPrint 90 3))
					((self isLocked:) (HighPrint 90 4))
					(else (HighPrint 90 5))
				)
			)
			(
				(or
					(Said 'lockpick[/lock]')
					(Said 'use/(lockpick[<lock]),lockpick')
					(Said 'unlock')
				)
				(cond 
					((not (self isLocked:)) (HighPrint 90 6))
					((not (CanPickLocks 1)))
					(
					(and (<= 0 currentTimeZone) (<= currentTimeZone 4)) (HighPrint 90 7))
					((not (self closeEnough:)) (HighPrint 90 8))
					(else (self setScript: pickLock))
				)
			)
			(else (super handleEvent: pEvent))
		)
	)
	
	(method (cue)
		(super cue:)
		(self stopUpd:)
		(= state (if (== state 1) 0 else 2))
	)
	
	(method (openMe)
		(return
			(if (TestSkill 19 75)
				(if (not barred)
					(self open:)
					(return 1)
				else
					(HighPrint 90 0)
				)
			else
				(HighPrint 90 1)
			)
		)
	)
	
	(method (open param1 &tmp temp0)
		(= global191 1)
		(= temp0 (if argc param1 else self))
		(if (and (!= state 3) (!= state 2))
			(= state 3)
			(self setCycle: End temp0)
			(if openSnd (openSnd doit:))
		else
			(temp0 cue:)
		)
	)
	
	(method (close param1 &tmp temp0)
		(= global191 0)
		(= temp0 (if argc param1 else self))
		(if (and (!= state 1) (!= state 0))
			(= state 1)
			(self setCycle: Beg temp0)
			(if closeSnd (closeSnd doit:))
		else
			(temp0 cue:)
		)
	)
	
	(method (enter)
		(self setScript: (enterDoor new:) curRoom)
	)
	
	(method (closeEnough)
		(return (< (ego distanceTo: self) 50))
	)
	
	(method (isLocked)
		(return isNightTime)
	)
)

(instance enterDoor of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(curRoom inOut: 1)
				(client savePri: (client priority?))
				(client setPri: 2)
				(ego
					setPri: 3
					illegalBits: 0
					posn: (client xOut?) (client yOut?)
					setMotion: MoveTo (client xIn?) (client yIn?) self
				)
			)
			(1
				(ego setPri: -1)
				(client setPri: (client savePri?) close:)
				(LockEgo)
				(self dispose:)
			)
		)
	)
)

(instance exitDoor of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (UnlockEgo) (client open:))
			(1
				(client setPri: 2)
				(ego
					setPri: 3
					illegalBits: 0
					setMotion: MoveTo (client xOut?) (client yOut?) self
				)
			)
			(2
				(= gTopExit (client exitDir?))
				(curRoom newRoom: (client entranceTo?))
				(LockEgo)
			)
		)
	)
)

(instance pickLock of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setMotion:
						MoveTo
						(+
							(client xIn?)
							(* (if (< (client x?) 160) -1 else 1) 10)
						)
						(+ (client yIn?) 3)
						self
				)
			)
			(1
				(ego
					view: 47
					loop: (+ 4 (< (client x?) 160))
					cel: 0
					setCycle: End self
				)
				(Bset 117)
			)
			(2 (= cycles 20))
			(3 (ego setCycle: Beg self))
			(4 (= cycles 10))
			(5
				(proc1_19)
				(ego loop: (if (< (client x?) 160) 7 else 6))
				(Bclr 117)
				(if (PickLock 100 1 1)
					(if (client barred?)
						(HighPrint 90 9)
						(self dispose:)
					else
						(client open: self)
					)
				else
					(self dispose:)
				)
			)
			(6 (= cycles 10))
			(7 (client setScript: exitDoor))
		)
	)
)
