;;; Sierra Script 1.0 - (do not remove this comment)
(script# 996)
(include sci.sh)
(use Main)
(use Intrface)
(use VerbMessager)
(use PolyPath)
(use RegPath)
(use Music)
(use Motion)
(use Menu)
(use Actor)
(use System)


(local
	[inputLine 23]
	local23
)
(instance uEvt of Event
	(properties)
)

(class User of Obj
	(properties
		alterEgo 0
		input 0
		controls 0
		echo 32
		prevDir 0
		prompt {Enter input}
		inputLineAddr 0
		x -1
		y -1
		blocks 1
		mapKeyToDir 1
		curEvent 0
		verbMessager 0
	)
	
	(method (init param1 param2)
		(= inputLineAddr (if argc param1 else @inputLine))
		(= local23 (if (== argc 2) param2 else 45))
		(= curEvent uEvt)
		(if (not verbMessager) (= verbMessager VerbMessager))
	)
	
	(method (doit)
		(if (== 0 isDemoGame)
			(curEvent
				type: 0
				message: 0
				modifiers: 0
				y: 0
				x: 0
				claimed: 0
			)
			(GetEvent 32767 curEvent)
			(self handleEvent: curEvent)
		)
	)
	
	(method (canControl theControls)
		(if argc (= controls theControls) (= prevDir 0))
		(return controls)
	)
	
	(method (getInput param1 &tmp temp0 temp1)
		(if (!= (param1 type?) 4) (= inputLine 0))
		(if (!= (param1 message?) echo)
			(Format @inputLine {%c} (param1 message?))
		)
		(= temp0 (Sound pause: blocks))
		(= temp1 (GetInput @inputLine local23 prompt 67 x y))
		(Sound pause: temp0)
		(return temp1)
	)
	
	(method (said param1 &tmp temp0)
		(param1
			message: (if verbMessager (verbMessager doit:) else 0)
		)
		(if useSortedFeatures
			(proc984_0)
		else
			(gSFeatures add: cast features)
		)
		(if MenuBar (gSFeatures addToFront: MenuBar))
		(if approachCode (gSFeatures addToFront: approachCode))
		(gSFeatures
			addToEnd: theGame
			handleEvent: param1
			release:
		)
		(if
		(and (== (param1 type?) 128) (not (param1 claimed?)))
			(theGame pragmaFail: @inputLine)
		)
	)
	
	(method (handleEvent pEvent &tmp pEventType temp1)
		(if (pEvent type?)
			(= lastEvent pEvent)
			(= pEventType (pEvent type?))
			(if mapKeyToDir (MapKeyToDir pEvent))
			(if MenuBar (MenuBar handleEvent: pEvent pEventType))
			(GlobalToLocal pEvent)
			(if (not (pEvent claimed?))
				(theGame handleEvent: pEvent pEventType)
			)
			(if
				(and
					controls
					(not (pEvent claimed?))
					(cast contains: alterEgo)
				)
				(alterEgo handleEvent: pEvent)
			)
			(if
				(and
					input
					(not (pEvent claimed?))
					(== (pEvent type?) evKEYBOARD)
					(or
						(== (pEvent message?) echo)
						(and
							(<= KEY_SPACE (pEvent message?))
							(<= (pEvent message?) 255)
						)
					)
					(self getInput: pEvent)
					(Parse @inputLine pEvent)
				)
				(pEvent type: 128)
				(self said: pEvent)
			)
		)
		(= lastEvent 0)
	)
	
	(method (canInput theInput)
		(if argc (= input theInput))
		(return input)
	)
)

(class Ego of Actor
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $2000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		edgeHit 0
	)
	
	(method (init)
		(super init:)
		(if (not cycler) (self setCycle: Walk))
	)
	
	(method (doit)
		(super doit:)
		(= edgeHit
			(cond 
				((<= x 0) 4)
				((>= x 319) 2)
				((>= y 189) 3)
				((<= y (curRoom horizon?)) 1)
				(else 0)
			)
		)
	)
	
	(method (handleEvent pEvent &tmp pEventMessage)
		(if script (script handleEvent: pEvent))
		(if (not (pEvent claimed?))
			(switch (pEvent type?)
				(evMOUSEBUTTON
					(if
					(and (User controls?) (not (pEvent modifiers?)))
						(self
							setMotion:
								(if useObstacles PolyPath else MoveTo)
								(pEvent x?)
								(pEvent y?)
						)
						(User prevDir: 0)
						(pEvent claimed: 1)
					)
				)
				(evJOYSTICK
					(if
						(and
							(==
								(= pEventMessage (pEvent message?))
								(User prevDir?)
							)
							(IsObject mover)
						)
						(= pEventMessage 0)
					)
					(User prevDir: pEventMessage)
					(self setDirection: pEventMessage)
					(pEvent claimed: 1)
				)
			)
		)
		(pEvent claimed?)
	)
	
	(method (get param1 &tmp temp0)
		(= temp0 0)
		(while (< temp0 argc)
			((inventory at: [param1 temp0]) moveTo: self)
			(++ temp0)
		)
	)
	
	(method (put param1 param2)
		(if (self has: param1)
			((inventory at: param1)
				moveTo: (if (== argc 1) -1 else param2)
			)
		)
	)
	
	(method (has param1 &tmp temp0)
		(if (= temp0 (inventory at: param1))
			(temp0 ownedBy: self)
		)
	)
)
