;;; Sierra Script 1.0 - (do not remove this comment)
(script# 96)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use Intrface)
(use Polygon)
(use Music)
(use Motion)
(use Actor)
(use System)


(local
	theXEgoPos
	theYEgoPos
	[thePoints_2 14] = [260 145 273 138 285 138 299 146 273 159 273 164 260 156]
	[thePoints 14] = [66 123 79 115 96 115 107 122 107 134 93 140 93 135]
	[thePoints_4 14] = [36 29 63 14 69 17 69 29 57 34 42 34 36 31]
	[thePoints_3 14] = [36 29 63 14 55 9 42 11 30 16 29 27 36 31]
	[thePoints_5 14] = [150 77 150 81 177 96 183 92 183 80 171 73 155 73]
	[thePoints_6 14] = [150 81 150 77 144 80 144 91 156 99 171 99 177 96]
	[local86 18] = [0 0 0 -5 5 -5 5 0 5 5 0 5 -5 5 -5 0 -5 -5]
	[local104 4] = [8 6 7 9]
	theX
	theY
)
(class _MapLocation of Prop
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 710
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		hasIcon 1
		isCycling 0
		theRoom 0
		alterRoom 0
		beenHere 0
		openAtNight 1
		points 0
		nPoints 0
		xEgoPos 0
		yEgoPos 0
		xCoord 0
		yCoord 0
		polygon 0
	)
	
	(method (init param1)
		(if (not (self hasBeenHere:)) (return 0))
		(super init: &rest)
		(param1 add: self)
		(if points
			((= polygon (Polygon new:))
				points: points
				size: nPoints
			)
		)
		(if isCycling
			(self setCycle: Fwd)
		else
			(self stopUpd:)
			(if (not hasIcon) (= loop 5) (= cel 9))
		)
		(self ignoreActors:)
		(return 1)
	)
	
	(method (dispose)
		(if polygon (polygon dispose:))
		(self setCycle: 0)
		(super dispose:)
	)
	
	(method (onMe param1 param2)
		(if polygon
			(AvoidPath param1 param2 polygon)
			(return)
		else
			(super onMe: param1 param2)
			(return)
		)
	)
	
	(method (isEgoInRoom param1)
		(return
			(if (== param1 theRoom)
				(= theXEgoPos xEgoPos)
				(= theYEgoPos yEgoPos)
				(return 1)
			else
				(return 0)
			)
		)
	)
	
	(method (hasBeenHere)
		(if (== 0 beenHere) else (Btst beenHere))
	)
	
	(method (canComeHere)
		(return
			(cond 
				(openAtNight)
				((<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
		)
	)
	
	(method (comeHere)
		(return
			(if (self canComeHere:)
				(return theRoom)
			else
				(return alterRoom)
			)
		)
	)
)

(class _MapView of View
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 710
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0101
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
	)
	
	(method (init param1)
		(super init: &rest)
		(param1 add: self)
	)
)

(class _MapPicView of _MapView
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 710
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0101
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
	)
	
	(method (onMe)
		(return 0)
	)
)

(instance egoPosition of Prop
	(properties
		view 710
	)
	
	(method (init param1)
		(super init: &rest)
		(param1 add: self)
		(self setCycle: Fwd)
	)
	
	(method (onMe)
		(return 0)
	)
)

(class Map of Obj
	(properties
		x 0
		y 0
		egoLoc 0
		csrLoc 0
		mapCast 0
		theKey 0
		roomToGoTo 0
		distance 0
		notHiddenList 0
		soundPaused 0
	)
	
	(method (init &tmp temp0 newEvent)
		(if
			(or
				(and (OneOf curRoomNum 303 300) (== elementalsStatus 1))
				(and (OneOf curRoomNum 240 335) (== elementalsStatus 3))
				(and (OneOf curRoomNum 310 315) (== elementalsStatus 7))
			)
			(HighPrint 96 0)
			(return)
		)
		(if
			(or
				(Btst 133)
				(ego script?)
				(curRoom script?)
				(theGame script?)
				global161
			)
			(HighPrint 96 1)
			(return)
		)
		(= soundPaused (Sound pause: 1))
		(= roomToGoTo 0)
		(= mapCast (Collect new:))
		(= notHiddenList (Collect new:))
		(cast
			eachElementDo: #perform hideCastMember notHiddenList
		)
		(compass init: mapCast)
		(Fighters_Plaza_b init: mapCast)
		(Fighters_Plaza_a init: mapCast)
		(Fountain_Plaza_a init: mapCast)
		(Fountain_Plaza_b init: mapCast)
		(Palace_Plaza init: mapCast)
		(Gates_Plaza init: mapCast)
		(Palace init: mapCast)
		(Guild_Hall init: mapCast)
		(Moneychanger init: mapCast)
		(Saurus_Lot init: mapCast)
		(Weapons_Shop init: mapCast)
		(Apothecary init: mapCast)
		(Astrologer init: mapCast)
		(Katta_s_Tail_Inn init: mapCast)
		(Enchantress init: mapCast)
		(Magic_Shop init: mapCast)
		(W__I__T_ init: mapCast)
		(= temp0 6)
		(if
			(= egoLoc
				(mapCast firstTrue: #perform seeIfEgoIsInRoom curRoomNum)
			)
			(= gEgoLocXCoord (egoLoc xCoord?))
			(= gEgoLocYCoord (egoLoc yCoord?))
		else
			(if (curRoom respondsTo: #facingHeading)
				(= temp0 [local104 (- (curRoom facingHeading?) 1)])
				(curRoom egoPos2Coords:)
			)
			(self map2ScreenCoords: gEgoLocXCoord gEgoLocYCoord)
		)
		(egoPosition
			init: mapCast
			x: theXEgoPos
			y: theYEgoPos
			loop: temp0
			cel: 0
			cycleSpeed: 2
			ignoreActors:
			setPri: 15
		)
		(= theX ((= newEvent (Event new:)) x?))
		(= theY (newEvent y?))
		(newEvent dispose:)
		(DrawPic 710 100 dpCLEAR 0)
		(self handleEvent:)
	)
	
	(method (dispose)
		(if modelessDialog (modelessDialog dispose:))
		(mapCast
			eachElementDo: #dispose
			eachElementDo: #delete
			release:
			dispose:
		)
		(notHiddenList eachElementDo: #show release: dispose:)
		(if
			(and
				roomToGoTo
				(or (!= roomToGoTo curRoomNum) (== curRoomNum 704))
			)
			(Bset 28)
			(= gTopExit 3)
			(= curRoomNum 0)
			(curRoom newRoom: roomToGoTo)
		else
			(DrawPic (curRoom curPic?) 100 dpCLEAR defaultPalette)
			(if (!= overlays -1)
				(DrawPic overlays 100 dpNO_CLEAR defaultPalette)
			)
			(addToPics doit:)
		)
		(Sound pause: soundPaused)
		(super dispose:)
	)
	
	(method (handleEvent &tmp temp0 temp1)
		(asm
code_0661:
			pushi    #new
			pushi    0
			class    Event
			send     4
			sat      temp1
			pushi    1
			push    
			callk    MapKeyToDir,  2
			pushi    1
			lst      temp1
			callk    GlobalToLocal,  2
			pushi    #x
			pushi    0
			lat      temp1
			send     4
			aTop     x
			pushi    #y
			pushi    0
			lat      temp1
			send     4
			aTop     y
			pushi    #displayCurLocation
			pushi    0
			self     4
			pushi    #type
			pushi    0
			lat      temp1
			send     4
			push    
			ldi      64
			eq?     
			bnt      code_06b9
			pushi    #message
			pushi    0
			lat      temp1
			send     4
			sat      temp0
			push    
			pToa     theKey
			eq?     
			bnt      code_06b2
			ldi      0
			aTop     theKey
			jmp      code_0750
code_06b2:
			lat      temp0
			aTop     theKey
			jmp      code_0750
code_06b9:
			pushi    #message
			pushi    0
			lat      temp1
			send     4
			push    
			ldi      27
			eq?     
			bnt      code_06cd
			jmp      code_0773
			jmp      code_0750
code_06cd:
			pushi    #message
			pushi    0
			lat      temp1
			send     4
			push    
			ldi      17
			eq?     
			bnt      code_06eb
			pushi    0
			calle    AskQuit,  0
			lag      quit
			bnt      code_0750
			jmp      code_0773
			jmp      code_0750
code_06eb:
			pushi    #type
			pushi    0
			lat      temp1
			send     4
			push    
			ldi      1
			eq?     
			bt       code_0707
			pushi    #message
			pushi    0
			lat      temp1
			send     4
			push    
			ldi      13
			eq?     
			bnt      code_073c
code_0707:
			pToa     csrLoc
			bnt      code_0773
			pushi    2
			pushi    0
			pushi    4
			pushi    #xCoord
			pushi    0
			send     4
			push    
			pushi    #yCoord
			pushi    0
			pToa     csrLoc
			send     4
			push    
			lsg      gEgoLocXCoord
			lsg      gEgoLocYCoord
			callk    GetDistance,  8
			push    
			calle    GameTimeEvents,  4
			pushi    #comeHere
			pushi    0
			pToa     csrLoc
			send     4
			aTop     roomToGoTo
			jmp      code_0773
			jmp      code_0750
code_073c:
			pTos     x
			lal      theX
			ne?     
			bt       code_074c
			pTos     y
			lal      theY
			ne?     
			bnt      code_0750
code_074c:
			ldi      0
			aTop     theKey
code_0750:
			pushi    #dispose
			pushi    0
			lat      temp1
			send     4
			pushi    1
			lsg      gSaveSpeed
			callk    Wait,  2
			pushi    2
			pushi    #elements
			pushi    0
			pToa     mapCast
			send     4
			push    
			pushi    1
			callk    Animate,  4
			pushi    #moveCursor
			pushi    0
			self     4
			jmp      code_0661
code_0773:
			pushi    #dispose
			pushi    0
			lat      temp1
			send     4
			pushi    #dispose
			pushi    0
			self     4
			ret     
		)
	)
	
	(method (map2ScreenCoords param1 param2)
		(= theXEgoPos
			(+
				(/ (* (+ param1 param2) 25) 8)
				(if (< param1 40) -25 else -22)
			)
		)
		(= theYEgoPos
			(+
				(- (/ (* param1 7) 4) (/ (* param2 5) 3))
				(if (< param1 40) 51 else 53)
			)
		)
	)
	
	(method (displayCurLocation &tmp theCsrLoc)
		(if (= theCsrLoc (mapCast firstTrue: #onMe x y))
			(if (!= theCsrLoc csrLoc)
				(Print (theCsrLoc name?) #font 999 #at 80 160 #dispose)
				(= csrLoc theCsrLoc)
			)
		else
			(if modelessDialog (modelessDialog dispose:))
			(= csrLoc 0)
		)
	)
	
	(method (moveCursor &tmp temp0 temp1)
		(if (!= theKey 0)
			(= temp0 (* theKey 2))
			(= x (+ x [local86 temp0]))
			(= y (+ y [local86 (+ temp0 1)]))
			(if (< x 0) (= x (= theKey 0)))
			(if (> x 319) (= theKey 0) (= x 319))
			(if (< y 0) (= y (= theKey 0)))
			(if (> y 189) (= theKey 0) (= x 189))
			(theGame setCursor: theCursor 1 x y)
			(= theX x)
			(= theY y)
		)
	)
)

(instance hideCastMember of Code
	(properties)
	
	(method (doit param1 param2)
		(if (not (& (param1 signal?) $0008))
			(param2 add: param1)
			(param1 hide:)
		)
	)
)

(instance seeIfEgoIsInRoom of Code
	(properties)
	
	(method (doit param1 param2)
		(return
			(if (param1 respondsTo: #isEgoInRoom)
				(return (param1 isEgoInRoom: param2))
			else
				(return 0)
			)
		)
	)
)

(instance compass of _MapPicView
	(properties
		x 41
		y 169
		loop 2
	)
)

(instance Palace of _MapLocation
	(properties
		x 294
		y 172
		loop 1
		cel 1
		theRoom 240
		alterRoom 335
		xEgoPos 276
		yEgoPos 154
		xCoord 78
		yCoord 20
	)
	
	(method (canComeHere)
		(return (if (super canComeHere:) (!= elementalsStatus 3) else 0))
	)
)

(instance Guild_Hall of _MapLocation
	(properties
		x 34
		y 19
		loop 4
		cel 1
		priority 14
		signal $0010
		theRoom 160
		alterRoom 320
		beenHere 127
		openAtNight 0
		xEgoPos 29
		yEgoPos 14
		yCoord 20
		name "Guild Hall"
	)
)

(instance Moneychanger of _MapLocation
	(properties
		x 85
		y 68
		loop 5
		theRoom 120
		beenHere 9
		xEgoPos 91
		yEgoPos 68
		xCoord 19
		yCoord 13
	)
)

(instance Saurus_Lot of _MapLocation
	(properties
		x 68
		y 135
		loop 3
		cel 1
		priority 14
		signal $0010
		theRoom 290
		alterRoom 300
		beenHere 152
		xEgoPos 67
		yEgoPos 131
		xCoord 37
		yCoord -5
		name "Saurus Lot"
	)
	
	(method (init param1)
		(if (super init: param1) (saurusLotIcon init: param1))
	)
	
	(method (onMe param1 param2)
		(if (not (super onMe: param1 param2))
			(return (saurusLotIcon onMe: param1 param2))
		)
		(return 1)
	)
	
	(method (canComeHere)
		(return (if (super canComeHere:) (!= elementalsStatus 1) else 0))
	)
)

(instance saurusLotIcon of _MapView
	(properties
		x 55
		y 130
		loop 5
		cel 1
	)
)

(instance Weapons_Shop of _MapLocation
	(properties
		x 76
		y 26
		loop 5
		cel 2
		priority 14
		signal $0010
		theRoom 140
		alterRoom 330
		beenHere 128
		openAtNight 0
		xEgoPos 80
		yEgoPos 24
		xCoord 8
		yCoord 24
		name "Weapons Shop"
	)
)

(instance Apothecary of _MapLocation
	(properties
		x 165
		y 106
		loop 5
		cel 3
		theRoom 130
		alterRoom 315
		openAtNight 0
		xEgoPos 131
		yEgoPos 94
		xCoord 36
		yCoord 16
	)
	
	(method (hasBeenHere)
		(return global264)
	)
	
	(method (canComeHere)
		(return (if (super canComeHere:) (!= elementalsStatus 7) else 0))
	)
)

(instance Astrologer of _MapLocation
	(properties
		x 248
		y 186
		loop 5
		cel 4
		theRoom 200
		alterRoom 704
		beenHere 131
		openAtNight 0
		xEgoPos 238
		yEgoPos 189
		xCoord 81
		yCoord 6
	)
)

(instance Katta_s_Tail_Inn of _MapLocation
	(properties
		x 113
		y 132
		loop 5
		cel 5
		theRoom 100
		alterRoom 300
		xEgoPos 118
		yEgoPos 136
		xCoord 45
		name "Katta's Tail Inn"
	)
	
	(method (canComeHere)
		(return (if (super canComeHere:) (!= elementalsStatus 1) else 0))
	)
)

(instance Enchantress of _MapLocation
	(properties
		x 245
		y 91
		loop 5
		cel 6
		theRoom 199
		beenHere 130
		xEgoPos 239
		yEgoPos 87
		xCoord 56
		yCoord 32
	)
)

(instance Magic_Shop of _MapLocation
	(properties
		x 189
		y 88
		loop 5
		cel 7
		theRoom 250
		alterRoom 310
		beenHere 129
		openAtNight 0
		xEgoPos 192
		yEgoPos 92
		xCoord 45
		yCoord 24
		name "Magic Shop"
	)
	
	(method (canComeHere)
		(return (if (super canComeHere:) (!= elementalsStatus 7) else 0))
	)
)

(instance W__I__T_ of _MapLocation
	(properties
		x 225
		y 49
		loop 5
		cel 8
		theRoom 229
		beenHere 62
		xEgoPos 216
		yEgoPos 51
		xCoord 40
		yCoord 40
		name "W. I. T."
	)
	
	(method (init param1)
		(if (super init: param1)
			(WIT2 init: param1 loop: loop cel: cel)
		)
	)
	
	(method (onMe param1 param2)
		(if (not (super onMe: param1 param2))
			(return (WIT2 onMe: param1 param2))
		)
		(return 1)
	)
)

(instance WIT2 of _MapView
	(properties
		x 232
		y 53
	)
)

(instance Gates_Plaza of _MapLocation
	(properties
		x 87
		y 139
		loop 3
		theRoom 300
		xEgoPos 86
		yEgoPos 128
		xCoord 40
		yCoord -2
		name "Gates Plaza"
	)
	
	(method (init)
		(= points @thePoints)
		(= nPoints 7)
		(super init: &rest)
	)
)

(instance Palace_Plaza of _MapLocation
	(properties
		x 278
		y 162
		loop 1
		theRoom 335
		xEgoPos 270
		yEgoPos 146
		xCoord 75
		yCoord 20
		name "Palace Plaza"
	)
	
	(method (init)
		(= points @thePoints_2)
		(= nPoints 7)
		(super init: &rest)
	)
)

(instance Fighters_Plaza_a of _MapLocation
	(properties
		x 49
		y 33
		loop 4
		theRoom 320
		xEgoPos 35
		yEgoPos 23
		xCoord 3
		yCoord 20
		name "Fighters Plaza\_a"
	)
	
	(method (init)
		(= points @thePoints_3)
		(= nPoints 7)
		(super init: &rest)
	)
)

(instance Fighters_Plaza_b of _MapLocation
	(properties
		loop 5
		cel 9
		theRoom 330
		xEgoPos 52
		yEgoPos 27
		xCoord 6
		yCoord 20
		name "Fighters Plaza\_b"
	)
	
	(method (init)
		(= points @thePoints_4)
		(= nPoints 7)
		(super init: &rest)
	)
)

(instance Fountain_Plaza_a of _MapLocation
	(properties
		x 162
		y 89
		isCycling 1
		theRoom 310
		xEgoPos 170
		yEgoPos 85
		xCoord 40
		yCoord 22
		name "Fountain Plaza\_a"
	)
	
	(method (init)
		(= points @thePoints_5)
		(= nPoints 7)
		(super init: &rest)
	)
)

(instance Fountain_Plaza_b of _MapLocation
	(properties
		hasIcon 0
		theRoom 315
		xEgoPos 155
		yEgoPos 91
		xCoord 40
		yCoord 18
		name "Fountain Plaza\_b"
	)
	
	(method (init)
		(= points @thePoints_6)
		(= nPoints 7)
		(super init: &rest)
	)
)
