;;; Sierra Script 1.0 - (do not remove this comment)
(script# 221)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use ProjClient)
(use TargActor)
(use rm220)
(use ForCount)
(use Motion)
(use System)

(public
	airSP 0
	levitateSP 1
	earthSP 2
	triggerWallSP 3
)

(local
	local0
	local1
)
(instance airSP of Script
	(properties)
	
	(method (doit &tmp temp0)
		(super doit: &rest)
		(cond 
			((== local0 (= temp0 (ego onControl: 1))))
			(((ScriptID 62 0) client?))
			((== temp0 16384) (ego view: 62 setLoop: 1 setCycle: Fwd))
			((and (== (ego view?) 62) (not global161)) (proc1_19))
		)
		(= local0 temp0)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(bullseye init:)
				(wizStaff init: setCycle: End self)
				(gMiscMusic number: 222 priority: 5 loop: -1 play:)
				(proc1_19)
				(ego setMotion: 0)
				(proc220_5)
			)
			(1
				(wizStaff setLoop: 1 setCycle: ForwardCounter 2 self)
			)
			(2
				(wizStaff setLoop: 2 setCycle: Fwd setPri: 8)
				(curRoom notify: 6 1)
				(LockEgo)
			)
		)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			(
				(and
					(== (ego view?) 62)
					(Said 'cast,cease,get,acquire')
				)
				(UnlockEgo)
				(ego
					illegalBits: 0
					ignoreActors:
					setMotion: MoveTo 161 136
				)
			)
		)
	)
)

(instance earthSP of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(wall
					posn: 139 108
					view: 222
					setLoop: 4
					cel: 0
					init:
					setStep: 2 1
					setMotion: MoveTo 143 108 self
				)
			)
			(1
				(wall cel: 1 setMotion: MoveTo 149 109 self)
			)
			(2
				(wall cel: 2 setMotion: MoveTo 156 110 self)
			)
			(3
				(wall cel: 3 setMotion: MoveTo 165 111 self)
			)
			(4
				(wall cel: 4 setMotion: MoveTo 177 113 self)
			)
			(5
				(proc1_19)
				(curRoom notify: 6 3)
				(wall setPri: 7 ignoreActors: 0 stopUpd:)
				(proc220_5)
				(LockEgo)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'climb,scale')
				(cond 
					(
						(and
							(<= 4 (curRoom notify: 6))
							(<= (curRoom notify: 6) 5)
						)
						(triggerWallSP changeState: 8)
					)
					((== (curRoom notify: 6) 6) (HighPrint 221 0))
					(else (self setScript: (ScriptID 220 2)))
				)
			)
		)
	)
)

(instance fetchStaffSP of Script
	(properties)
	
	(method (doit)
		(cond 
			((> (Abs (- (ego x?) (wizStaff x?))) 26))
			((curRoom notify: 2))
			((not ((ScriptID 62 0) client?))
				(curRoom notify: 2 1)
				(ego setScript: 0)
				(curRoom setScript: (ScriptID 220 1) 0 16)
			)
			((< (ego z?) 16)
				(curRoom notify: 2 1)
				(levitateSP cue:)
				(curRoom setScript: (ScriptID 220 1) 0 16)
			)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(wizStaff setLoop: 3 cycleSpeed: 1 setCycle: End self)
				(bullseye hide:)
				(curRoom notify: 6 0)
			)
			(1
				(wizStaff
					setLoop: 4
					setStep: 2 3
					setPri: 7
					setCycle: Fwd
					cycleSpeed: 0
					moveSpeed: 1
					setMotion: MoveTo 348 180 self
				)
				(curRoom notify: 6 2)
			)
			(2
				(gMiscMusic loop: 1 fade:)
				(= cycles 8)
			)
			(3
				(wizStaff dispose:)
				(if ((ScriptID 62 0) client?)
					((ScriptID 62 0) cue:)
					(= cycles 52)
				else
					(= cycles 1)
				)
			)
			(4
				(UnlockEgo)
				(ego setMotion: MoveTo 246 141 self)
			)
			(5
				(ego setLoop: -1 setHeading: 315 self)
			)
			(6
				(AddToScore 687 7 1)
				(curRoom notify: 6 0)
				(LockEgo 1)
				(Bset 67)
				(curRoom setScript: (ScriptID 220 3))
				(client dispose:)
			)
		)
	)
)

(instance levitateSP of HandsOffScript
	(properties)
	
	(method (doit)
		(if (< (Abs (- (ego x?) (wizStaff x?))) 22)
			(ego z: (- (ego z?) (Random 0 2)))
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(curRoom notify: 1 (ego y?))
				(if (== (curRoom notify: 6) 2)
					(UnlockEgo)
					(curRoom notify: 4 1)
				)
				(caller cue:)
			)
			(1
				(if (curRoom notify: 2)
					(ego z: 100 y: (+ (ego y?) 100))
					(self setScript: (ScriptID 62 1) 0 200)
				)
				(ego ignoreActors: 0)
				(self dispose:)
			)
		)
	)
)

(instance triggerWallSP of Script
	(properties)
	
	(method (doit)
		(super doit: &rest)
		(cond 
			((!= (ego onControl: 1) 16384))
			((curRoom notify: 5) (curRoom notify: 5 0) (self changeState: 4))
			((== (curRoom notify: 6) 5) (self changeState: 8))
		)
	)
	
	(method (changeState newState &tmp [temp0 2])
		(switch (= state newState)
			(0
				(UnlockEgo)
				(wall setLoop: 0 cel: 0 setCycle: End self)
			)
			(1
				(curRoom notify: 6 4)
				(curRoom notify: 5 1)
				(LockEgo)
			)
			(2
				(UnlockEgo)
				(wall setLoop: 0 cel: (wall lastCel:) setCycle: Beg self)
			)
			(3
				(curRoom notify: 6 3)
				(curRoom notify: 5 0)
				(LockEgo)
			)
			(4
				(UnlockEgo)
				(wall setLoop: 2 cel: 0 setCycle: CT 1 1 self)
			)
			(5
				(wall setCycle: End self)
				(ego posn: 185 123)
				(curRoom setScript: (ScriptID 220 1) 0 16)
				(LockEgo)
				(client setScript: 0)
			)
			(6
				(wall setLoop: 1 cel: 0 cycleSpeed: 2 setCycle: End self)
			)
			(7
				(curRoom notify: 6 5)
				(curRoom notify: 5 0)
			)
			(8
				(UnlockEgo)
				(curRoom notify: 6 6)
				(ego
					illegalBits: 0
					ignoreActors:
					setMotion: MoveTo 190 117 self
				)
			)
			(9
				(ego
					view: 7
					setLoop: 1
					posn: 182 91
					setPri: 11
					cel: 0
					cycleSpeed: 3
					setCycle: End self
				)
			)
			(10 (= cycles 8))
			(11
				(ego
					setPri: 7
					cel: (- (ego lastCel:) 1)
					setCycle: CT 1 -1 self
				)
			)
			(12
				(proc220_4)
				(ego
					view: 0
					posn: 177 114
					setLoop: 7
					cycleSpeed: 0
					setCycle: Fwd
				)
				(wall setPri: 8 setMotion: MoveTo 232 134 self)
			)
			(13
				(wall
					setMotion: MoveTo 262 144 self
					cycleSpeed: 4
					setCycle: Beg
				)
			)
			(14
				(proc220_5)
				(ego setCycle: 0)
				(FaceObject ego wall)
				(= cycles 8)
			)
			(15
				(wall setLoop: 3 cycleSpeed: 1 cel: 0 setCycle: End self)
			)
			(16
				(SetInput 0)
				(gMiscMusic number: 223 priority: 5 loop: 1 play:)
				(ShakeScreen 2)
				(wall cycleSpeed: 2 setCycle: Beg)
				(ego
					view: 225
					setLoop: 8
					setCycle: ForwardCounter 5
					setMotion: MoveTo 201 125
				)
				(= cycles 24)
			)
			(17
				(wall cycleSpeed: 1 cel: 0 setCycle: End self)
			)
			(18
				(gMiscMusic number: 223 priority: 5 loop: 1 play:)
				(ShakeScreen 2)
				(wall cycleSpeed: 2 setCycle: Beg)
				(ego setCycle: ForwardCounter 4 setMotion: MoveTo 212 132)
				(= cycles 24)
			)
			(19
				(wall cycleSpeed: 0 setCycle: ForwardCounter 2 self)
			)
			(20
				(gMiscMusic number: 223 priority: 5 loop: 1 play:)
				(ShakeScreen 2)
				(wall cycleSpeed: 2 setCycle: Beg)
				(ego setCycle: ForwardCounter 3 setMotion: MoveTo 214 142)
			)
			(21
				(UnlockEgo)
				(wall setCycle: 0)
				(ego setMotion: 0 setLoop: 0 cel: 0 setCycle: End self)
				(gMiscMusic loop: 1 play:)
			)
			(22
				(if (== (ego view?) 31)
					(wall setLoop: 1 cel: 0 setCycle: End)
				else
					(wall setLoop: 0 cel: (wall lastCel:) setCycle: Beg)
				)
				(= cycles 24)
			)
			(23
				(wall
					setLoop: 4
					cel: (wall lastCel:)
					ignoreActors:
					setCycle: Beg self
				)
			)
			(24
				(wall setMotion: MoveTo 319 260)
				(ego
					view: 0
					setCycle: Walk
					setMotion: MoveTo 246 141 self
				)
			)
			(25
				(ego setLoop: -1 setHeading: 315 self)
			)
			(26
				(AddToScore 688 7 1)
				(curRoom notify: 6 0)
				(LockEgo)
				(Bset 68)
				(curRoom setScript: (ScriptID 220 3))
				(client dispose:)
			)
		)
	)
)

(instance wizStaff of TargActor
	(properties
		x 170
		y 86
		noun '/staff'
		description {the wizard's spinning staff}
		lookStr {The wizard's staff spins faster and faster.}
		view 221
		priority 9
		signal $4010
		illegalBits $0000
	)
	
	(method (calmMe)
		(PrintWarning 221 1)
		(return 1)
	)
	
	(method (dazzleMe)
		(PrintWarning 221 1)
	)
	
	(method (detectMe)
		(PrintWarning 221 2)
		(return 1)
	)
	
	(method (fetchMe)
		(PrintWarning 221 3)
		(return 0)
	)
	
	(method (hurtMe param1 param2 &tmp temp0 newProjectile)
		(return
			(if
				(and
					(== (= temp0 (param2 type?)) 27)
					(== (curRoom notify: 6) 1)
					(< hitY 87)
				)
				(bullseye setScript: fetchStaffSP)
			else
				((= newProjectile (Projectile new:))
					type: temp0
					damage: param1
					xStart: x
					yStart: (- y 11)
					x: (+ (ego x?) (Random 3 40))
					y: (- (ego y?) (Random 3 30))
				)
				(self init: setScript: newProjectile self 0)
				(return 0)
			)
		)
	)
	
	(method (openMe)
		(PrintWarning 221 1)
		(return 0)
	)
	
	(method (triggerMe)
		(PrintWarning 221 1)
		(return 0)
	)
)

(instance bullseye of TargActor
	(properties
		x 170
		y 91
		lookStr {The staff might be easier to hit with a spell near its center.}
		view 221
		loop 5
		priority 9
		signal $4010
		illegalBits $0000
	)
	
	(method (fetchMe)
		(if (== (curRoom notify: 6) 1)
			(self setScript: fetchStaffSP)
		else
			(PrintWarning 221 1)
		)
		(return 0)
	)
	
	(method (hurtMe param1 param2 &tmp newProjectile)
		((= newProjectile (Projectile new:))
			type: (param2 type?)
			damage: param1
			xStart: x
			yStart: (- y 11)
			x: (+ (ego x?) (Random 3 40))
			y: (- (ego y?) (Random 3 30))
		)
		(self setScript: newProjectile self 0)
		(return 0)
	)
)

(instance wall of TargActor
	(properties
		x 170
		y 86
		noun '/wall,creature,elemental'
		description {the earthen wall}
		lookStr {The wall is made of earth and stone.}
		view 222
		priority 9
		signal $4010
		illegalBits $0000
	)
	
	(method (handleEvent pEvent)
		(if (Said 'climb,scale')
			(pEvent claimed: 0)
		else
			(super handleEvent: pEvent)
		)
	)
	
	(method (calmMe)
		(if (== (curRoom notify: 6) 4)
			((ScriptID 221 3) changeState: 6)
			(return 1)
		else
			(PrintWarning 221 4)
		)
		(return 0)
	)
	
	(method (dazzleMe)
		(if (== (curRoom notify: 6) 4)
			((ScriptID 221 3) changeState: 6)
		else
			(PrintWarning 221 1)
		)
		(return 0)
	)
	
	(method (detectMe)
		(HighPrint 221 5)
		(return 1)
	)
	
	(method (fetchMe)
		(PrintWarning 221 6)
		(return 0)
	)
	
	(method (hurtMe &tmp temp0)
		(switch (curRoom notify: 6)
			(3
				((curRoom script?)
					setScript:
						delayPrintS
						0
						{That was about as useful as bouncing a flame dart off of a brick wall.}
				)
			)
			(4
				((curRoom script?)
					setScript:
						delayPrintS
						0
						{You really shouldn't get him angry.__You wouldn't like him when he's angry.}
				)
			)
			(else 
				((curRoom script?)
					setScript: delayPrintS 0 {It seems to have absorbed your spell's energy.}
				)
			)
		)
		(return 1)
	)
	
	(method (openMe)
		(PrintWarning 221 1)
		(return 0)
	)
	
	(method (triggerMe)
		(return
			(cond 
				((== (curRoom notify: 6) 3) (self setScript: triggerWallSP) (return 1))
				(
					(and
						(>= 5 (curRoom notify: 6))
						(>= (curRoom notify: 6) 4)
					)
					((ScriptID 221 3) changeState: 2)
					(return 1)
				)
				(else (PrintWarning 221 1) (return 0))
			)
		)
	)
)

(instance delayPrintS of Script
	(properties)
	
	(method (doit)
		(if (and (not (Btst 87)) register) (self cue:))
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(1
				(PrintWarning register)
				(= register 0)
				(self dispose:)
			)
		)
	)
)
