;;; Sierra Script 1.0 - (do not remove this comment)
(script# 703)
(include sci.sh)
(use Main)
(use n001)
(use HandsOffScript)
(use Talker)
(use Full)
(use AFeat)
(use Block)
(use MoveFwd)
(use LoadMany)
(use Motion)
(use Actor)
(use System)

(public
	alleyRas 0
)

(local
	local0
	local1
	local2
)
(instance alleyRas of AlleyRoom
	(properties)
	
	(method (init)
		(LoadMany 128 433 382 426)
		(gCMusic number: 710 loop: -1 playBed:)
		(= defaultPalette 2)
		(super init: &rest)
	)
	
	(method (doit)
		(super doit:)
		(if (theGame script?) (return))
		(cond 
			(
				(and
					local0
					(not (Btst 142))
					(or
						(and (== facingHeading 3) (== (- length scrBotPos) 36))
						(and (== facingHeading 1) (== (- length scrBotPos) 36))
					)
					(== currentDay 28)
					(Btst 97)
					(not (Btst 138))
				)
				(Bset 142)
				(theGame setScript: slaveBeckons)
			)
			(
				(and
					(not (theGame script?))
					(Btst 142)
					(or
						(and (== facingHeading 1) (== (- length scrBotPos) 20))
						(and (== facingHeading 3) (== (- length scrBotPos) 20))
					)
				)
				(theGame setScript: getCaught)
			)
			((and local1 (== (- length scrBotPos) 9)) (theGame setScript: meetAdAvis))
		)
	)
	
	(method (dispose)
		(= defaultPalette 0)
		(if (theGame script?) ((theGame script?) dispose:))
		(gCMusic fade:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(if (Said 'listen')
			(HighPrint 703 0)
		else
			(super handleEvent: pEvent)
		)
	)
	
	(method (newAlley)
		(super newAlley: &rest)
		(if (and local2 (theGame script?))
			((theGame script?) dispose:)
		)
		(= local0 (not (StrCmp (alley name?) {alley200})))
		(= local1
			(if (not (StrCmp (alley name?) {alley250}))
				(== prevRoomNum 440)
			else
				0
			)
		)
		(if
			(and
				(not local0)
				(== currentDay 28)
				(not (Btst 138))
				(not (theGame script?))
				(or
					(and
						(not (StrCmp (alley name?) {alley201}))
						(== facingHeading 4)
					)
					(not (StrCmp (alley name?) {alley210}))
					(not (StrCmp (alley name?) {alley218}))
				)
			)
			(= local2 1)
			(theGame setScript: guardsBlock 0 (== facingHeading 4))
		)
	)
	
	(method (turnAround)
		(if (and local2 (theGame script?))
			((theGame script?) dispose:)
		)
		(super turnAround:)
	)
	
	(method (newFeature)
		((super newFeature: &rest)
			palette:
				(if
				(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
					3
				else
					4
				)
			yourself:
		)
	)
	
	(method (crossIntersection)
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(super crossIntersection:)
		)
	)
	
	(method (makeCrosser param1 &tmp [temp0 3])
		(param1
			view: 382
			description: {the guard}
			noun: '/man,guard'
			lookStr: {The guard looks like he means business.}
		)
	)
)

(instance guard1 of Talker
	(properties
		view 383
		illegalBits $0000
		tLoop -1
		said '[/guard]'
		title {Guard:}
	)
	
	(method (init param1)
		(if param1
			(= loop 5)
			(= cel 0)
			(= x 133)
			(= y 137)
		else
			(= loop 7)
			(= cel 0)
			(= x 138)
			(= y 104)
		)
		(super init: show:)
	)
	
	(method (handleEvent pEvent)
		(if (Said 'attack')
			(HighPrint 703 2)
		else
			(super handleEvent: pEvent)
		)
		(pEvent claimed?)
	)
	
	(method (respond)
		(HighPrint 703 1)
	)
)

(instance guard2 of Actor
	(properties
		view 383
		illegalBits $0000
	)
	
	(method (init param1)
		(if param1
			(= loop 6)
			(= cel 0)
			(= x 182)
			(= y 139)
		else
			(= loop 8)
			(= cel 0)
			(= x 176)
			(= y 104)
		)
		(super init: show:)
	)
)

(instance block of Blk
	(properties
		top 95
		bottom 145
		right 319
	)
)

(instance guardsBlock of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(guard1 init: register)
		(guard2 init: register)
		(= gGDftSC gNoSC)
		(if register
			(ego posn: (ego x?) 164)
		else
			(ego posn: (ego x?) 82)
		)
		(ego loop: 3 observeBlocks: block)
		(curRoom isMoving: 0 isScrolling: 0)
	)
	
	(method (doit)
		(super doit:)
		(cond 
			(
				(and
					(not state)
					(or
						(and register (< (ego y?) 164))
						(and (not register) (> (ego y?) 82))
					)
				)
				(self changeState: 1)
			)
			(
				(and
					(== state 2)
					(or
						(and register (> (ego y?) 164))
						(and (not register) (< (ego y?) 82))
					)
				)
				(self changeState: 3)
			)
		)
	)
	
	(method (dispose)
		(if (IsObject (ego blocks?)) (ego ignoreBlocks: block))
		(guard1 dispose:)
		(guard2 dispose:)
		(= gGDftSC gAllSC)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(1
				(UnlockEgo)
				(guard1 loop: 2 setCycle: End)
				(guard2 loop: 3 setCycle: End self)
			)
			(2
				(Say guard1 703 3)
				(LockEgo)
			)
			(3
				(UnlockEgo)
				(guard1 setCycle: Beg)
				(guard2 setCycle: Beg self)
			)
			(4
				(guard1 loop: 5)
				(guard2 loop: 6)
				(LockEgo)
				(self changeState: 0)
			)
		)
	)
)

(instance slaveBeckons of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp [temp0 2])
		(switch (= state newState)
			(0
				(= register (== (curRoom facingHeading?) 1))
				(ego setMotion: 0)
				(curRoom isMoving: 0)
				(slaveWoman
					loop: register
					x: (if register 202 else 115)
					init:
				)
				(= cycles 5)
			)
			(1
				(slaveWoman setCycle: End self)
			)
			(2
				(proc1_15
					5
					{If you are truly a hero, follow me!}
					80
					{Woman}
					103
					self
				)
				(slaveWoman
					loop: (+ 2 register)
					cel: 0
					y: 116
					setCycle: Full 2 self
				)
			)
			(3)
			(4
				(slaveWoman
					loop: register
					setCel: 255
					y: 105
					setCycle: Beg self
				)
			)
			(5
				(slaveWoman dispose:)
				(self dispose:)
			)
		)
	)
)

(instance slaveWoman of Prop
	(properties
		y 105
		view 433
		priority 8
		signal $4010
		cycleSpeed 1
	)
)

(instance catchingGuard of Actor
	(properties
		view 382
		priority 8
		signal $4010
		illegalBits $0000
	)
	
	(method (init param1 param2 param3 &tmp temp0)
		(super init:)
		(if (== (curRoom facingHeading?) 3)
			(= param2 (- 320 param2))
			(= param3 (- 320 param3))
		)
		(self setScript: (guardMove new:) param1 param2 param3)
	)
)

(instance guardMove of Script
	(properties)
	
	(method (init param1 param2 param3 param4)
		(param1
			posn: param3 115
			setCycle: Walk
			setMotion: MoveTo param4 115 self
		)
		(super init: param1 param2)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0)
			(1 (= cycles 5))
			(2
				(client setHeading: 180 self)
			)
			(3 (self dispose:))
		)
	)
)

(instance getCaught of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: 0)
				(curRoom isMoving: 0)
				((catchingGuard new:) init: self 75 140)
				(= cycles 1)
			)
			(1
				(catchingGuard init: self 95 170)
			)
			(2)
			(3
				(HighPrint 703 4 80 {Guard})
				(Die
					0
					703
					5
					82
					(catchingGuard view?)
					(catchingGuard loop?)
					(catchingGuard cel?)
					80
					{Caught by guards}
				)
			)
		)
	)
)

(instance shimmer of Prop
	(properties
		view 426
		loop 2
		signal $4000
	)
	
	(method (init)
		(super init: &rest)
		(self posn: (ego x?) (+ (ego y?) 3) setCycle: Fwd)
	)
)

(instance adAvis of Actor
	(properties
		view 426
		signal $4000
		illegalBits $0000
	)
)

(instance meetAdAvis of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: 0)
				(curRoom isMoving: 0)
				(= cycles 3)
			)
			(1
				(shimmer init:)
				(= seconds 3)
			)
			(2
				(adAvis
					posn: 130 84
					cel: 0
					setHeading: 90
					setCycle: Walk
					xStep: 5
					setMotion: MoveFwd 12 self
					init:
				)
			)
			(3 (= seconds 2))
			(4
				(shimmer setCycle: 0 cel: 1)
				(curRoom newRoom: 420)
			)
		)
	)
)
