;;; Sierra Script 1.0 - (do not remove this comment)
(script# 704)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Monster)
(use TargActor)
(use Full)
(use TryToMoveTo)
(use StateMachine)
(use Intrface)
(use AFeat)
(use MoveFwd)
(use Approach)
(use LoadMany)
(use StopWalk)
(use Motion)
(use Actor)
(use System)

(public
	alleyRoom 0
)

(local
	[local0 3] = [357 358 359]
	local3
	local4
	local5
	local6
	gEgoIllegalBits
	[local8 2] = [1 2]
	[local10 2] = [1 1]
	[local12 8] = [3 4 0 7 2 6 1 5]
	local20 =  30
	local21
)
(procedure (localproc_0cba)
	(if (cast contains: (ScriptID 32 0))
		((ScriptID 32 0) endCombat: dispose:)
		(proc1_19)
		(ego
			observeControl: gEgoIllegalBits
			posn: ((ScriptID 32 0) x?) ((ScriptID 32 0) y?)
			init:
		)
	)
)

(instance alleyRoom of AlleyRoom
	(properties)
	
	(method (init)
		(LoadMany 128 345 80 81 810 811 715 709 357 358 359)
		(LoadMany 130 31 30 32 24)
		(gCMusic number: 700 loop: -1 playBed:)
		(detectee init:)
		(super init: &rest)
		(= local3 1)
	)
	
	(method (doit &tmp temp0)
		(super doit:)
		(if isScrolling (= local3 1) (return))
		(if
			(and
				local3
				(not (theGame script?))
				(< elementalsStatus 6)
				(or
					(and
						(== currentDay 12)
						(>= gEgoLocYCoord 20)
						(<= (Random 1 100) 40)
					)
					(and
						(== currentDay 13)
						(or
							(and
								(>= gEgoLocYCoord 20)
								(<= (= temp0 (Random 1 100)) 65)
							)
							(and (< gEgoLocYCoord 20) (<= (Random 1 100) 30))
						)
					)
				)
			)
			(theGame setScript: earthElemSM)
			(return)
		)
		(if (not isScrolling) (= local3 0))
	)
	
	(method (dispose)
		(if (IsObject earthElemSM) (earthElemSM dispose:))
		(gCMusic fade:)
		(super dispose: &rest)
	)
	
	(method (handleEvent pEvent)
		(if (Said 'listen')
			(HighPrint 704 0)
		else
			(super handleEvent: pEvent)
		)
	)
	
	(method (notify param1)
		(return
			(if (== param1 59)
				(localproc_0cba)
				(self turnAround:)
				(return 1)
			else
				0
			)
		)
	)
	
	(method (newAlley)
		(= local3 1)
		(earthElemSM cue: 6)
		(super newAlley: &rest)
	)
	
	(method (crossIntersection)
		(if
			(and
				(not (Btst 144))
				(== currentDay 3)
				(<= 0 currentTimeZone)
				(<= currentTimeZone 4)
			)
			(theGame setScript: harpoCrosses)
		else
			(super crossIntersection:)
		)
	)
	
	(method (makeCrosser param1 &tmp temp0 temp1 temp2 temp3 temp4)
		(if (Random 0 1)
			(= temp0 [local0 (Random 0 2)])
			(= temp1 (Random 1 3))
			(= temp2 {the townsperson})
			(= temp3 '/man,woman')
			(= temp4 {The townsperson looks nondescript.})
		else
			(= temp0 294)
			(= temp1 0)
			(= temp2 {the guard})
			(= temp3 '/man,guard')
			(= temp4 {The guard looks official.})
		)
		(param1
			view: temp0
			palette: temp1
			description: temp2
			noun: temp3
			lookStr: temp4
		)
	)
)

(instance earthElem of Monster
	(properties
		noun '/earth,dirt,monster,elemental[<earth]'
		description {the earth elemental}
		view 345
		cel 2
		cycleSpeed 3
		moveSpeed 3
		strength 200
		intell 50
		agil 50
		vit 100
		luck 50
		weap 150
		magic 100
		armorValue 8
		weapValue 10
		barX 260
		battleMusic 52
		endMusic 53
	)
	
	(method (init)
		(if (not (Btst 109))
			(= gHealth 0)
			(Bset 109)
		else
			(= health gHealth_2)
			(= stamina gStamina)
			(= gHealth health)
		)
		(super init:)
	)
	
	(method (dispose)
		(super dispose:)
		(= gHealth_2 health)
		(= gStamina stamina)
	)
	
	(method (handleEvent pEvent)
		(if
			(and
				(Said 'search>')
				(Said '/earth,dirt,monster,elemental[<earth]')
			)
			(self doVerb: 7)
			(pEvent claimed: 1)
		else
			(super handleEvent: pEvent)
		)
		(pEvent claimed?)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(7
				(cond 
					((ego has: 52) (HighPrint 704 3))
					(local5 (ego setScript: getDirt))
					(else (HighPrint 704 4))
				)
			)
			(else  (super doVerb: theVerb))
		)
	)
	
	(method (calmMe)
		(earthElemSM cue: 4)
		(return 1)
	)
	
	(method (dazzleMe)
		(self calmMe:)
	)
	
	(method (detectMe)
		(if (not local5) (HighPrint 704 1))
	)
	
	(method (hurtMe param1 param2)
		(cond 
			((OneOf (param2 type?) 52 25)
				(super hurtMe: (* param1 2) param2)
				(if (and health (== (param2 type?) 25))
					(earthElemSM cue: 1)
				)
			)
			((== (param2 type?) 3) (self die:))
			((not local4) (HighPrint 704 2) (= local4 1))
		)
	)
	
	(method (die)
		(super die:)
		(= local5 1)
		(earthElemSM cue: 2)
	)
)

(instance getDirt of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setMotion: MoveTo (earthElem x?) (earthElem y?) self
				)
			)
			(1
				(ego view: 47 loop: 0 cel: 0 setCycle: End self)
			)
			(2
				(if (ego has: 38)
					(HighPrint 704 5)
					(ego use: 38)
					(ego get: 52)
					(++ elementalsStatus)
					(AddToScore 655 20)
					(SkillUsed 14 100)
				else
					(HighPrint 704 6)
				)
				(= cycles 5)
			)
			(3 (ego setCycle: Beg self))
			(4
				(ego view: 0 setCycle: StopWalk 4 setHeading: 0)
				(self dispose:)
			)
		)
	)
)

(instance earthElemDies of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(client
					view: 345
					y: (Max (client y?) 106)
					setLoop: 2
					cel: 0
					cycleSpeed: 1
					setCycle: End self
					setMotion: 0
				)
			)
			(1
				(localproc_0cba)
				(client setPri: 0 ignoreActors:)
				(LockEgo 1)
				(self dispose:)
			)
		)
	)
)

(instance earthElemHitByFlame of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(earthElem
					view: 345
					setLoop: 3
					cel: 0
					setMotion: 0
					setCycle: End self
				)
			)
			(1
				(earthElem setCycle: Beg self)
			)
			(2 (LockEgo 1) (self dispose:))
		)
	)
)

(instance earthElemSM of StateMachine
	(properties)
	
	(method (handleEvent pEvent)
		(if (and (Said 'attack>') (< state 3))
			(earthElem setScript: earthElemCombat)
			(self changeState: 3)
			(pEvent claimed: 1)
		else
			(super handleEvent: pEvent)
		)
		(pEvent claimed?)
	)
	
	(method (doState param1)
		(if (== param1 6)
			(earthElem dispose:)
			(= gGDftSC gAllSC)
			(self dispose:)
		)
		(switch state
			(0
				(UnlockEgo)
				(= gGDftSC earthElemSpellChecker)
				(earthElem posn: 155 94)
				(ego setLoop: 3 setMotion: MoveTo (ego x?) 176)
				(Print 704 7 #at -1 180 #dispose)
				(earthElem
					view: 345
					loop: 4
					cel: 0
					setCycle: End self
					priority: 5
					signal: 16
					barMessage: 0
					initCombat:
					hurtScript: 0
					deathScript: 0
					show:
				)
				(= cueState 1)
			)
			(1
				(LockEgo 1)
				(DisposeDialog)
				(ego setLoop: -1)
				(earthElem
					view: 345
					setLoop: 5
					cel: 0
					setCycle: SyncWalk
					setMotion: Approach ego 5
				)
				(self changeState: 2)
			)
			(2
				(cond 
					(
						(or
							(< (earthElem distanceTo: ego) 15)
							(< (- (ego y?) (earthElem y?)) 10)
						)
						(earthElem setScript: earthElemCombat)
						(self changeState: 3)
					)
					((== param1 1) (= cueState 1) (self setScript: earthElemHitByFlame self))
					((== param1 2) (self changeState: 4))
					((== param1 4) (= cueState 1) (= seconds 10) (earthElem setMotion: 0))
				)
			)
			(3
				(cond 
					((== param1 2) (self changeState: 4))
					((== param1 3)
						(UnlockEgo)
						(localproc_0cba)
						(earthElem
							endCombat:
							view: 345
							loop: 4
							cel: 9
							setCycle: Beg self
						)
						(= cueState 8)
					)
				)
			)
			(8
				(LockEgo 1)
				(earthElem dispose:)
				(self dispose:)
			)
			(4
				(= cueState 5)
				(earthElem
					health: 50
					stamina: 50
					setScript: earthElemDies self
				)
				((ScriptID 31 0) stop: dispose:)
				(gMiscMusic
					number: (earthElem endMusic?)
					priority: 6
					loop: 0
					play:
				)
				(= gGDftSC gAllSC)
			)
			(5
				(if (IsObject earthElem) (earthElem addToPic:))
				(self dispose:)
			)
		)
	)
)

(instance earthElemSpellChecker of Code
	(properties)
	
	(method (doit param1)
		(return
			(if (OneOf param1 28 6)
				(HighPrint 704 8)
				(return 0)
			else
				(return 1)
			)
		)
	)
)

(instance earthElemCombat of Script
	(properties)
	
	(method (changeState newState &tmp clientOpponent temp1)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(ego setScript: 0)
				(Print 704 9 #at -1 20 #dispose)
				(ego
					setMotion: TryToMoveTo 138 (+ (earthElem y?) 10) 10 self
				)
				(client setMotion: 0)
			)
			(1 (ego setHeading: 45 self))
			(2
				(DisposeDialog)
				(LockEgo 1)
				(client
					view: 345
					loop: 0
					cel: 0
					opponent: (ScriptID 32 0)
					barMessage: {"Rocky"}
					drawStatus:
				)
				(= gEgoIllegalBits (ego illegalBits?))
				(ego dispose:)
				((ScriptID 32 0)
					posn: (ego x?) (ego y?)
					opponent: earthElem
					barX: (- ((ScriptID 32 0) barX?) 5)
					initCombat:
				)
				(= seconds 3)
			)
			(3
				(= temp1 (Random 0 1))
				(client
					action: [local10 temp1]
					attDirection: [local8 temp1]
					setLoop: temp1
					cel: 0
				)
				(= cycles (Random 5 15))
			)
			(4 (client setCycle: End self))
			(5
				(= clientOpponent (client opponent?))
				(if
					(and
						(== (client action?) 1)
						(client tryAttack: clientOpponent 0)
					)
					(client doDamage: clientOpponent)
				)
				(= cycles 2)
			)
			(6 (client setCycle: Beg self))
			(7
				(if (== currentDay 12)
					(earthElemSM cue: 3)
				else
					(client action: 0 setLoop: 0)
					(self changeState: 3)
				)
			)
		)
	)
)

(instance harpoCrosses of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 2))
			(1
				(harpo posn: 107 80 init:)
				(Bset 144)
				(curRoom isMoving: 0)
				(ego setMotion: 0)
			)
			(2
				(HighPrint 704 10)
				(harpo
					setHeading: 90
					setCycle: Walk
					setMotion: MoveFwd 84 self
				)
				(curRoom nextTee: 0)
			)
			(3
				(harpo cel: 0)
				(Honk-Honk changeState: 0)
				0
			)
			(4
				(harpo dispose:)
				(self dispose:)
			)
		)
	)
)

(instance harpo of Actor
	(properties
		noun '/harpo,man,woman,girl'
		description {the funny-lookin' dude}
		lookStr {That strange man bears a striking resemblance to some of the other odd characters you've met around this city.}
		view 715
		signal $4000
		illegalBits $0000
	)
	
	(method (init)
		(super init:)
		(cast delete: self)
		(cast addToFront: self)
		(self setScript: Honk-Honk)
	)
)

(instance Honk-Honk of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(self doit:)
	)
	
	(method (doit)
		(super doit: &rest)
		(if
			(and
				(== (harpo view?) 715)
				(OneOf (harpo cel?) 2 4)
				(== ((harpo cycler?) cycleCnt?) 0)
			)
			(gSpareMusic
				number: 36
				loop: 1
				priority: 5
				vol: 127
				play:
			)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gSpareMusic
					number: 36
					loop: 1
					priority: 5
					vol: local20
					play:
				)
				(= cycles 2)
			)
			(1
				(gSpareMusic number: 36 loop: 1 priority: 5 play:)
				(= cycles 8)
			)
			(2
				(if (>= (++ local21) 4)
					(= local20 (- local20 30))
				else
					(= local20 (+ local20 30))
				)
				(cond 
					((== local21 3) (harpoCrosses cue:))
					((== local21 7) (harpoCrosses cue:))
					(else (self changeState: 0))
				)
			)
		)
	)
)

(instance detectee of TargActor
	(properties
		x 160
		y 38
		view 709
		priority 5
		signal $0010
	)
	
	(method (init)
		(super init: &rest)
		(self hide:)
	)
	
	(method (onMe)
		(return 0)
	)
	
	(method (cue)
		(self hide:)
		(LockEgo)
	)
	
	(method (detectMe &tmp temp0 temp1 temp2)
		(AddToScore 693 7 1)
		(if
			(and
				(== gEgoLocYCoord 36)
				(<= 38 gEgoLocXCoord)
				(<= gEgoLocXCoord 42)
			)
			(= temp2 0)
		else
			(= temp0 (- gEgoLocXCoord 40))
			(= temp1 (- gEgoLocYCoord 40))
			(cond 
				((< (* (Abs temp1) 3) (Abs temp0)) (if (< temp0 0) (= temp2 2) else (= temp2 6)))
				((> (Abs temp1) (* 3 (Abs temp0))) (= temp2 0))
				((< temp0 0) (= temp2 1))
				(else (= temp2 7))
			)
		)
		(if
			(<
				(= temp2
					(- temp2 (* 2 (- (curRoom facingHeading?) 1)))
				)
				0
			)
			(= temp2 (+ temp2 8))
		)
		(UnlockEgo)
		(self loop: [local12 temp2] show: setCycle: Full 10 self)
		(return 1)
	)
)
