;;; Sierra Script 1.0 - (do not remove this comment)
(script# 880)
(include sci.sh)
(use Main)
(use n001)
(use Stage)
(use Actor)
(use System)

(public
	cityRoom 0
)

(instance cityRoom of Stage
	(properties
		picture 780
		style $0008
		horizon 120
		north 380
		east 665
		south 665
		west 665
		topExit 3
		bottomExit 1
		rightFromY 180
		rightExit 4
		rightToY 180
		leftFromY 180
		leftExit 2
		leftToY 180
	)
	
	(method (init)
		(Bset 82)
		(ego init:)
		(if (or (== prevRoomNum 380) (Btst 28))
			(= prevRoomNum 380)
			(= inOut 3)
			(if (ego has: 50) (ChangeEgoWalk 3 0))
		)
		(self setRegions: 660)
		(super init: &rest)
		(if isNightTime
			(raseir loop: 1 cel: 0)
			(DrawFeature stellar1 stellar2)
		)
		(DrawFeature raseir)
		(if (== prevRoomNum 380)
			(ego posn: 150 97 setScript: (ScriptID 660 8))
			(if (and (ego has: 50) (not (Btst 89)))
				(Bset 89)
				(self setScript: delayedMessage)
			)
		)
	)
	
	(method (doit)
		(if
		(and (not (ego script?)) (& (ego onControl:) $0004))
			(ego setScript: (ScriptID 660 9))
		else
			(super doit:)
		)
	)
)

(instance raseir of PicView
	(properties
		x 135
		y 90
		noun '/city,city,wall,raseir'
		description {the city of Raseir}
		lookStr {The city of Raseir is dark with despair.}
		view 780
		loop 2
		cel 1
		priority 0
		signal $4010
	)
)

(instance stellar1 of PicView
	(properties
		x 208
		y 62
		noun '/star,constellation<dragon'
		description {the Dragon constellation}
		lookStr {The star pattern known as the Dragon.}
		view 660
		loop 2
		priority 0
		signal $6010
	)
)

(instance stellar2 of PicView
	(properties
		x 86
		y 26
		noun '/star,constellation<scorpion'
		description {the Scorpion constellation}
		lookStr {The sign of the Scorpion.}
		view 660
		loop 2
		cel 1
		priority 0
		signal $6010
	)
)

(instance delayedMessage of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 20))
			(1
				(HighPrint 880 0)
				(self dispose:)
			)
		)
	)
)
