;;; Sierra Script 1.0 - (do not remove this comment)
(script# 501)
(include sci.sh)
(use Main)
(use n001)
(use HandsOffScript)
(use Talker)
(use ProjClient)
(use TargActor)
(use Full)
(use n095)
(use LoadMany)
(use Motion)
(use Actor)
(use System)

(public
	LoseFinalBattle 0
	doBattleS 1
	proc501_2 2
	proc501_3 3
	iblisIsFreeS 4
	proc501_5 5
	comeAndGoS 6
	backInS 7
	getCandleS 8
	kickCandleS 9
	fightHurtS 10
	djS 11
)

(procedure (LoseFinalBattle param1)
	(switch param1
		(0
			(HighPrint 501 0 80 {Statue of Limitations})
		)
		(1 (Die 1 501 1 80 {Rocky}))
		(2
			(Die 1 501 2 80 {Standing Aground?})
		)
		(3
			(HighPrint 501 3 80 {MisSpelling})
		)
		(4
			(Die 1 501 4 80 {See? We Know Some Big Words!})
		)
		(5
			(Die 1 501 5 80 {Indirectly Dead})
		)
		(6
			(Die 1 501 6 80 {Role Reversal})
		)
	)
)

(procedure (proc501_2)
	(LoadMany 128 22 465 504 508 511 556 31 32)
	(LoadMany 132 13 14 15 16 17 18 31 34 35)
	(LoadMany 130 63 64 65)
)

(procedure (proc501_3)
	(LoadMany 128 80 41 509)
	(LoadMany 132 54 55 23)
	(LoadMany 130 30 31 32 24)
)

(procedure (proc501_5)
	(floor init: stopUpd:)
	(wall init: stopUpd:)
	(iblisStatue init:)
	(DrawFeature moon)
)

(instance doBattleS of Script
	(properties)
	
	(method (changeState newState &tmp clientOpponent temp1 temp2 temp3)
		(switch (= state newState)
			(0 (= cycles 3))
			(1
				(switch arcadeDifficultyLevel
					(1 (= cycles (Random 12 15)))
					(2 (= cycles (Random 8 11)))
					(3 (= cycles (Random 4 7)))
				)
			)
			(2
				(if
					(= temp1
						(switch (= temp3 ((client opponent?) loop?))
							(0 (Random 2 3))
							(1 0)
							(2 0)
							(3 2)
							(4 2)
							(5 2)
							(6 2)
							(7 2)
							(8 2)
							(9 (Random 2 3))
							(10 (Random 2 3))
							(11 3)
						)
					)
					(client setLoop: temp1 cel: 0 setCycle: End self)
				else
					(self changeState: 5)
				)
			)
			(3
				(switch ((client opponent?) loop?)
					(0 (= register 3))
					(1 (= register 0))
					(2 (= register 0))
					(3 (= register 3))
					(4 (= register 3))
					(5 (= register 3))
					(6 (= register 7))
					(7 (= register 7))
					(8 (= register 3))
					(9 (= register 0))
					(10 (= register 0))
					(11 (= register 3))
				)
				(= clientOpponent (client opponent?))
				(= temp2 (if (== register 7) 20 else 50))
				(if register (client doDamage: clientOpponent temp2 1))
				(= cycles 2)
			)
			(4
				(client setCycle: CT 3 -1 self)
			)
			(5
				(client setLoop: 0 setCycle: Fwd)
				(self changeState: 0)
			)
		)
	)
)

(instance iblisIsFreeS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(DjinniSpeaks 501 7)
				(= seconds 3)
			)
			(1
				(ShakeScreen 2 2)
				(iblisSmoke init: cel: 0 setCycle: End self)
			)
			(2
				(LoseFinalBattle register)
				(curRoom newRoom: 790)
			)
		)
	)
)

(instance floor of TargActor
	(properties
		view 501
		loop 11
		signal $4010
	)
	
	(method (onMe param1)
		(return (& (OnControl 4 (param1 x?) (param1 y?)) $0400))
	)
	
	(method (hurtMe param1 param2 &tmp temp0)
		(if (== (param2 type?) 25) (HighPrint 501 8))
	)
)

(instance wall of TargActor
	(properties
		view 501
		loop 11
		signal $4010
	)
	
	(method (onMe param1)
		(return (& (OnControl 4 (param1 x?) (param1 y?)) $2000))
	)
	
	(method (hurtMe param1 param2 &tmp newProjectile)
		(return
			(switch (param2 type?)
				(25 (HighPrint 501 9))
				(27
					(if (> (ego x?) 170)
						(DjinniSpeaks 501 10)
					else
						((= newProjectile (Projectile new:))
							type: (param2 type?)
							damage: param1
							xStart: hitX
							yStart: hitY
							x: 124
							y: (if (> (ego y?) 130) 102 else (ego y?))
						)
						(Bset 147)
						(self setScript: newProjectile self 0)
					)
					(return 0)
				)
			)
		)
	)
)

(instance comeAndGoS of Script
	(properties)
	
	(method (changeState newState &tmp [temp0 4])
		(switch (= state newState)
			(0
				(client show: posn: (ego x?) (ego y?) setCycle: Fwd)
				(ego loop: 3 heading: 0)
				(= cycles (if register else 9))
			)
			(1
				(client hide:)
				(self dispose:)
			)
		)
	)
)

(instance backInS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(DjinniSpeaks 501 11)
				(if register
					(ego setMotion: MoveTo 230 180 self)
				else
					(ego setMotion: MoveTo (+ mouseX 20) mouseY self)
				)
			)
			(1 (self dispose:))
		)
	)
)

(instance getCandleS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(FaceObject ego register 0 self)
			)
			(1
				(ego
					view: 47
					cel: 0
					loop: (> (ego x?) (register x?))
					setCycle: End self
				)
			)
			(2
				(if (> (register xStep?) (curRoom notify:))
					(register hide: posn: -10 -10)
					(curRoom notify: -2)
					(= register 1)
				else
					(DjinniSpeaks 501 12)
					(= register 0)
				)
				(ego setCycle: Beg self)
			)
			(3
				(if register (curRoom notify: -1))
				(proc1_19)
				(self dispose:)
			)
		)
	)
)

(instance kickCandleS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setMotion: MoveTo (register x?) (+ (register y?) 3) self
				)
			)
			(1
				(ego
					cel: 1
					setMotion: MoveTo (- (register x?) 18) (+ (register y?) 6) self
				)
				(cond 
					((== (curRoom notify:) 5) (DjinniSpeaks 501 13) (self dispose:))
					((> (register xStep?) (curRoom notify:))
						(register
							setStep: 6 4
							setMotion: MoveTo (- (register x?) 30) (- (register y?) 10)
							setCycle: End
						)
						(= register 1)
						(curRoom notify: -2)
					)
					(else (curRoom notify: -3) (= register 0))
				)
			)
			(2
				(if register (curRoom notify: -1))
				(self dispose:)
			)
		)
	)
)

(instance fightHurtS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp [temp0 2])
		(switch (= state newState)
			(0
				((ScriptID 32 0)
					canFight: 0
					action: 7
					setCycle: 0
					setMotion: 0
					setLoop: -1
					loop: 2
					cel: 0
					setCycle: End self
				)
				(if (client respondsTo: #nextMove) (client nextMove: 0))
			)
			(1
				(client setCel: 1)
				(= cycles
					(switch gSeconds
						(0 2)
						(1 4)
						(2 6)
						(3 8)
					))
			)
			(2
				((ScriptID 32 0) loop: 1 cel: 1 setCycle: End self)
			)
			(3
				((ScriptID 32 0) canFight: 1 action: 0 loop: 0)
				(self dispose:)
			)
		)
	)
)

(instance djS of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp [temp0 2])
		(switch (= state newState)
			(0
				(dj
					init:
					setLoop: 1
					cel: 0
					setPri: 12
					posn: (+ mouseX 22) (- mouseY 23)
					setCycle: End self
				)
			)
			(1
				(dj
					setLoop: 2
					setCycle: Fwd
					setMotion: MoveTo 159 135 self
				)
			)
			(2
				(iblisStatue dispose:)
				(FaceObject ego dj)
				(Say dj self 501 14)
			)
			(3
				(dj setLoop: 6 cel: 0 cycleSpeed: 0 setCycle: End self)
			)
			(4 (= seconds 3))
			(5 (dj setCycle: Beg self))
			(6
				(Say dj self 501 15 501 16 501 17 501 18)
			)
			(7 (Say dj self 501 19))
			(8 (dj setCycle: End self))
			(9
				(ego view: 50 cel: 0 setCycle: End self)
			)
			(10 (curRoom newRoom: 820))
		)
	)
)

(instance iblisStatue of TargActor
	(properties
		x 159
		y 133
		view 613
	)
	
	(method (cue)
		(super cue:)
		(DjinniSpeaks 501 20)
	)
	
	(method (detectMe)
		(HighPrint 501 22)
	)
	
	(method (fetchMe)
		(self cue:)
		(return 0)
	)
	
	(method (hurtMe param1 param2)
		(if (OneOf (param2 type?) 25 27)
			(self cue:)
			(self setCycle: Full 1)
			(return 0)
		else
			(DjinniSpeaks 501 21)
		)
		(return 0)
	)
	
	(method (openMe)
		(self cue:)
	)
	
	(method (triggerMe)
		(self cue:)
	)
)

(instance iblisSmoke of Prop
	(properties
		x 159
		y 117
		view 502
		priority 9
		signal $4010
		cycleSpeed 3
	)
)

(instance dj of Talker
	(properties
		x 174
		y 120
		description {the djinni}
		lookStr {Do you mind if I'm smoke?}
		view 612
		loop 1
		priority 12
		signal $4810
		cycleSpeed 3
		illegalBits $0000
		tLoop 3
		talkSpeed 1
		myName '//djinn'
		title {Djinni:}
		color 1
		back 13
	)
)

(instance moon of PicView
	(properties
		x 158
		y 46
		noun '/moon'
		description {the moon}
		lookStr {The moon is brighter than you have ever seen it.}
		view 507
	)
)
