;;; Sierra Script 1.0 - (do not remove this comment)
(script# 655)
(include sci.sh)
(use Main)
(use n001)
(use HandsOffScript)
(use Monster)
(use Music)
(use Motion)
(use Actor)
(use System)

(public
	griffin 0
)

(procedure (localproc_0b52 param1 param2 param3)
	(while (< param2 190)
		(if (& (OnControl 2 param1 param2) param3) (break))
		(++ param2)
	)
	(if (== param2 190) (= param2 0))
	(return param2)
)

(instance griffin of Monster
	(properties
		x -100
		y -100
		noun '/griffin'
		description {the Griffin}
		lookStr {It is a mean, nasty, agitated, about-to-rip-your-head-off Griffin.}
		yStep 6
		view 655
		signal $2800
		xStep 9
		strength 150
		intell 70
		agil 120
		vit 130
		luck 100
		weap 120
		parry 50
		dodge 80
		armorValue 2
		weapValue 6
		barMessage {Griffin}
		battleMusic 54
		endMusic 55
	)
	
	(method (init)
		(= battleMusic 54)
		(Load rsVIEW 810)
		(Load rsSCRIPT 32 24)
		(= gHealth gGHealth)
		(super init:)
		(leftWing
			x: x
			y: (- y 25)
			cycleSpeed: 1
			setCycle: Fwd
			init:
		)
		(rightWing
			x: (+ x 3)
			y: (- y 25)
			cycleSpeed: 1
			setCycle: Fwd
			init:
		)
	)
	
	(method (doit)
		(if ((leftWing cycler?) cycleCnt?)
			(switch (leftWing cel?)
				(0
					(= z 2)
					(leftWing z: 2)
					(rightWing z: 2)
				)
				(1
					(leftWing z: (= z 4))
					(rightWing z: 4)
				)
				(2
					(= z 0)
					(leftWing z: 0)
					(rightWing z: 0)
				)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(leftWing dispose:)
		(rightWing dispose:)
		(griffinSound dispose:)
		(super dispose:)
		(= gGHealth gHealth)
	)
	
	(method (hurtMe)
		(return
			(if (!= script griffinCombatS)
				(return 0)
			else
				(super hurtMe: &rest)
			)
		)
	)
	
	(method (initCombat)
		(= combatScript griffinCombatS)
		(= hurtScript griffinHurtS)
		(= deathScript griffinDeathS)
		((ScriptID 32 1)
			x: (griffin x?)
			y: (- (griffin y?) 20)
		)
		(super initCombat: &rest)
	)
	
	(method (initAmbush)
		(= ambushScript griffinAmbushS)
		(super initAmbush: &rest)
	)
)

(instance leftWing of Prop
	(properties
		view 655
		loop 1
		signal $6000
	)
	
	(method (doit)
		(= x (griffin x?))
		(= y (- (griffin y?) 25))
		(super doit:)
	)
)

(instance rightWing of Prop
	(properties
		view 655
		loop 2
		signal $6000
	)
	
	(method (doit)
		(= x (+ (griffin x?) 3))
		(= y (- (griffin y?) 25))
		(super doit:)
	)
)

(instance griffinCombatS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(griffin setLoop: (Random 3 4) setCel: 0)
				(= cycles (Random 5 15))
			)
			(1 (griffin setCycle: End self))
			(2
				(if (griffin tryAttack: (ScriptID 32 0) 0)
					(griffin doDamage: (ScriptID 32 0))
				)
				(= cycles 2)
			)
			(3 (griffin setCycle: Beg self))
			(4
				(if
				(and ((ScriptID 32 0) barHealth?) (Random 0 3))
					(self changeState: 0)
				else
					((ScriptID 32 0) canFight: 0)
					(griffin setScript: flyAwayS 0 0)
				)
			)
		)
	)
)

(instance griffinAmbushS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 4))
			(1
				(if (ego script?)
					((ego script?) caller: self)
				else
					(= cycles 1)
				)
			)
			(2
				(if (Random 0 1)
					(littleGriffin
						setLoop: 0
						x: -30
						setCycle: Fwd
						setMotion: MoveTo 35 40 self
						init:
					)
				else
					(littleGriffin
						setLoop: 1
						x: 350
						setCycle: Fwd
						setMotion: MoveTo 285 40 self
						init:
					)
				)
			)
			(3
				(ego setMotion: 0 setHeading: 0)
				(if (> (littleGriffin x?) 160)
					(littleGriffin setMotion: MoveTo -30 40 self)
				else
					(littleGriffin setMotion: MoveTo 350 40 self)
				)
			)
			(4
				(cond 
					((< (ego x?) 70) (ego setMotion: MoveTo 70 (ego y?) self))
					((> (ego x?) 220) (ego setMotion: MoveTo 220 (ego y?) self))
					(else (= cycles 8))
				)
				(littleGriffin dispose:)
			)
			(5
				(griffinSound number: (griffin battleMusic?) play:)
				(= register (> (ego x?) 160))
				(griffin
					battleMusic: 0
					setCel: register
					posn: (if register 40 else 260) -150
					setMotion: MoveTo (+ (ego x?) 30) (- (ego y?) 20)
				)
				(= cycles 12)
			)
			(6
				(ego setMotion: 0 hide:)
				((ScriptID 32 0)
					posn: (ego x?) (ego y?)
					opponent: griffin
					initCombat:
				)
				(griffin
					setMotion: MoveTo (+ (ego x?) 30) (- (ego y?) 20) self
				)
			)
			(7
				(if (and suckBlueFrog (ego mover?))
					(InspectObj (ego mover?))
				)
				(client initCombat:)
			)
		)
	)
)

(instance griffinHurtS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(griffin setLoop: 5 setCel: 0)
				(= cycles 2)
			)
			(1 (griffin setCycle: End self))
			(2
				(if (Random 0 2)
					(client setScript: griffinCombatS)
				else
					(client setScript: flyAwayS 0 0)
				)
			)
		)
	)
)

(instance griffinDeathS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(self setScript: flyAwayS self 1)
			)
			(1 (= cycles 10))
			(2
				(griffinSound number: (griffin endMusic?) play:)
				(ego setHeading: 0)
				(littleGriffin
					loop: 2
					posn: 150 -50
					setPri: 1
					yStep: 6
					init:
					setCycle: Fwd
					setMotion: MoveTo 150 150 self
				)
			)
			(3
				(littleGriffin dispose:)
				(gMiscMusic number: 12 priority: 10 loop: 0 play:)
				(shroomCloud
					y: (localproc_0b52 150 1 8)
					init:
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(4
				(shroomCloud dispose:)
				(ego setHeading: 180 self)
			)
			(5
				(ego view: 50 setLoop: 0 setCycle: End self)
			)
			(6 (= cycles 20))
			(7
				(proc1_19)
				(griffin endCombat: dispose:)
			)
		)
	)
)

(instance flyAwayS of Script
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(griffinSound number: 23 play:)
				(leftWing cycleSpeed: 0)
				(rightWing cycleSpeed: 0)
				(griffin
					setLoop: 0
					setCel: 0
					setMotion: MoveTo 40 -50 self
				)
			)
			(1
				(if (not register) (griffin endCombat: dispose:))
				(= monsterInRoom 0)
				((ScriptID 32 0) endCombat: dispose:)
				(ego show:)
				(Bset 143)
				(self dispose:)
			)
		)
	)
)

(instance littleGriffin of Actor
	(properties
		y 40
		noun '/griffin,bird'
		description {the Griffin}
		lookStr {Uh-oh, looks like trouble...}
		view 654
		signal $6000
		illegalBits $0000
		xStep 7
	)
)

(instance shroomCloud of Prop
	(properties
		x 145
		y 107
		view 654
		loop 3
		priority 1
		signal $6010
	)
)

(instance griffinSound of Sound
	(properties
		priority 6
		loop 0
	)
)
