;;; Sierra Script 1.0 - (do not remove this comment)
(script# 475)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use TopWindow)
(use Monster)
(use Warrior)
(use n095)
(use Intrface)
(use Polygon)
(use Timer)
(use Motion)
(use Actor)
(use System)

(public
	khaveen 0
	rm470Warrior 1
)

(local
	[local0 8] = [1 0 2 1 0 2 0 2]
	[local8 8] = [1 1 1 2 2 2 3 3]
	theMonster
	theWarrior
	[local18 12] = [163 131 221 117 223 125 231 125 232 132 178 150]
	local30
	local31
	local32
	local33
	local34
	local35
	local36
	local37
	local38
)
(procedure (localproc_0042)
	(PrintWarning &rest 35 khaveenWindow 80 {Khaveen:})
)

(instance khaveenWindow of BotWindow
	(properties
		color 7
		back 0
	)
)

(instance khaveen of Monster
	(properties
		x 165
		y 145
		noun '/khaveen,guard,man,captain'
		description {Khaveen}
		lookStr {It is Khaveen.}
		view 475
		strength 125
		intell 125
		agil 125
		vit 125
		luck 125
		weap 125
		parry 125
		dodge 125
		armorValue 5
		armorEnc 20
		shieldValue 20
		weapValue 8
		battleMusic 0
		endMusic 0
	)
	
	(method (hurtMe)
		(if (== (++ local34) 3) (self strength: 250 agil: 250))
		(super hurtMe: &rest)
	)
	
	(method (doDamage param1)
		(if local36
			(param1 hurtMe: 0 self)
		else
			(super doDamage: param1 &rest)
		)
	)
	
	(method (initCombat)
		(= theMonster self)
		(= combatScript doBattle)
		(super initCombat: &rest)
		(= opponent rm470Warrior)
		(= deathScript doneFight)
	)
)

(instance doBattle of Script
	(properties)
	
	(method (changeState newState &tmp clientOpponent temp1)
		(switch (= state newState)
			(0 (= seconds 2))
			(1
				(if
				(and local31 (not local32) (!= (rm470Warrior loop?) 1))
					(= local32 1)
					(= local31 0)
					(rm470Warrior endCombat: setScript: egoFlips)
					(khaveen
						endCombat:
						setScript: 0
						strength: 125
						intell: 125
						agil: 125
						vit: 125
						luck: 125
						weap: 125
						parry: 125
						dodge: 125
						magic: 0
					)
				else
					(switch arcadeDifficultyLevel
						(1 (= cycles (Random 12 15)))
						(2 (= cycles (Random 8 11)))
						(3 (= cycles (Random 4 7)))
					)
				)
			)
			(2
				(= temp1
					(switch ((khaveen opponent?) loop?)
						(0 (Random 3 5))
						(1 0)
						(2 0)
						(3 6)
						(4 10)
						(5 9)
						(6 3)
						(7 4)
						(8 4)
						(9 3)
						(10 5)
					)
				)
				(client
					action: [local8 (- temp1 3)]
					attDirection: [local0 (- temp1 3)]
					setLoop: temp1
					cel: 0
					setCycle: End self
				)
			)
			(3
				(= clientOpponent (client opponent?))
				(if
					(and
						(== (client action?) 1)
						(client tryAttack: clientOpponent 0)
					)
					(client doDamage: clientOpponent 0 1)
				)
				(= cycles 2)
			)
			(4 (client setCycle: Beg self))
			(5
				(client action: 0 setLoop: 0)
				(self changeState: 1)
			)
		)
	)
)

(instance rm470Warrior of Warrior
	(properties)
	
	(method (hurtMe)
		(if (not local32) (++ local31))
		(super hurtMe: &rest)
	)
	
	(method (die)
		(= local32 1)
		(gMiscMusic number: 55 loop: 1 play:)
		(super die:)
	)
	
	(method (initCombat)
		(= theWarrior self)
		(super initCombat: &rest)
		(= deathScript dropDead)
		(= attackScript rm470Attacks)
		(= opponent khaveen)
	)
)

(instance doneFight of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(LockEgo)
		(proc1_19)
		(ego
			x: (+ (ego x?) 8)
			y: (+ (ego y?) 2)
			illegalBits: (| (ego illegalBits?) $4000)
			setHeading: 45
		)
		(khaveenPoly points: @local18 size: 6)
		(curRoom addObstacle: khaveenPoly)
		(curRoom notify: 58)
	)
	
	(method (changeState newState &tmp theWarriorX theWarriorY)
		(switch (= state newState)
			(0
				(gMiscMusic number: 55 loop: 1 play:)
				(if local35
					(theMonster view: 474 setLoop: 5 setCel: 0)
				else
					(theMonster view: 475 setLoop: 2 setCel: 0)
				)
				(= cycles 2)
			)
			(1
				(theMonster setCycle: End self)
			)
			(2
				(HighPrint 475 0)
				(theMonster setPri: 9 stopUpd:)
				(= theWarriorX (theWarrior x?))
				(= theWarriorY (theWarrior y?))
				(theWarrior endCombat: dispose:)
				(ego
					view: 83
					setLoop: 0
					setCel: 6
					x: theWarriorX
					y: theWarriorY
					init:
					cycleSpeed: 1
					setCycle: Beg self
				)
			)
			(3 (self dispose:))
		)
	)
)

(instance dropDead of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp [temp0 2])
		(switch (= state newState)
			(0
				(theWarrior loop: 2 cel: 0)
				(= cycles 2)
			)
			(1
				(theWarrior setCycle: End self)
			)
			(2
				(PrintWarning 475 1)
				(curRoom setScript: (ScriptID 470 1))
				(self dispose:)
			)
		)
	)
)

(instance khaveenFlips of HandsOffScript
	(properties)
	
	(method (init)
		(gDirH addToFront: self)
		(super init: &rest)
	)
	
	(method (dispose)
		(super dispose:)
		(if (not local35)
			(rm470Warrior canFight: 1 initCombat:)
			(khaveen view: 475 loop: 0 canFight: 1 initCombat:)
			(= local36 1)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				0
				(= local34 50)
				(rm470Warrior canFight: 0 view: 473 setLoop: 0 cel: 0)
				(= cycles 1)
			)
			(1
				1
				(rm470Warrior setCycle: End)
				(khaveen view: 474 setLoop: 1 cel: 0 setCycle: End self)
			)
			(2
				2
				(rm470Warrior setCel: 3)
				(sword
					view: 474
					setLoop: 2
					x: 165
					y: 80
					yStep: 10
					init:
					setPri: 15
					setCycle: Fwd
					setMotion: MoveTo 169 10 self
				)
			)
			(3
				3
				(sword setMotion: MoveTo 172 100 self)
			)
			(4
				(sword setMotion:)
				(khaveen setLoop: 3 cel: 0 setCycle: End)
			)
			(5
				5
				(sword setCel: 3 setCycle: 0 setPri: -1)
				(= cycles 2)
			)
			(6
				6
				(HighPrint 475 8)
				(= approachCode self)
				(rm470Warrior view: 80 loop: 0 setCel: -1)
				(LockEgo)
				(= seconds 10)
			)
			(7
				7
				(gDirH delete: self)
				(SkillUsed 14 200)
				(AddToScore 680 7 3)
				(= approachCode 0)
				(rm470Warrior view: 473 setLoop: 6 cel: 0 setCycle: End)
				(= cycles 15)
			)
			(8
				8
				(if (< local37 3) (rm470Warrior setCycle: Beg))
				(khaveen setLoop: 4 cel: 0 setCycle: CT 4 1 self)
			)
			(9
				9
				(rm470Warrior view: 80 loop: 0 setCel: -1)
				(sword dispose:)
				(khaveen setCycle: End self)
			)
			(10 10 (self dispose:))
			(11
				11
				(ProclaimedHonorless)
				(= approachCode 0)
				(rm470Warrior setLoop: 4 setCycle: End self)
			)
			(12
				12
				(= local35 1)
				(khaveen die:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(if (== state 6)
			(cond 
				(
					(or
						(Said 'gave,get,acquire,(lockpick<up)/blade,weapon')
						(Said
							'let,gave/khaveen,man,captain,fighter,swordsman[/blade,weapon]'
						)
					)
					(self changeState: 7)
					(gDirH delete: self)
					(= seconds 0)
				)
				(
					(Said
						'kill,attack,chop,beat[/man,khaveen,captain,fighter,swordsman]'
					)
					(= seconds 0)
					(gDirH delete: self)
					(self changeState: 11)
				)
				((Said 'resign,resign,(gave<up)')
					(switch (++ local37)
						(1 (localproc_0042 475 2))
						(2 (localproc_0042 475 3))
						(3
							(= approachCode 0)
							(self changeState: 8)
						)
					)
				)
				(
					(or
						(== (pEvent message?) JOY_UP)
						(== (pEvent message?) JOY_UPRIGHT)
						(== (pEvent message?) JOY_UPLEFT)
					)
					(self changeState: 11)
					(gDirH delete: self)
				)
				((Said 'throw') (HighPrint 475 4))
				((Said 'cast') (HighPrint 475 5))
				((Said 'look,examine') (HighPrint 475 6))
				(else (DjinniSpeaks 475 7) (pEvent claimed: 1))
			)
		else
			(pEvent claimed: 1)
		)
	)
)

(instance egoFlips of Script
	(properties)
	
	(method (dispose)
		(super dispose:)
		(if (not local38)
			(rm470Warrior view: 80 loop: 0 canFight: 1 initCombat:)
			(khaveen view: 475 loop: 0 canFight: 1 initCombat:)
			(= local33 local34)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(khaveen canFight: 0 view: 474 setLoop: 0 setCel: 0)
				(= cycles 1)
			)
			(1
				(khaveen setCel: 1)
				(rm470Warrior view: 473 setLoop: 4 setCel: 0)
				(= cycles 1)
			)
			(2
				(khaveen setCel: 2)
				(rm470Warrior setCel: 1)
				(= cycles 1)
			)
			(3
				(khaveen setCel: 3)
				(rm470Warrior setCel: 2)
				(= cycles 1)
				(sword
					view: 473
					setLoop: 5
					x: 152
					y: 99
					setPri: 15
					yStep: 10
					init:
					setCycle: Fwd
					setMotion: MoveTo 152 10 self
				)
			)
			(4
				(khaveen setCel: 4)
				(rm470Warrior setCycle: End)
			)
			(5
				(sword setMotion: MoveTo 150 90 self)
			)
			(6
				(sword setPri: 5 setMotion: MoveTo 147 148 self)
			)
			(7
				(sword setCel: 3 setPri: 2 setCycle: 0)
				(= cycles 2)
			)
			(8
				(HighPrint 475 12)
				(localproc_0042 475 13)
				(localproc_0042 475 14)
				(yieldTimer setReal: yieldTimer 6)
				(= approachCode self)
			)
			(9
				(= approachCode 0)
				(rm470Warrior setLoop: 7 setCel: 0 setCycle: CT 3 1 self)
			)
			(10
				(sword dispose:)
				(rm470Warrior setCycle: End self)
				(khaveen view: 475 setLoop: 3 setCel: 0 setCycle: End)
			)
			(11
				(DjinniSpeaks 475 15)
				(= cycles 8)
			)
			(12 (self dispose:))
			(13
				(= local38 1)
				(gMiscMusic number: 55 loop: 1 play:)
				(cast eachElementDo: #hide)
				(curRoom drawPic: 2)
				(= cycles 2)
			)
			(14
				(Print 475 16)
				(curRoom setScript: (ScriptID 470 1))
			)
		)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if (== state 8)
			(cond 
				(
					(or
						(Said 'get,acquire,(lockpick<up)/blade,weapon')
						(Said 'n')
					)
					(self changeState: 9)
					(= seconds 0)
					(yieldTimer dispose:)
				)
				((Said 'throw') (HighPrint 475 4))
				(
					(Said
						'kill,attack,chop,beat[/man,khaveen,captain,fighter,swordsman]'
					)
					(HighPrint 475 9 25 4)
				)
				((Said 'affirmative,resign,resign,(gave<up)')
					(= seconds 0)
					(yieldTimer dispose:)
					(self changeState: 13)
				)
				((Said 'cast') (HighPrint 475 5))
				((Said 'look,examine') (HighPrint 475 6))
				(
					(or
						(Said 'attack,kill,beat,chop')
						(Said 'use/blade,dagger,weapon')
						(Said 'parry,defend,block')
						(Said 'use/shield')
					)
					(HighPrint 475 10)
				)
				(
					(or
						(Said 'escape,escape,(run<away)')
						(Said 'dodge,hop')
					)
					(HighPrint 475 11)
				)
				(else (DjinniSpeaks 475 7) (pEvent claimed: 1))
			)
		else
			(pEvent claimed: 1)
		)
	)
)

(instance sword of Actor
	(properties
		priority 15
		signal $6810
		illegalBits $0000
	)
)

(instance rm470Attacks of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp clientOpponent temp1)
		(switch (= state newState)
			(0
				(if (and (== local34 (+ local33 2)) local32)
					(++ local34)
					(rm470Warrior setScript: 0 endCombat:)
					(khaveen endCombat: setScript: khaveenFlips)
				else
					(client forceUpd:)
					(= cycles 1)
				)
			)
			(1 (client setCycle: End self))
			(2
				(= clientOpponent (client opponent?))
				(client getTired: 5)
				(if (> register 5) (= register 5))
				(= temp1 (- (* register 30) 50))
				(TestSkill 5 0 temp1)
				(if
				(and client (client tryAttack: clientOpponent temp1))
					(client doDamage: clientOpponent)
				)
				(= cycles 2)
			)
			(3 (client setCycle: Beg self))
			(4
				(client action: 0 setLoop: 0)
				(self dispose:)
			)
		)
	)
)

(instance yieldTimer of Timer
	(properties)
	
	(method (cue)
		(if local30
			(localproc_0042 475 17)
			(Die 1 475 18 80 {Khaveen skewers you})
		else
			(localproc_0042 475 19)
			(= local30 1)
			(self setReal: self 6)
		)
		(super cue:)
	)
)

(instance khaveenPoly of Polygon
	(properties
		type $0002
	)
)
