;;; Sierra Script 1.0 - (do not remove this comment)
(script# 2)
(include sci.sh) (include game.sh)
(use Main)
(use n001)
(use Talker)
(use Intrface)
(use Printd)
(use LoadMany)
(use User)
(use Menu)
(use System)

(public
	SetGraphicsSoundInit 0
	SetGameInit 1
	proc2_2 2
	EatItem 3
	DrinkItem 4
	Sleep 5
	Rest 6
	TestSkill 7
	SkillUsed 8
	CanPickLocks 9
	ReduceSP 10
	ReduceMP 11
	ReduceHP 12
	AddToScore 13
	PrintGameTime 14
	SetGameTime 15
	GameTimeEvents 16
	IncrementGameDay 17
	EatRation 18
	proc2_19 19
	AnswerQuestion 20
	proc2_21 21
	proc2_22 22
	BlueFrogTP 23
	UsePill 24
	DrinkWater 25
	ProclaimedHonorless 26
	PaladinCheck 27
	SayThanks 28
	GiveFlowers 29
	PickLock 30
)

(procedure (SetGraphicsSoundInit)
	(= suckBlueFrog 0)
	(= musicChannels (DoSound sndDISPOSE))
	(if (< (= colorCount (Graph grGET_COLOURS)) 8)
		(= hpStatusView 811)
		(= hpFontColor 15)
		(= statColor 0)
		(= statColorNew 4)
	else
		(= hpStatusView 810)
		(= hpFontColor 11)
		(= statColor 9)
		(= statColorNew 12)
	)
	(DoSound sndINIT 15)
	(Joystick 12 0)
)

(procedure (SetGameInit &tmp temp0 temp1)
	(= cSoundDeath 10)
	(= showStyle 0)
	(= possibleScore 500)
	(= userFont 300)
	(= smallFont 999)
	(= bigFont 300)
	(= spRefreshCountdown 20)
	(= hpRefreshCountdown 15)
	(= mpRefreshCountdown 5)
	(Bset 1)
	(= currentDay 1)
	(SetGameTime 8)
	(= sillyClowns 0)
	(= arcadeDifficultyLevel 2)
	(= gameTimeScale 1)
	(= temp0 0)
	(if (and suckBlueFrog 1)
		(= temp1 0)
		(while (< temp1 30)
			(= [skills temp1] 80)
			(++ temp1)
		)
		(= [skills skEXPERIENCE] 1900)
		(= [skills skHP] (GetMaxHealth))
		(= [skills skSP] (GetMaxStamina))
		(= [skills skMP] (GetMaxMana))
		(= [invNum invGoldCoin] 100)
		(= [invNum invFoodRation] 10)
		(= [invNum invWaterskin] 1)
		(= currentWater 10)
		(StrCpy @userName {Hero})
		(Bset EVENT_PLAYINGTHEGAME)
		(= temp0 (BlueFrogTP))
	else
		(Bclr EVENT_PLAYINGTHEGAME)
	)
	(if (not temp0)
		(if (GameIsRestarting)
			(= temp0 765)
		else
			(= temp0 764)
		)
	)
	(return temp0)
)

(procedure (proc2_2 param1 &tmp [temp0 2] newEvent)
	(theGame setCursor: waitCursor 1)
	(while ((= newEvent (Event new:)) type?)
		(newEvent dispose:)
	)
	(newEvent dispose:)
	(if
		(OneOf
			param1
			764
			765
			750
			770
			785
			800
			810
			805
			98
			850
			820
			821
			822
		)
		(MenuBar hide: state: 0)
	else
		(MenuBar draw:)
	)
	(DisposeDialog)
	(LoadMany
		0
		21
		322
		321
		491
		30
		32
		31
		670
		171
		685
		175
		273
		675
		695
		680
		655
		660
		381
		953
		951
		985
		946
		475
		61
		62
		63
		64
		65
		70
		71
		25
		60
		116
		117
		88
		241
		973
		988
		959
		95
		700
		701
		702
		80
		81
		83
		85
		89
		90
		86
		84
		87
		78
		82
		79
		75
		91
		3
		77
		96
		93
		24
		72
		956
		951
		991
		968
		969
		972
		971
		970
		945
		949
		940
	)
	(gMouseH release:)
	(gKeyH release:)
	(gDirH release:)
	(SetGameTime)
	(if isNightTime
		(= defaultPalette (| defaultPalette $0001))
	else
		(= defaultPalette (& defaultPalette $fffe))
	)
	(if (== param1 820)
		(Bclr EVENT_PLAYINGTHEGAME)
		(SetGameTime 12 0)
		(= isNightTime FALSE)
		(= defaultPalette 0)
	)
	(= global166 (= gLevMe 0))
	(if (not monsterInRoom) (= daggersInMonster 0))
)

(procedure (EatItem param1 &tmp temp0)
	(= temp0 0)
	(cond 
		(mealsPreEaten (param1 claimed: 1) (HighPrint 2 0))
		((Said '/fruit')
			(if (ego has: invCompassionFruit)
				(ego use: invCompassionFruit)
				(HighPrint 2 1)
				(= temp0 1)
			else
				(HighPrint 2 2)
			)
		)
		(
		(or (Said '/provision,food') (Said 'eat,chew[/!*]'))
			(if (ego has: invFoodRation)
				(ego use: invFoodRation 1)
				(HighPrint 2 3)
				(= temp0 1)
			else
				(HighPrint 2 4)
			)
		)
		(else (param1 claimed: 1) (HighPrint 2 5))
	)
	(if temp0
		(if (Btst EVENT_HEROISGETTINGHUNGRY)
			(Bclr EVENT_HEROISGETTINGHUNGRY)
			(Bclr EVENT_HEROISSTARVING)
		else
			(= mealsPreEaten 1)
		)
	)
)

(procedure (DrinkItem param1 param2)
	(cond 
		((or (== param2 invWaterskin) (Said '/water')) (DrinkWater 1))
		((Said '/potion,grease') (HighPrint 2 6))
		((Said '/*') (HighPrint 2 7))
		(else (param1 claimed: 1) (DrinkWater 1))
	)
)

(procedure (Sleep param1 param2 &tmp temp0 theCurrentTime)
	(= daysWithoutSleep 0)
	(= theCurrentTime currentTime)
	(SetGameTime param1 param2)
	(= temp0
		(/
			(mod (- (+ currentTime 3600) theCurrentTime) 3600)
			150
		)
	)
	(= [skills 17] (GetMaxStamina))
	(ReduceHP (- (* temp0 8)))
	(ReduceMP (- (* temp0 8)))
	(if (> theCurrentTime currentTime) (IncrementGameDay))
)

(procedure (Rest param1)
	(= gCurrentDay currentDay)
	(= gCurrentTime currentTime)
	(= [skills skSP] (GetMaxStamina))
	(ReduceMP -12)
	(ReduceHP -6)
	(if param1 (HighPrint 2 21))
	(GameTimeEvents 1 0)
)

(procedure (TestSkill param1 param2 param3 &tmp theSkills temp1 temp2 temp3)
	(= temp3 0)
	(if (= theSkills [skills param1])
		(if (== argc 3) (= theSkills (+ theSkills param3)))
		(if param2
			(if (and (>= param1 5) (< param1 13))
				(ReduceSP (/ param2 10))
			)
		else
			(if (and (>= param1 5) (< param1 13))
				(ReduceSP (Random 1 6))
			)
			(= param2 (proc1_9))
		)
		(if (>= (localproc_0a2e 4 1) (Random 1 200))
			(= theSkills (+ theSkills (Random 1 20)))
		)
		(= temp3 (<= param2 theSkills))
		(if
			(= temp1
				(+ (/ (+ 19 (Abs (- param2 theSkills))) 20) 1)
			)
			(cond 
				((== param1 5) (SkillUsed 0 3) (SkillUsed 2 2))
				(
				(or (== param1 6) (== param1 7) (== param1 8)) (SkillUsed 2 4) (SkillUsed 1 2))
				((== param1 9) (SkillUsed 2 8) (SkillUsed 1 5))
				((or (== param1 10) (== param1 11)) (SkillUsed 0 5) (SkillUsed 2 4))
				((== param1 13) (SkillUsed 1 6))
				((>= param1 19) (SkillUsed 12 8) (SkillUsed 1 4))
			)
			(= temp2 100)
			(if (or (< param1 13) (== param1 5)) (= temp2 25))
			(SkillUsed param1 (Abs (/ temp2 temp1)))
		)
	)
	(return temp3)
)

(procedure (SkillUsed param1 param2 &tmp temp0)
	(if (not [skills param1]) (return 0))
	(= temp0 (if (>= param2 0) 1 else -1))
	(if (> (Abs param2) [skills param1])
		(= param2 (* [skills param1] temp0))
	)
	(= [skills 15] (+ [skills 15] (/ (Abs param2) 4)))
	(cond 
		(
			(>=
				[skillsThreshold param1]
				[skills (= [skillsThreshold param1]
					(+ [skillsThreshold param1] param2)
				)]
			)
			(= [skillsThreshold param1]
				(- [skillsThreshold param1] [skills param1])
			)
			(if
				(>
					(= [skills param1] (+ [skills param1] (Random 1 3)))
					200
				)
				(= [skills param1] 200)
			)
		)
		((< [skillsThreshold param1] 0)
			(= [skillsThreshold param1]
				(+ [skillsThreshold param1] [skills param1])
			)
			(if
				(<
					(= [skills param1] (- [skills param1] (Random 1 3)))
					5
				)
				(= [skills param1] 5)
			)
		)
		(else (return 0))
	)
	(return 1)
)

(procedure (CanPickLocks param1 &tmp temp0)
	(cond 
		((not [skills skLOCKPICKING]) (= temp0 {You don't have the skill to pick locks.}))
		((not (if (ego has: invLockPick) else (ego has: invThiefToolKit))) (= temp0 {You don't have any lock picking equipment.}))
		(else (return 1))
	)
	(if (and argc param1) (HighPrint temp0))
	(return 0)
)

(procedure (ReduceSP param1 &tmp temp0)
	(if (> param1 0) (SkillUsed 3 (/ (+ param1 3) 4)))
	(cond 
		(
		(> (= temp0 (= [skills 17] (- [skills 17] param1))) 4)
			(Bclr 7)
			(if (> temp0 (GetMaxStamina))
				(= [skills 17] (GetMaxStamina))
			)
		)
		((>= temp0 0))
		((ReduceHP (/ (- -3 [skills 17]) 4))
			(= [skills 17] 0)
			(if (not (Btst 7)) (Bset 7) (HighPrint 2 23))
		)
		(else (Die 0 2 24 80 {Sports are Healthy?} 82 999 0 0))
	)
)

(procedure (ReduceMP param1)
	(if [skills 12]
		(if (< (= [skills 18] (- [skills 18] param1)) 0)
			(= [skills 18] 0)
		)
		(if (> [skills 18] (GetMaxMana))
			(= [skills 18] (GetMaxMana))
		)
	)
	(return [skills 18])
)

(procedure (ReduceHP param1)
	(if (> param1 0)
		(SkillUsed 3 (Abs (/ (+ param1 1) 2)))
	)
	(if (< (= [skills 16] (- [skills 16] param1)) 0)
		(= [skills 16] 0)
	)
	(if (> [skills 16] (GetMaxHealth))
		(= [skills 16] (GetMaxHealth))
	)
	(return (> [skills 16] 0))
)

(procedure (AddToScore param1 param2 param3 &tmp temp0)
	(= temp0 0)
	(if (>= argc 3)
		(if (== param3 3)
			(if (!= heroType 3)
				(if (not (Btst 153))
					(if (not (Btst param1))
						(= paladinPoints (+ paladinPoints param2))
					)
				)
			)
		)
		(if (== heroType 3)
			(if (== param3 gHeroType) (= param3 3))
		)
	)
	(if
		(not
			(cond 
				((Bset param1))
				((>= argc 3) (!= heroType param3))
			)
		)
		(SkillUsed 1 param2)
		(theGame changeScore: param2)
		(= temp0 1)
	)
	(return temp0)
)

(procedure (PrintGameTime param1 &tmp theCurrentDay)
	(= theCurrentDay currentDay)
	(if
	(and (== currentTimeZone 6) (<= currentTime 500))
		(-- theCurrentDay)
	)
	(Format
		param1
		2
		25
		10
		(+ 4 currentTimeZone)
		theCurrentDay
	)
)

(procedure (SetGameTime param1 param2 &tmp temp0 theCurrentTime)
	(= theCurrentTime currentTime)
	(if (>= argc 1)
		(= theCurrentTime (* 150 param1))
		(= realTime (GetTime 1))
		(if (>= argc 2)
			(= theCurrentTime
				(+ theCurrentTime (/ (* 150 param2) 60))
			)
		)
	)
	(localproc_0bae theCurrentTime)
)

(procedure (GameTimeEvents param1 param2 &tmp temp0)
	(switch argc
		(1
			(= temp0 (+ currentTime (* 150 param1)))
		)
		(2
			(= temp0
				(+ currentTime (* 150 param1) (/ (* 150 param2) 60))
			)
		)
	)
	(= temp0 (^ temp0 $0001))
	(if
		(or
			(and (< currentTime 1100) (>= temp0 1100))
			(and
				(< currentTime 2500)
				(or (>= temp0 2500) (< temp0 currentTime))
			)
		)
		(EatRation)
	)
	(while (>= temp0 3600)
		(= temp0 (- temp0 3600))
		(IncrementGameDay)
	)
	(localproc_0bae temp0)
)

(procedure (IncrementGameDay)
	(++ currentDay)
	(Bclr 161)
	(Bclr 168)
	(Bclr 169)
	(Bclr 177)
	(return
		(cond 
			(
				(and
					(OneOf elementalsStatus 1 3 5 7)
					(OneOf currentDay 7 11 14 16)
				)
				(curRoom newRoom: 340)
			)
			((> currentDay 30) (curRoom newRoom: 790))
			((OneOf currentDay 5 8 12 14) (++ elementalsStatus))
		)
	)
)

(procedure (EatRation)
	(cond 
		(mealsPreEaten (-- mealsPreEaten))
		([invNum 3] (if (not (-- [invNum 3])) (PrintWarning 2 28)))
		((Btst 4)
			(Bset 5)
			(if (ReduceHP 1)
				(PrintWarning 2 29)
			else
				(Die 0 2 30 80 {An Unbalanced Diet} 82 999 1 1)
			)
		)
		(else (Bset 4) (PrintWarning 2 31))
	)
)

(procedure (proc2_19 param1)
	(return
		(if (or (< param1 65) (> param1 90))
			(return param1)
		else
			(return (+ (- param1 65) 97))
		)
	)
)

(procedure (AnswerQuestion param1 param2 &tmp temp0 temp1 temp2 temp3)
	(= temp1 (StrLen param2))
	(= temp0 (- (= temp0 (StrLen param1)) temp1))
	(while (>= temp0 0)
		(= temp3 0)
		(= temp2 temp0)
		(while (< temp3 temp1)
			(if
				(!=
					(proc2_19 (StrAt param2 temp3))
					(proc2_19 (StrAt param1 temp2))
				)
				(break)
			)
			(++ temp3)
			(++ temp2)
		)
		(if (== temp3 temp1) (return (+ temp3 1)))
		(-- temp0)
	)
	(return 0)
)

(procedure (proc2_21 param1 param2 param3 &tmp temp0 userInputLineAddr)
	(if
		(and
			(User canInput:)
			(not (param1 claimed?))
			(== (param1 type?) 4)
			(or
				(== (param1 message?) (User echo?))
				(and
					(<= 32 (param1 message?))
					(<= (param1 message?) 127)
				)
			)
		)
		(param1 claimed: 1)
		(if (User getInput: param1)
			(= userInputLineAddr (User inputLineAddr?))
			(= temp0 1)
			(while (< temp0 argc)
				(if
				(AnswerQuestion userInputLineAddr [param3 (- temp0 1)])
					(break)
				)
				(++ temp0)
			)
			(if (== temp0 argc)
				(= temp0 0)
				(if (and param2 (Parse userInputLineAddr param1))
					(param1 type: 128)
					(param1 claimed: 0)
					(User said: param1)
				)
			)
		)
	)
	(return temp0)
)

(procedure (proc2_22 param1 param2 param3 &tmp temp0 temp1)
	(cond 
		((>= argc 3) (GetFarText param2 param3 param1))
		((>= argc 2) (StrCpy param1 param2))
	)
	(= temp1 (StrLen param1))
	(= temp0 0)
	(while (< temp0 temp1)
		(StrAt param1 temp0 (proc2_19 (StrAt param1 temp0)))
		(++ temp0)
	)
	(return param1)
)

(procedure (BlueFrogTP &tmp [temp0 20] [temp20 20] [temp40 20] [temp60 10] temp70 temp71)
	(asm
		ldi      0
		sat      temp0
		pushi    2
		lea      @temp20
		push    
		lofsa    {8}
		push    
		callk    StrCpy,  4
		pushi    2
		lea      @temp40
		push    
		lofsa    {1}
		push    
		callk    StrCpy,  4
		pushi    2
		lea      @temp60
		push    
		lofsa    {1}
		push    
		callk    StrCpy,  4
		pushi    21
		lofsa    {Where to?}
		push    
		pushi    41
		lea      @temp0
		push    
		pushi    5
		lofsa    {Day}
		push    
		pushi    4
		pushi    3
		pushi    41
		lea      @temp40
		push    
		pushi    3
		lofsa    {Time}
		push    
		pushi    41
		lea      @temp20
		push    
		pushi    3
		pushi    101
		pushi    81
		lofsa    {Intro}
		push    
		pushi    81
		lofsa    {New Hero}
		push    
		pushi    81
		lofsa    {Import}
		push    
		calle    Printd,  42
		sat      temp70
		pushi    1
		lea      @temp40
		push    
		callk    ReadNumber,  2
		sat      temp71
		ldi      0
		sag      elementalsStatus
		sag      currentDay
code_1004:
		-at      temp71
		push    
		ldi      0
		ge?     
		bnt      code_1038
		+ag      currentDay
		pushi    8
		push    
		pushi    5
		pushi    7
		pushi    8
		pushi    11
		pushi    12
		pushi    14
		pushi    16
		calle    OneOf,  16
		bnt      code_1004
		+ag      elementalsStatus
		lsg      currentDay
		ldi      14
		eq?     
		bnt      code_1004
		+ag      elementalsStatus
		jmp      code_1004
code_1038:
		pushi    2
		pushi    1
		lea      @temp20
		push    
		callk    ReadNumber,  2
		push    
		pushi    0
		call     SetGameTime,  4
		lst      temp70
		dup     
		ldi      1
		eq?     
		bnt      code_105d
		pushi    1
		lea      @temp0
		push    
		callk    ReadNumber,  2
		sat      temp70
		jmp      code_1087
code_105d:
		dup     
		ldi      2
		eq?     
		bnt      code_106c
		ldi      750
		sat      temp70
		jmp      code_1087
code_106c:
		dup     
		ldi      3
		eq?     
		bnt      code_107b
		ldi      800
		sat      temp70
		jmp      code_1087
code_107b:
		dup     
		ldi      4
		eq?     
		bnt      code_1087
		ldi      805
		sat      temp70
code_1087:
		toss    
		lat      temp70
		bnt      code_1094
		pushi    1
		pushi    28
		calle    Bset,  2
code_1094:
		lat      temp70
		ret     
	)
)

(procedure (UsePill param1 param2 &tmp temp0 temp1)
	(= temp0 1)
	(cond 
		((not param2) (HighPrint 2 8) (= temp0 0))
		((not (ego use: param2)) (HighPrint 2 9) (= temp0 0))
		((== param2 18)
			(= temp1 (GetMaxHealth))
			(if (< [skills 16] temp1)
				(ReduceHP (- (/ temp1 2)))
				(HighPrint 2 10)
			else
				(HighPrint 2 11)
			)
		)
		((== param2 19)
			(= temp1 (GetMaxMana))
			(if (< [skills 18] temp1)
				(ReduceMP (- (/ temp1 2)))
				(HighPrint 2 12)
			else
				(HighPrint 2 11)
			)
		)
		((== param2 20)
			(= temp1 (GetMaxStamina))
			(if (< [skills 17] temp1)
				(ReduceSP (- temp1))
				(HighPrint 2 13)
			else
				(HighPrint 2 11)
			)
		)
		((== param2 48)
			(if (Btst 121)
				(HighPrint 2 14)
			else
				(Bset 121)
				(HighPrint 2 15)
			)
		)
	)
	(if temp0 (HighPrint 2 16) (DrinkWater 1))
	(return temp0)
)

(procedure (DrinkWater param1 &tmp temp0)
	(= temp0 (> currentWater 0))
	(if (< (-- currentWater) 0)
		(if param1 (HighPrint 2 17))
	else
		(Bclr 3)
		(Bclr 137)
		(cond 
			((not currentWater) (HighPrint 2 18))
			((== currentWater 2) (HighPrint 2 19))
			(param1 (HighPrint 2 20))
		)
	)
	(return temp0)
)

(procedure (ProclaimedHonorless)
	(if (Bset 153)
		(SkillUsed 14 -200)
	else
		(SkillUsed 14 -50)
	)
	(= possibleScore 500)
	(= paladinPoints 0)
	(= heroType gHeroType)
)

(procedure (PaladinCheck &tmp temp0)
	(if
		(and
			(not (Btst 153))
			(!= heroType 3)
			(>= paladinPoints 25)
			(>= [skills 14] 75)
		)
		(SkillUsed 14 200)
		(if (== gHeroType 2)
			(= possibleScore 500)
		else
			(= possibleScore 550)
		)
		(AddToScore 682 6 3)
		(= heroType 3)
		(theGame changeScore: paladinPoints)
	)
)

(procedure (SayThanks)        ; Pass a "You're welcome" string
   (if (<= (++ roomThanks) 2)    ; Not more than twice per room visit
      (SkillUsed skHONOR 10)
      (SkillUsed skCOMMUNICATION 5)
   )
   (Say &rest)
)

(procedure (GiveFlowers)
	(if (ego use: invFlowerBouquet 1)
		(SkillUsed skHONOR 10)
		(SkillUsed skCOMMUNICATION 20)
		(Say &rest)
	else
		(HighPrint 2 32)
	)
)

(procedure (PickLock param1 param2 param3)
	(return
		(if (TestSkill 9 param1 global133)
			(if (or (< argc 3) param3)
				(gMiscMusic number: 20 priority: 10 loop: 0 play:)
			)
			(return 1)
		else
			(if (and (> argc 1) param2) (HighPrint 2 22))
			(return 0)
		)
	)
)

(procedure (localproc_0a2e param1 param2)
	(SkillUsed param1 param2)
	(return (* [skills param1] param2))
)

(procedure (localproc_0bae param1 &tmp theCurrentTimeZone)
	(= currentTime (^ param1 $0001))
	(= theCurrentTimeZone currentTimeZone)
	(cond 
		((< currentTime 300) (= currentTimeZone 6))
		((< currentTime 750) (= currentTimeZone 7))
		(else (= currentTimeZone (/ (- currentTime 750) 450)))
	)
	(if
	(and (< 0 currentTimeZone) (< currentTimeZone 4))
		(Bclr 115)
	)
	(if (> currentTimeZone 4)
		(= isNightTime 1)
	else
		(= isNightTime 0)
	)
	(if
	(and (== currentTimeZone 6) (!= theCurrentTimeZone 6))
		(if (== (++ daysWithoutSleep) 1)
			(Print 2 26)
		else
			(Print 2 27)
		)
	)
)
