;;; Sierra Script 1.0 - (do not remove this comment)
(script# 765)
(include sci.sh)
(use Main)
(use n001)
(use Intrface)
(use Feature)
(use Motion)
(use Game)
(use Menu)
(use Actor)
(use System)

(public
	notice2Room 0
)

(local
	theContinueGame
	theIntro
)
(procedure (localproc_03fe)
	(theIntro setCycle: 0 setCel: 0 forceUpd:)
	(theContinueGame setCel: 2)
	(= theIntro theContinueGame)
	(SetUpEgo)
)

(procedure (localproc_0422 &tmp temp0)
	(theContinueGame setCel: 1 forceUpd:)
	(SetUpEgo)
	(switch theContinueGame
		(intro (= temp0 750))
		(startGame (= temp0 800))
		(import (= temp0 805))
		(continueGame
			(theGame restore:)
			(return)
		)
	)
	(MenuBar state: 1)
	(curRoom newRoom: temp0)
)

(procedure (localproc_048b)
	(if (!= theContinueGame intro)
		(= theContinueGame
			(buttonList at: (- (buttonList indexOf: theIntro) 1))
		)
	else
		(= theContinueGame continueGame)
	)
)

(procedure (localproc_04b6)
	(if (!= theContinueGame continueGame)
		(= theContinueGame
			(buttonList at: (+ (buttonList indexOf: theIntro) 1))
		)
	else
		(= theContinueGame intro)
	)
)

(instance candle of Prop
	(properties
		x 280
		y 68
		description {the candlestick}
		lookStr {Is this your "Trial by Fire?"\n\nNah.__Too small.}
		view 765
		cel 2
	)
)

(instance quill of PicView
	(properties
		x 27
		y 92
		description {a quill}
		lookStr {An old-fashioned word processor.}
		view 765
		loop 5
	)
)

(instance intro of Prop
	(properties
		x 152
		y 126
		shiftClick 0
		view 765
		loop 1
		signal $0001
		cycleSpeed 1
	)
	
	(method (handleEvent pEvent)
		(if (MousedOn self pEvent)
			(= theContinueGame intro)
			(localproc_03fe)
			(localproc_0422)
		)
		(super handleEvent: pEvent)
	)
)

(instance startGame of Prop
	(properties
		x 170
		y 143
		shiftClick 0
		view 765
		loop 2
		signal $0001
		cycleSpeed 1
	)
	
	(method (handleEvent pEvent)
		(if (MousedOn self pEvent)
			(= theContinueGame startGame)
			(localproc_03fe)
			(localproc_0422)
		)
		(super handleEvent: pEvent)
	)
)

(instance import of Prop
	(properties
		x 176
		y 161
		shiftClick 0
		view 765
		loop 3
		signal $0001
		cycleSpeed 1
	)
	
	(method (handleEvent pEvent)
		(if (MousedOn self pEvent)
			(= theContinueGame import)
			(localproc_03fe)
			(localproc_0422)
		)
		(super handleEvent: pEvent)
	)
)

(instance continueGame of Prop
	(properties
		x 176
		y 180
		shiftClick 0
		view 765
		loop 4
		signal $0001
		cycleSpeed 1
	)
	
	(method (handleEvent pEvent)
		(if (MousedOn self pEvent)
			(= theContinueGame continueGame)
			(localproc_03fe)
			(localproc_0422)
		)
		(super handleEvent: pEvent)
	)
)

(instance inkwell of Feature
	(properties
		x 30
		y 111
		nsTop 92
		nsBottom 131
		nsRight 59
		description {the inkwell}
		lookStr {Koko the Clown lived here many years ago.}
	)
)

(instance candlestick of Feature
	(properties
		x 287
		y 98
		nsTop 70
		nsLeft 260
		nsBottom 126
		nsRight 314
		description {the candlestick}
		lookStr {This belongs to Nimble Jack.}
	)
)

(instance scroll of Feature
	(properties
		x 30
		y 111
		nsTop 75
		nsLeft 58
		nsBottom 190
		nsRight 320
		description {the scroll}
		lookStr {Even in early word processing, they used scrolling techniques.}
	)
)

(instance buttonList of List
	(properties)
)

(instance notice2Room of Rm
	(properties
		picture 765
		style $0001
	)
	
	(method (init)
		(Load rsVIEW 765)
		(if (!= (gCMusic prevSignal?) -1) (gCMusic fade:))
		(gCMusic number: 770 loop: -1 priority: 0 playBed:)
		(super init: &rest)
		(MenuBar state: 0)
		(buttonList
			add: intro startGame import continueGame
			eachElementDo: #init
			doit:
		)
		(gMouseH add: self)
		(gKeyH add: self)
		(gDirH add: self)
		(candle init: setCycle: Fwd)
		(proc1_31 inkwell candlestick scroll)
		(DrawFeature quill)
		(= theContinueGame intro)
		(= theIntro intro)
		(localproc_03fe)
		(Animate (buttonList elements?) 1)
	)
	
	(method (dispose)
		(gMouseH delete: self)
		(gKeyH delete: self)
		(gDirH delete: self)
		(SetControl 0)
		(buttonList dispose:)
		(gCMusic fade:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp [temp0 2])
		(switch (pEvent type?)
			(evJOYSTICK
				(switch (pEvent message?)
					(JOY_UP (localproc_048b))
					(JOY_DOWN (localproc_04b6))
				)
				(pEvent claimed: 1)
			)
			(evKEYBOARD
				(switch (pEvent message?)
					(KEY_RETURN (localproc_0422))
					(KEY_SHIFTTAB (localproc_048b))
					(KEY_TAB (localproc_04b6))
					(KEY_CONTROL
						(gCMusic pause:)
						(AskQuit)
						(gCMusic pause: 0)
						(return)
					)
				)
				(pEvent claimed: 1)
			)
		)
		(localproc_03fe)
		(SetUpEgo)
		(super handleEvent: pEvent)
	)
)
