;;; Sierra Script 1.0 - (do not remove this comment)
(script# 401)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Intrface)
(use RaseirGuard)
(use PolyPath)
(use Polygon)
(use Save)
(use Motion)
(use Actor)
(use System)

(public
	rasGuard 0
	secondDown 1
	eunuchDie 2
	theDaz 3
	eunuchBust 4
	centerMe 5
	eunuchPace 6
	doorPicker 7
	doorBuster 8
	backToInn 9
	proc401_10 10
)

(local
	local0
	[local1 8]
	[local9 8]
)
(procedure (proc401_10 param1 &tmp temp0 temp1 temp2 temp3 temp4 curRoomObstacles)
	(= temp4 param1)
	(BaseSetter param1)
	(= temp0 (- (temp4 brLeft?) 10))
	(= temp1 (- (temp4 brTop?) 10))
	(= temp2 (+ (temp4 brRight?) 10))
	(= temp3 (+ (temp4 brBottom?) 5))
	(= curRoomObstacles (curRoom obstacles?))
	(if
	(or (== param1 (ScriptID 400 4)) (== param1 firstGuy))
		(= [local1 0] (= [local1 6] temp0))
		(= [local1 1] (= [local1 3] temp1))
		(= [local1 2] (= [local1 4] temp2))
		(= [local1 5] (= [local1 7] temp3))
		(guardPoly1 points: @local1 size: 4)
		(if
			(or
				(not curRoomObstacles)
				(not (curRoomObstacles contains: guardPoly1))
			)
			(curRoom addObstacle: guardPoly1)
		)
	else
		(= [local9 0] (= [local9 6] temp0))
		(= [local9 1] (= [local9 3] temp1))
		(= [local9 2] (= [local9 4] temp2))
		(= [local9 5] (= [local9 7] temp3))
		(guardPoly2 points: @local9 size: 4)
		(if
			(or
				(not curRoomObstacles)
				(not (curRoomObstacles contains: guardPoly2))
			)
			(curRoom addObstacle: guardPoly2)
		)
	)
)

(procedure (localproc_0142)
	(HighPrint &rest 80 {Eunuch:} 35 eWin)
)

(instance eWin of SysWindow
	(properties
		back 13
	)
)

(instance firstGuy of Actor
	(properties
		x 183
		y 153
		noun '/guard'
		description {the dead guard}
		lookStr {Yep, you killed him!}
		view 381
		loop 9
		signal $4000
		illegalBits $0000
	)
)

(instance guyTwo of Actor
	(properties
		noun '/guard<other'
		description {the other dead guard}
		lookStr {It's a dead guard lying on the ground, bleeding all over the place while you just stare.}
		signal $4000
	)
)

(instance rasGuard of RaseirGuard
	(properties)
	
	(method (die)
		(switch global312
			(0
				(if (cast contains: (ScriptID 400 2))
					((ScriptID 400 2) setScript: (ScriptID 400 3))
				)
				(if (cast contains: (ScriptID 400 4))
					((ScriptID 400 4) dispose:)
				)
				(if (cast contains: (ScriptID 400 5))
					((ScriptID 400 5) dispose:)
				)
				(super die:)
				(return)
			)
			(1
				(firstGuy init: setScript: firstDown)
				(self hide:)
				(curRoom setScript: (ScriptID 400 1))
			)
		)
		(-- global312)
		(= health (self calcHealth:))
		(= stamina (self calcStamina:))
		(self setHealth: health)
		(self setStamina: stamina)
	)
	
	(method (initCombat)
		(= deathScript secondDown)
		(super initCombat: &rest)
	)
)

(instance firstDown of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(firstGuy setCycle: End self)
			)
			(1
				(firstGuy loop: 2 cel: 1 posn: 198 162)
				(= cycles 2)
			)
			(2
				(firstGuy cel: 2 posn: 203 169)
				(= cycles 2)
			)
			(3
				(firstGuy cel: 3 posn: 201 182)
				(= cycles 2)
			)
			(4
				(proc401_10 firstGuy)
				(firstGuy ignoreActors: 0)
				(self dispose:)
			)
		)
	)
)

(instance secondDown of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(guyTwo
					view: 381
					loop: 2
					cel: 0
					illegalBits: 0
					posn: 183 153
					init:
				)
				(rasGuard hide:)
				((ScriptID 32 0) hide:)
				(ego
					view: (if (or (ego has: 4) (ego has: 24)) 83 else 84)
					loop: 0
					cel: 6
					posn: 145 159
					show:
					illegalBits: -32768
					cycleSpeed: 2
					setCycle: Beg
				)
				(= cycles 4)
			)
			(1
				(guyTwo cel: 1 posn: 173 162)
				(= cycles 1)
			)
			(2
				(guyTwo setCycle: End)
				(= seconds 2)
			)
			(3
				(LockEgo)
				(guyTwo setPri: 12 ignoreActors: 0)
				(rasGuard dispose:)
				((ScriptID 32 0) dispose:)
				(proc401_10 guyTwo)
				(proc1_19)
				(ego loop: 6)
				(= cycles 3)
			)
			(4 (self dispose:))
		)
	)
)

(instance eunuchDie of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 400 2) setMotion: 0)
				(if (== ((ScriptID 400 2) loop?) 0)
					((ScriptID 400 2) setLoop: 1)
					(= seconds 1)
				else
					(self cue:)
				)
			)
			(1
				((ScriptID 400 2)
					view: 533
					setLoop: 1
					cel: 0
					posn: (- ((ScriptID 400 2) x?) 11) (- ((ScriptID 400 2) y?) 15)
				)
				(= cycles 2)
			)
			(2
				((ScriptID 400 2)
					posn: (- ((ScriptID 400 2) x?) 7) (+ ((ScriptID 400 2) y?) 5)
				)
				(= cycles 2)
			)
			(3
				((ScriptID 400 2)
					posn: (- ((ScriptID 400 2) x?) 9) (+ ((ScriptID 400 2) y?) 7)
				)
				(= cycles 3)
			)
			(4
				((ScriptID 400 2) dispose:)
				(self dispose:)
			)
		)
	)
)

(instance theDaz of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 400 4) illegalBits: 0 setLoop: 8)
				(if (cast contains: (ScriptID 400 5))
					((ScriptID 400 5) illegalBits: 0 setLoop: 7)
				)
				(= cycles 3)
			)
			(1
				(HighPrint 401 0 80 {Guard:} 25 4 103)
				(= cycles 2)
			)
			(2 (= seconds 4))
			(3
				(switch local0
					(0
						(= local0 0)
						(HighPrint 401 1 80 {Other Guard:} 25 6 103)
					)
					(1
						(HighPrint 401 2 80 {Other Guard:} 25 6 103)
					)
					(2
						(HighPrint 401 3 80 {Other Guard:} 25 6 103)
					)
					(3
						(HighPrint 401 4 80 {Other Guard:} 25 6 103)
					)
				)
				(= seconds 4)
			)
			(4
				(switch local0
					(0
						(HighPrint 401 5 80 {First Guard:} 25 6 103)
					)
					(1
						(HighPrint 401 6 80 {First Guard:} 25 6 103)
					)
					(2
						(HighPrint 401 7 80 {First Guard:} 25 6 103)
					)
					(3
						(HighPrint 401 8 80 {First Guard:} 25 6 103)
					)
				)
				(if (== local0 3) (= local0 0) else (++ local0))
				(self changeState: 2)
			)
		)
	)
)

(instance eunuchBust of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: 0 setCycle: 0)
				(cond 
					((> ((ScriptID 400 2) x?) 313)
						((ScriptID 400 2)
							view: 533
							loop: 0
							cel: 0
							posn: 292 35
							mover: 0
							setCycle: End self
						)
					)
					((< ((ScriptID 400 2) x?) 19)
						((ScriptID 400 2)
							setMotion: MoveTo 30 ((ScriptID 400 2) y?) self
						)
					)
					(else (FaceObject (ScriptID 400 2) ego) (= seconds 1))
				)
			)
			(1
				(if (== ((ScriptID 400 2) view?) 533)
					((ScriptID 400 2) loop: 1 setCycle: Fwd)
				)
				(localproc_0142 401 9 25 3 103 self)
			)
			(2
				(Print 401 10 #title {The End})
				(= cycles 2)
			)
			(3
				(curRoom newRoom: 790)
				(self dispose:)
			)
		)
	)
)

(instance centerMe of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 400 2)
					setMotion: MoveTo 160 ((ScriptID 400 2) y?) self
				)
			)
			(1
				(FaceObject (ScriptID 400 2) ego)
				(= cycles 1)
			)
			(2
				(localproc_0142 401 11 103 25 3)
				(self dispose:)
			)
		)
	)
)

(instance eunuchPace of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				((ScriptID 400 2)
					setCycle: Walk
					setMotion: MoveTo 360 58 self
				)
			)
			(1
				((ScriptID 400 2) loop: 1)
				(= seconds 2)
			)
			(2
				((ScriptID 400 2) setMotion: MoveTo 15 58 self)
			)
			(3
				((ScriptID 400 2) loop: 0)
				(= seconds 5)
			)
			(4 (self changeState: 0))
		)
	)
)

(instance doorPicker of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					((< (ego y?) 100) (PrintWarning 401 12))
					((<= (ego y?) 136) (ego setMotion: MoveTo (ego x?) 117 self))
					((< (ego x?) 110) (ego setMotion: MoveTo 121 141 self))
					((< (ego x?) 120) (ego setMotion: MoveTo 159 116 self))
					(else (ego setMotion: MoveTo 198 141 self))
				)
			)
			(1
				(ego setMotion: MoveTo 169 116 self)
			)
			(2
				(ego view: 47 loop: 1 cel: 0 posn: 167 113)
				(= cycles 3)
			)
			(3
				(if (PickLock 100 1 1) (HighPrint 401 13))
				(ego view: 0 loop: 3)
				(proc1_19)
				(self dispose:)
			)
		)
	)
)

(instance doorBuster of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (< (ego y?) 100)
					(PrintWarning 401 14)
				else
					(self cue:)
				)
			)
			(1
				(ChangeEgoWalk 1 0)
				(ego illegalBits: 0 setMotion: PolyPath 175 117 self)
			)
			(2
				(ego view: 576 setLoop: 0 cel: 0 setCycle: CT 5 1 self)
			)
			(3
				(if (TestSkill 0 100)
					((ScriptID 400 6) ignoreActors: 1 setCycle: End)
					((ScriptID 400 7) ignoreActors: 1 setCycle: End self)
				else
					(HighPrint 401 15)
					(self changeState: 7)
				)
			)
			(4 (ego setCycle: End self))
			(5
				(ego
					view: 0
					setLoop: -1
					setCycle: Walk
					setMotion: MoveTo 160 92 self
				)
			)
			(6
				(curRoom newRoom: 470)
				(self dispose:)
			)
			(7
				(ego illegalBits: -32768 view: 0 loop: 3)
				(proc1_19)
				(self dispose:)
			)
		)
	)
)

(instance backToInn of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: 0 view: 4)
				(= cycles 2)
			)
			(1
				(HighPrint 401 16 80 {Guard:})
				(= cycles 2)
			)
			(2
				(cond 
					((< (ego x?) 86) (ego setMotion: MoveTo 126 135 self))
					((> (ego x?) 232) (ego setMotion: MoveTo 201 135 self))
					(else (self cue:))
				)
			)
			(3
				(if (< (ego x?) 160)
					(ego setMotion: MoveTo 195 121 self)
				else
					(ego setMotion: MoveTo 131 121 self)
				)
			)
			(4 (= cycles 2))
			(5
				(if (< (ego x?) 160)
					(FaceObject ego (ScriptID 400 4))
				else
					(FaceObject ego (ScriptID 400 5))
				)
				(= cycles 2)
			)
			(6
				(if (ego has: 41)
					(HighPrint 401 17)
					(= cycles 2)
				else
					(Die 401 18 80 {Get a life - Get a visa})
					(self dispose:)
				)
			)
			(7
				(HighPrint 401 19 80 {Guard:})
				(= cycles 2)
			)
			(8
				(cast eachElementDo: #hide)
				(curRoom drawPic: 2)
				(= cycles 10)
			)
			(9 (Print 401 20) (= cycles 2))
			(10
				(curRoom newRoom: 360)
				(self dispose:)
			)
		)
	)
)

(instance guardPoly1 of Polygon
	(properties
		type $0002
	)
)

(instance guardPoly2 of Polygon
	(properties
		type $0002
	)
)
