;;; Sierra Script 1.0 - (do not remove this comment)
(script# 269)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Stage)
(use TargActor)
(use Intrface)
(use LoadMany)
(use Motion)
(use Actor)

(public
	rm269 0
)

(instance rm269 of Stage
	(properties
		picture 700
		style $0009
		south 704
		bottomFromX 158
		bottomFromY 179
		bottomExit 4
		bottomToX 158
		bottomToY 147
	)
	
	(method (init)
		(LoadMany 128 0 700 705)
		(ego init:)
		(proc1_19)
		(super init:)
		(door init:)
		(lamp init: setCycle: Fwd)
		(if (== prevRoomNum 260)
			(= inOut 3)
			(self setScript: exitHouseS)
		)
		(DrawFeature wallLeft wallRight)
		(= gGDftSC gAllSC)
	)
	
	(method (doit)
		(if (and (== inOut 3) (>= (ego y?) 179))
			(= edgeHit 3)
		)
		(super doit:)
	)
	
	(method (dispose)
		(= gTopExit 1)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'lockpick[/lock]')
					(Said 'use/(lockpick[<lock]),lockpick')
					(Said 'unlock')
				)
				(cond 
					((not (CanPickLocks 1)))
					((not (ego inRect: 185 136 220 166)) (Print 269 0))
					((PickLock 70 1 1) (self setScript: openDoorS))
				)
			)
			((Said '/door') (Print 269 1))
		)
	)
	
	(method (cue)
		(super cue: &rest)
		(ego illegalBits: -384)
	)
)

(instance openDoorS of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(door setLoop: 7 cel: 0 setCycle: End)
				(= cycles 10)
			)
			(1
				(door stopUpd:)
				(ego
					setPri: 10
					illegalBits: 0
					setMotion: MoveTo 210 150 self
				)
			)
			(2
				(ego setMotion: MoveTo 243 150 self)
			)
			(3 (curRoom newRoom: 260))
		)
	)
)

(instance exitHouseS of HandsOffScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(ego illegalBits: -384)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(door setLoop: 7 cel: 2 setCycle: Beg)
				(ego posn: 213 150 loop: 1 setMotion: MoveTo 194 150 self)
			)
			(1
				(door stopUpd:)
				(proc1_19)
				(ego illegalBits: -384)
				(LockEgo)
				(self dispose:)
			)
		)
	)
)

(instance wallLeft of PicView
	(properties
		x 160
		y 79
		view 700
		loop 2
		cel 3
		signal $4000
	)
)

(instance wallRight of PicView
	(properties
		x 160
		y 79
		view 700
		loop 3
		cel 3
		signal $4000
	)
)

(instance door of TargActor
	(properties
		x 220
		y 160
		noun '/door'
		description {door}
		sightAngle 135
		closeRangeDist 60
		longRangeDist 400
		shiftClick 1
		contClick 7
		view 701
		loop 1
		cel 1
		priority 9
		signal $4010
		illegalBits $0000
	)
	
	(method (doVerb theVerb)
		(if (or (< argc 2) (self passedChecks: theVerb))
			(switch theVerb
				(1 (Print 269 2))
				(7 (Print 269 3))
				(2 (Print 269 4))
				(else 
					(super doVerb: theVerb &rest)
				)
			)
		)
	)
	
	(method (openMe)
		(self setScript: openDoorS)
		(return 1)
	)
)

(instance lamp of Prop
	(properties
		x 208
		y 131
		z 66
		noun '/lamp'
		description {lamp}
		sightAngle 135
		closeRangeDist 50
		longRangeDist 400
		shiftClick 1
		contClick 7
		view 705
		loop 7
		cycleSpeed 1
	)
	
	(method (doVerb theVerb)
		(if (or (< argc 2) (self passedChecks: theVerb))
			(switch theVerb
				(1 (Print 269 5))
				(7 (Print 269 6))
				(else 
					(super doVerb: theVerb &rest)
				)
			)
		)
	)
)
