;;; Sierra Script 1.0 - (do not remove this comment)
(script# 270)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Flame)
(use Intrface)
(use LoadMany)
(use Reverse)
(use Music)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm270 0
)

(local
	local0
	local1
	local2
	local3
	local4 =  1
	[local5 2]
)
(instance rm270 of Rm
	(properties
		picture 2
		style $0007
		horizon 100
	)
	
	(method (init)
		(LoadMany 128 0 1 2 10 22 47 270 271 272 273)
		(LoadMany 130 78 969)
		(LoadMany 132 50 270)
		(= local0
			(cond 
				((< [skills 7] 50) 100)
				((< [skills 7] 75) 5)
				((< [skills 7] 100) 4)
				((< [skills 7] 125) 3)
				(else 2)
			)
		)
		(super init:)
		(self setScript: welcome)
	)
)

(instance drFront of PicView
	(properties
		x 227
		y 118
		noun '/door'
		description {the doorway}
		lookStr {The doorway is the only way out of the room.}
		view 270
		loop 1
		cel 1
		priority 8
	)
)

(instance drBack of PicView
	(properties
		x 227
		y 108
		noun '/door'
		description {the doorway}
		lookStr {The doorway is the only way out of the room.}
		view 270
		loop 1
		priority 7
	)
)

(instance manacles of PicView
	(properties
		x 41
		y 127
		noun '/chain,manacle'
		description {the shackles that bound you}
		lookStr {The shackles that bound you hang limply from the wall.}
		view 270
		loop 1
		cel 2
		priority 8
	)
)

(instance shield of View
	(properties
		x 207
		y 103
		noun '/shield,blade,equipment'
		description {your fighting equipment}
		lookStr {Your sword and shield are doing you no good on the far side of the room.}
		view 270
		priority 6
	)
)

(instance flame1 of Flame
	(properties
		x 158
		y 58
		view 270
		loop 2
	)
)

(instance flame2 of Flame
	(properties
		x 200
		y 58
		view 270
		loop 2
		cel 1
	)
)

(instance fighter of Actor
	(properties
		x 235
		y 110
		noun '/fighter,fighter,swordsman'
		description {the bloodthirsty swordsman}
		lookStr {The flailing, bloodthirsty swordsman looks like he means business.}
		view 272
		signal $1800
	)
)

(instance welcome of HandsOffScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(Print 270 1)
				(PrintWarning 270 2 80 {Voice:})
				(Print 270 3 #title {Same Voice:})
				(HighPrint 270 4 80 {Still the Same Voice:} 25 5)
				(SetInput 0)
				(= seconds 5)
			)
			(1
				(SetInput 1)
				(Print 270 5)
				(Print 270 6)
				(Print 270 7)
				(curRoom drawPic: 270)
				(DrawFeature drFront drBack)
				(shield init: stopUpd:)
				(gCMusic number: 50 loop: -1 vol: 60 init: playBed:)
				(flame1 init: cycleSpeed: 1 setCycle: Fwd)
				(flame2 init: cycleSpeed: 1 setCycle: Rev)
				(ego view: 271 loop: 0 cel: 0 posn: 46 160 init:)
				(= cycles 10)
			)
			(2
				(rmnSound number: 270 loop: 2 play:)
				(ego cycleSpeed: 1 setCycle: End)
				(= seconds 3)
			)
			(3
				(ego cycleSpeed: 0)
				(HighPrint 270 8 80 {Voice:})
				(self cue:)
			)
			(4
				(curRoom setScript: countDown)
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((or (Said 'done,escape') (Said 'run[<away]')) (= global284 2) (gCMusic fade:) (curRoom newRoom: 271))
			(else (HighPrint 270 0) (pEvent claimed: 1))
		)
	)
)

(instance breakOut of HandsOffScript
	(properties)
	
	(method (doit)
		(super doit: &rest)
		(if
			(and
				(<= 0 state)
				(<= state 3)
				(== (ego view?) 271)
				(OneOf (ego loop?) 1 3)
				(OneOf (ego cel?) 1 4)
				(== ((ego cycler?) cycleCnt?) 0)
			)
			(gSpareMusic
				number: 270
				loop: 1
				priority: 5
				vol: 110
				play:
			)
		)
	)
	
	(method (dispose)
		(gSpareMusic vol: 127)
		(super dispose: &rest)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					loop: 1
					cel: 0
					cycleSpeed: (if (< local4 4) 2 else 1)
					setCycle: Fwd
				)
				(= cycles (Random 15 35))
			)
			(1
				(ego loop: 2 setCycle: 0)
				(= cycles (if (cast contains: fighter) 25 else 10))
			)
			(2
				(if (cast contains: fighter)
					(ego loop: 1 cycleSpeed: 0 setCycle: Fwd)
					(= cycles 14)
				else
					(self changeState: 0)
				)
			)
			(3
				(if local1
					(ego loop: 2 setCycle: 0)
				else
					(ego loop: 3 cel: 0 cycleSpeed: 1 setCycle: End self)
				)
			)
			(4
				(DrawFeature manacles)
				(ego loop: 4 cel: 0 setCycle: End self)
			)
			(5
				(= local3 1)
				(ego
					setLoop: 5
					cel: 0
					setCycle: 0
					cycleSpeed: 0
					setScript: dodgeEm
				)
				(self dispose:)
			)
		)
	)
)

(instance countDown of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (SetInput 0) (= seconds 2))
			(1
				(switch local4
					(1 (HighPrint 270 22 25 2 103))
					(2 (HighPrint 270 23 25 2 103))
					(3 (HighPrint 270 24 25 2 103))
					(4 (HighPrint 270 25 25 2 103))
					(5 (HighPrint 270 26 25 2 103))
					(6 (HighPrint 270 27 25 2 103))
					(7 (HighPrint 270 28 25 2 103))
					(8 (HighPrint 270 29 25 2 103))
					(9 (HighPrint 270 30 25 2 103))
					(10 (HighPrint 270 31 25 2 103))
				)
				(= seconds 2)
			)
			(2
				(if (<= (++ local4) 10)
					(self changeState: 1)
					(if
					(and (== local4 8) (not (cast contains: fighter)))
						(fighter illegalBits: 0 init: setScript: sicEm)
						(if local2 (breakOut changeState: 1) else (= local1 1))
					)
				else
					(self dispose:)
				)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(if (super handleEvent: pEvent) (return 1))
		(return
			(switch (pEvent type?)
				(evSAID
					(cond 
						((Said 'ask//!*') (HighPrint 270 9))
						((Said 'look,examine>')
							(cond 
								((Said '/flame,fire,sconce') (HighPrint 270 10))
								((Said '/shield') (HighPrint 270 11))
								((Said '/blade') (HighPrint 270 12))
								((Said '/door') (HighPrint 270 13))
								((Said '/ceiling,up') (HighPrint 270 14))
								((Said '/floor,down') (HighPrint 270 15))
								(
								(Said 'search,look,examine[<at,around][/room,area][/!*]') (HighPrint 270 16))
								((Said '/fighter,fighter,swordsman') (HighPrint 270 17))
								((Said '/chain,chain,manacle') (HighPrint 270 18))
							)
						)
						(
							(or
								(Said 'break/chain,free,loose')
								(Said 'use/strength')
								(Said 'attack,struggle[<free,loose]')
								(Said 'free/self')
							)
							(if local2
								(HighPrint 270 19)
							else
								(= local2 1)
								(ego setScript: breakOut)
							)
						)
						((Said 'cast,throw') (HighPrint 270 20))
						(else (pEvent claimed: 1) (HighPrint 270 21))
					)
				)
				(evJOYSTICK (pEvent claimed: 1))
			)
		)
	)
)

(instance sicEm of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(fighter setMotion: MoveTo 229 110 self)
			)
			(1
				(SetInput 0)
				(fighter setCel: -1 setCycle: End)
				(= cycles 10)
			)
			(2
				(fighter
					setLoop: 1
					cel: 0
					posn: (- (fighter x?) 1) (+ (fighter y?) 2)
					setCycle: Walk
					setMotion: MoveTo 81 153 self
				)
			)
			(3
				(if local3
					(fighter
						view: 273
						setLoop: 0
						cel: 0
						setCycle: 0
						setScript: bopEm
					)
				else
					(ego setScript: 0)
					(fighter view: 273 setLoop: 0 cel: 0 setCycle: CT 4 1)
					(= global284 1)
					(HighPrint 270 32 25 4 103)
					(= seconds 3)
				)
			)
			(4
				(if local3
					(self dispose:)
				else
					(= currentTimeZone 6)
					(gCMusic fade:)
					(curRoom newRoom: 271)
				)
			)
		)
	)
)

(instance bopEm of Script
	(properties)
	
	(method (doit)
		(cond 
			(
				(and
					(== (client loop?) 3)
					(== (client cel?) (client lastCel:))
					(not (dodgeEm script?))
				)
				(dodgeEm setScript: egoBopped)
			)
			(
				(and
					(<= 4 (client loop?))
					(<= (client loop?) 5)
					(== (client cel?) (client lastCel:))
					(not (dodgeEm script?))
				)
				(dodgeEm setScript: knockDown)
			)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 3))
			(1
				(client setLoop: 0 cel: 0)
				(= cycles (Random 2 5))
			)
			(2
				(if (== (dodgeEm script?) knockDown)
					(self changeState: 0)
				else
					(client setLoop: (Random 3 5) cel: 0)
					(= cycles (Random 5 15))
				)
			)
			(3
				(if (not (client loop?))
					(client setCycle: CT 0 1 self)
				else
					(client setCycle: End self)
				)
				(= cycles 10)
			)
			(4
				(if (not (client loop?))
					(self changeState: 1)
				else
					(= cycles 4)
				)
			)
			(5 (self changeState: 1))
		)
	)
)

(instance dodgeEm of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(gDirH add: self)
		(gMouseH add: self)
		(SetInput 0)
	)
	
	(method (dispose)
		(gDirH delete: self)
		(gMouseH delete: self)
		(SetInput 1)
		(super dispose: &rest)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1)
		(if (super handleEvent: pEvent) (return 1))
		(if (self script?) (return (self script?)))
		(if (== (fighter script?) sicEm) (return 1))
		(return
			(switch (pEvent type?)
				(evJOYSTICK
					(pEvent claimed: 1)
					(switch (pEvent message?)
						(JOY_UP
							(self setScript: egoBlocked)
						)
						(JOY_LEFT
							(self setScript: dodgeLeft)
						)
						(JOY_RIGHT
							(if local0
								(if
								(> (= temp0 (/ (Random 5 255) local0)) (Random 15 25))
									(self setScript: dodgeRightBad)
								else
									(self setScript: blockedRight)
								)
							else
								(self setScript: dodgeRightGood)
							)
							(-- local0)
						)
						(JOY_DOWN
							(self setScript: jumpBack)
						)
					)
				)
				(evMOUSEBUTTON
					(pEvent claimed: 1)
					(cond 
						(
							(<
								(= temp1
									(GetAngle (ego x?) (ego y?) (pEvent x?) (pEvent y?))
								)
								75
							)
							(self setScript: egoBlocked)
						)
						((< temp1 100)
							(if local0
								(if
								(> (= temp0 (/ (Random 5 255) local0)) (Random 15 25))
									(self setScript: dodgeRightBad)
								else
									(self setScript: blockedRight)
								)
							else
								(self setScript: dodgeRightGood)
							)
							(-- local0)
						)
						((< temp1 240) (self setScript: jumpBack))
						(else (self setScript: dodgeLeft))
					)
				)
				(evSAID
					(cond 
						((or (Said 'done,escape') (Said 'run[<away]')) (= global284 2) (gCMusic fade:) (curRoom newRoom: 271))
						((Said 'cast,throw')
							(= global284 6)
							(HighPrint 270 33 80 {A chorus of voices})
							(gCMusic fade:)
							(curRoom newRoom: 271)
						)
						(else (pEvent claimed: 1))
					)
				)
			)
		)
	)
)

(instance knockDown of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ReduceSP 20)
				(ego
					view: 22
					setLoop: 0
					cel: 0
					posn: (+ (ego x?) 10) (+ (ego y?) 3)
					setCycle: End self
				)
			)
			(1 (= cycles 15))
			(2
				(ego setLoop: 1 cel: 0 setCycle: CT 4 1 self)
			)
			(3 (= cycles 10))
			(4 (ego setCycle: CT 8 1 self))
			(5
				(ego
					view: 271
					setLoop: 5
					posn: (- (ego x?) 10) (- (ego y?) 3)
				)
				(self dispose:)
			)
		)
	)
)

(instance blockedRight of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(fighter setLoop: 5 cel: 1 setCycle: End)
				(ego
					setPri: (+ (fighter priority?) 1)
					setLoop: 8
					cel: 0
					posn: (+ (ego x?) 13) (- (ego y?) 10)
					setCycle: End self
				)
			)
			(1
				(fighter setCycle: Beg)
				(ReduceSP 20)
				(ego
					view: 22
					posn: (- (ego x?) 3) (+ (ego y?) 13)
					setLoop: 0
					cel: 0
					setCycle: End self
				)
			)
			(2 (= cycles 15))
			(3
				(ego
					setLoop: 1
					cel: 0
					cycleSpeed: 1
					setCycle: CT 4 1 self
				)
			)
			(4 (= cycles 10))
			(5 (ego setCycle: CT 8 1 self))
			(6
				(ego
					view: 271
					setLoop: 5
					cycleSpeed: 0
					posn: (- (ego x?) 10) (- (ego y?) 3)
					setPri: -1
				)
				(self dispose:)
			)
		)
	)
)

(instance dodgeLeft of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setLoop: 7 cel: 0 x: (- (ego x?) 8))
				(= cycles 2)
			)
			(1 (ego cel: 1) (= cycles 2))
			(2 (ego cel: 0) (= cycles 2))
			(3
				(ego x: (+ (ego x?) 8) setLoop: 5)
				(self dispose:)
			)
		)
	)
)

(instance dodgeRightBad of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setLoop: 6
					cel: 0
					posn: (+ (ego x?) 10) (- (ego y?) 5)
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(1
				(ego
					setLoop: 5
					cycleSpeed: 0
					posn: (- (ego x?) 10) (+ (ego y?) 5)
				)
				(self dispose:)
			)
		)
	)
)

(instance dodgeRightGood of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setLoop: 8
					cel: 0
					setPri: (+ (fighter priority?) 1)
					posn: (+ (ego x?) 13) (- (ego y?) 9)
					setCycle: End self
				)
			)
			(1
				(ego
					setLoop: 7
					cel: 2
					posn: (+ (ego x?) 34) (+ (ego y?) 9)
					setCycle: Beg self
				)
			)
			(2
				(ego view: 271 setLoop: 5 cel: 0 setPri: -1)
				(client setScript: straightUp)
			)
		)
	)
)

(instance egoBopped of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ReduceSP 20)
				(ego
					view: 271
					posn: 46 160
					setLoop: 4
					cel: 4
					illegalBits: 0
					cycleSpeed: 0
					moveSpeed: 0
					setCycle: CT 1 -1 self
				)
			)
			(1 (= cycles 5))
			(2
				(ego illegalBits: -32768 cycleSpeed: 1 setCycle: End self)
			)
			(3
				(ego view: 271 setLoop: 5 cel: 0 cycleSpeed: 0)
				(self dispose:)
			)
		)
	)
)

(instance egoBlocked of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(fighter
					setScript: 0
					setLoop: 4
					cel: 0
					setCycle: CT 4 1 self
				)
				(ego
					view: 1
					setLoop: 6
					cel: 0
					xStep: 6
					yStep: 3
					cycleSpeed: 1
					moveSpeed: 1
					setCycle: 0
					posn: (+ (ego x?) 16) (+ (ego y?) 2)
				)
			)
			(1
				(fighter setCycle: Beg)
				(ReduceSP 20)
				(ego
					setMotion: 0
					view: 271
					posn: 46 160
					setLoop: 4
					cel: 4
					illegalBits: 0
					cycleSpeed: 0
					moveSpeed: 0
					setCycle: CT 1 -1 self
				)
			)
			(2 (= cycles 5))
			(3
				(ego illegalBits: -32768 cycleSpeed: 1 setCycle: End self)
			)
			(4
				(fighter setScript: bopEm)
				(ego view: 271 setLoop: 5 cel: 0 cycleSpeed: 0)
				(self dispose:)
			)
		)
	)
)

(instance straightUp of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 1
					setLoop: -1
					loop: (if (< (ego x?) 200) 6 else 3)
					cel: 0
					xStep: 6
					yStep: 3
					cycleSpeed: 0
					setCycle: Walk
					posn: (+ (ego x?) 16) (+ (ego y?) 2)
					setMotion: MoveTo 199 105 self
				)
				(fighter
					view: 272
					setLoop: 2
					cel: 0
					cycleSpeed: 1
					setCycle: End
					setScript: 0
				)
			)
			(1
				(ego view: 47 loop: 0 cel: 0 setCycle: End self)
			)
			(2
				(HighPrint 270 34)
				(gCMusic fade:)
				(curRoom newRoom: 275)
			)
		)
	)
)

(instance jumpBack of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setLoop: 6
					cel: 0
					posn: (+ (ego x?) 12) (- (ego y?) 4)
				)
				(= cycles 2)
			)
			(1
				(ego cycleSpeed: 1 setCycle: End self)
			)
			(2
				(ego
					cycleSpeed: 0
					posn: (- (ego x?) 12) (+ (ego y?) 4)
					setLoop: 5
					cel: 0
				)
				(self dispose:)
			)
		)
	)
)

(instance rmnSound of Sound
	(properties)
	
	(method (check)
		(DoSound sndCHECK_DRIVER self)
		(if (self signal?)
			(self prevSignal: (self signal?) signal: 0)
			(cond 
				((> (self loop?) 1)
					(self loop: (- (self loop?) 1))
					(DoSound sndRESUME self 0)
				)
				((IsObject client) (client cue: self))
			)
		)
	)
)
