;;; Sierra Script 1.0 - (do not remove this comment)
(script# 275)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use Flame)
(use Intrface)
(use LoadMany)
(use Reverse)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm275 0
)

(local
	local0
	local1
	local2
	local3
)
(instance rm275 of Rm
	(properties
		picture 2
		style $0010
		horizon 80
	)
	
	(method (init)
		(LoadMany 128 80 272 273 141 358 294 275 270 83 145)
		(Load rsPIC 275)
		(LoadMany 130 969)
		(super init: &rest)
		(= gGDftSC rm275Check)
		(self setScript: fightingScript)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((!= (pEvent type?) evSAID))
			((Said 'look,examine>')
				(cond 
					((Said '/ceiling,up') (HighPrint 275 0))
					((Said '/floor,down') (HighPrint 275 1))
					(
						(or
							(Said 'search,look,examine[<at,around][/room,area][/!*]')
							(Said '/hall[<eof]')
						)
						(HighPrint 275 2)
					)
					((Said '/fighter,fighter')
						(cond 
							(local1 (HighPrint 275 3))
							(local0 (HighPrint 275 4))
							(else (HighPrint 275 5))
						)
					)
				)
			)
		)
	)
	
	(method (notify param1)
		(switch param1
			(59
				(HighPrint 275 6)
				(= global284 3)
				(self newRoom: 271)
			)
			(60
				(HighPrint 275 7)
				(= [skills 17] 1)
				(= global284 4)
				(self newRoom: 271)
			)
			(61
				(Die 1 275 8 80 {Proper Preparation Pays})
			)
			(57
				(= local0 1)
				(self setScript: doneScript)
			)
			(58
				(= local0 1)
				(self setScript: doneScript)
			)
		)
		(return 1)
	)
)

(instance fighter of Actor
	(properties
		x 175
		y 125
		description {the swordsman}
		lookStr {Walid, the swordsman, is not pleased.}
		view 272
		loop 1
		signal $4000
	)
)

(instance issur of Talker
	(properties
		x 15
		y 158
		noun '/man,issur,armorer'
		description {Issur}
		lookStr {The man talking to you is Issur, the blacksmith and weaponer.}
		view 141
		illegalBits $0000
		tLoop 3
		talkSpeed 1
		said '[/issur,man,armorer]>'
		title {Issur:}
		back 14
	)
	
	(method (showText param1)
		(super showText: param1)
	)
)

(instance extra1 of Actor
	(properties
		x 17
		y 159
		noun '/man,spectator'
		description {the spectator}
		lookStr {Hassan used to be a Brigand.__Some still wonder.}
		view 358
		priority 11
		signal $4010
		illegalBits $0000
	)
)

(instance extra2 of Actor
	(properties
		x 5
		y 154
		noun '/man,spectator'
		description {the spectator}
		lookStr {Saddam got off duty just to watch Walid beat up on you.}
		view 294
		priority 11
		signal $4010
		illegalBits $0000
	)
)

(instance extra3 of Actor
	(properties
		y 162
		noun '/man,spectator'
		description {the spectator}
		lookStr {Hussein was hoping to see Mr. Big-Shot Walid get beaten.}
		view 294
		priority 11
		signal $4010
		illegalBits $0000
	)
)

(instance shackles of PicView
	(properties
		x 210
		y 79
		noun '/chain,manacle'
		description {the shackles that bound you}
		lookStr {The shackles that bound you hang limply from the wall.}
		view 275
		loop 1
		cel 2
	)
)

(instance alleyDoor of PicView
	(properties
		x 125
		y 102
		noun '/door[<alley]'
		description {the door to the alley}
		lookStr {The door leads to the alley, you think.}
		view 275
	)
)

(instance flame1 of Flame
	(properties
		x 120
		y 60
		noun '/flame,fire,sconce'
		view 270
		loop 2
	)
)

(instance flame2 of Flame
	(properties
		x 163
		y 60
		noun '/flame,fire,sconce'
		view 270
		loop 2
		cel 1
	)
)

(instance leftDoorHalf of PicView
	(properties
		x 21
		y 164
		noun '/door'
		description {the door}
		lookStr {The door leads to another room, you think.}
		view 275
		loop 1
	)
)

(instance rightDoorHalf of PicView
	(properties
		x 34
		y 154
		noun '/door'
		description {the door}
		lookStr {The door leads to another room, you think.}
		view 275
		loop 1
		cel 1
	)
)

(instance stabEm of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local1 1)
				(fighter view: 272 loop: 5 cel: 0)
				(ego
					view: 80
					loop: 10
					cel: 1
					palette: 1
					posn: (+ (ego x?) 20) (- (ego y?) 9)
				)
				(= cycles 2)
			)
			(1 (ego cel: 0) (= cycles 2))
			(2
				(ego view: 272 loop: 7 cel: 0 setCycle: End)
				(= cycles 15)
			)
			(3 (ego cel: 1) (= cycles 10))
			(4 (ego cel: 2) (= cycles 15))
			(5
				(ego cycleSpeed: 1 setCycle: Beg self)
			)
			(6
				(ego view: 80 loop: 10 cel: 0)
				(= cycles 2)
			)
			(7 (ego cel: 1) (= cycles 2))
			(8
				(issur
					init:
					setCycle: Walk
					setMotion: MoveTo 40 (issur y?)
				)
				(ego
					view: 83
					loop: 0
					cel: 4
					posn: (- (ego x?) 20) (+ (ego y?) 9)
					setCycle: Beg self
				)
			)
			(9
				(ego view: 0)
				(proc1_19)
				(issur view: 145 loop: 0)
				(Say issur self 275 9)
			)
			(10 (client setScript: member))
		)
	)
)

(instance theTurkey of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset 154)
				(ego setCycle: Beg)
				(fighter view: 272 loop: 5 cel: 0)
				(issur
					init:
					setCycle: Walk
					setMotion: MoveTo 60 (issur y?) self
				)
			)
			(1
				(issur view: 145 loop: 0)
				(Say issur self 275 10)
			)
			(2
				(proc1_19)
				(client setScript: member)
			)
		)
	)
)

(instance member of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(issur
					view: 141
					setCycle: Walk
					setMotion: MoveTo (- (ego x?) 15) (ego y?) self
				)
			)
			(1
				(issur loop: 2 cel: 0 setCycle: End self)
			)
			(2
				(ego posn: (+ (ego x?) 3) (- (ego y?) 2))
				(= cycles 2)
			)
			(3
				(issur loop: 0)
				(ego setHeading: 225 self)
			)
			(4
				(issur view: 145)
				(Say issur self 275 11)
			)
			(5 (fighter setCycle: End self))
			(6
				(fighter
					loop: 6
					cel: 0
					posn: (fighter x?) (- (fighter y?) 6)
					setCycle: End self
				)
			)
			(7
				(HighPrint 275 12 25 3 80 {Walid})
				(= seconds 2)
			)
			(8
				(extra1
					init:
					setCycle: Walk
					setMotion: MoveTo (+ (extra1 x?) 35) (extra1 y?)
				)
				(= cycles 5)
			)
			(9
				(extra2
					init:
					setCycle: Walk
					setMotion: MoveTo (+ (extra1 x?) 35) (- (extra1 y?) 10)
				)
				(= cycles 5)
			)
			(10
				(extra3
					init:
					setCycle: Walk
					setMotion: MoveTo (+ (extra1 x?) 31) (+ (extra1 y?) 10) self
				)
			)
			(11
				(extra1 view: 352 loop: 0 cel: 0)
				(extra2 view: 295 loop: 0 cel: 0)
				(extra3 view: 295 loop: 0 cel: 0)
				(Say issur self 275 13)
			)
			(12
				(extra3 view: 295 loop: 3 cel: 0)
				(if local1
					(Say issur self 275 14)
				else
					(Say issur self 275 15)
				)
			)
			(13
				(cast eachElementDo: #dispose)
				(curRoom drawPic: 2)
				(= seconds 1)
			)
			(14
				(AddToScore 664 7 0)
				(SkillUsed 14 50)
				(HighPrint 275 16)
				(HighPrint 275 17)
				(Print 275 18)
				(HighPrint 275 19)
				(if (< [invNum 2] 5)
					(= [invNum 2] 0)
				else
					(ego use: 2 5)
				)
				(ego get: 40)
				(= cycles 4)
			)
			(15
				(= currentDay 16)
				(if (OneOf elementalsStatus 1 3 5 7)
					(curRoom newRoom: 340)
				else
					(= curRoomNum 101)
					(SetGameTime 8 0)
					(curRoom newRoom: 100)
					(self dispose:)
				)
			)
		)
	)
)

(instance fightingScript of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Bset 159) (= cycles 2))
			(1
				(curRoom drawPic: 275)
				(flame1 init: cycleSpeed: 1 setCycle: Fwd)
				(flame2 init: cycleSpeed: 1 setCycle: Rev)
				(DrawFeature
					alleyDoor
					leftDoorHalf
					rightDoorHalf
					shackles
				)
				((= local2 (ScriptID 273 0))
					barMessage: 0
					posn: 145 145
				)
				((= local3 (ScriptID 32 0))
					barMessage: 0
					posn: 112 150
					setPri: 10
					opponent: local2
					initCombat:
				)
				(fighter
					init:
					setLoop: 1
					setCycle: Walk
					setMotion: MoveTo 145 145 self
				)
				(= gGDftSC rm275Check)
			)
			(2
				(fighter dispose:)
				(local2 initCombat:)
				(self dispose:)
			)
		)
	)
)

(instance doneScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(local2 dispose:)
				(local3 dispose:)
				(fighter
					cel: 0
					setLoop: 4
					init:
					cycleSpeed: 1
					setCycle: End self
				)
				(proc1_19)
				(ego view: 83 loop: 0 cel: 4 init: posn: 111 149)
				(fighter cycleSpeed: 0)
			)
			(1
				(SetInput 0)
				(HighPrint 275 20 25 3)
				(= cycles 10)
			)
			(2
				(PrintWarning 275 21 25 3)
				(= cycles 10)
			)
			(3
				(Print 275 21 #time 3 #at 20 100)
				(= cycles 10)
			)
			(4
				(Print 275 21 #time 3 #at 280 100)
				(= cycles 10)
			)
			(5
				(HighPrint 275 21 25 3)
				(= cycles 10)
			)
			(6 (= seconds 5))
			(7
				(client setScript: theTurkey)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((!= (pEvent type?) evSAID))
			((Said 'kill,attack,attack,affirmative')
				(SkillUsed 14 -20)
				(ProclaimedHonorless)
				(client setScript: stabEm)
			)
			(
			(or (Said 'n') (Said 'deposit,(put<away)/weapon'))
				(AddToScore 678 7 3)
				(SkillUsed 14 40)
				(client setScript: theTurkey)
			)
			((Said 'ask//!*') (Print 275 22))
		)
	)
)

(instance rm275Check of Code
	(properties)
	
	(method (doit)
		(HighPrint 275 23)
		(SkillUsed 14 -10)
		(= global284 3)
		(curRoom newRoom: 271)
		(return 0)
	)
)
