;;; Sierra Script 1.0 - (do not remove this comment)
(script# 320)
(include sci.sh)
(use Main)
(use n001)
(use HandsOffScript)
(use TopWindow)
(use Talker)
(use Stage)
(use TargActor)
(use Intrface)
(use Feature)
(use LoadMany)
(use Follow)
(use Motion)
(use Actor)
(use System)

(public
	rm320 0
)

(local
	[local0 4]
)
(instance rm320 of Stage
	(properties
		picture 300
		north 160
		east 704
		south 330
		west 704
		topFromX 158
		topFromY 95
		topExit 4
		topToX 158
		topToY 118
		bottomExit 2
		rightFromX 330
		rightFromY 170
		rightExit 1
		rightToX 260
		rightToY 170
		leftFromX -10
		leftFromY 170
		leftExit 3
		leftToX 35
		leftToY 170
	)
	
	(method (init)
		(LoadMany 128 11 300 294 168 301 320 297)
		(Load rsSCRIPT 971)
		(++ global268)
		(if (!= gCurrentDay_4 currentDay)
			(= global268 1)
			(= gCurrentDay_4 currentDay)
		)
		(if (Btst 28) (= inOut 3))
		(if
		(and (<= 0 currentTimeZone) (<= currentTimeZone 4))
			(= gGDftSC gNoSC)
		else
			(= gGDftSC gAllSC)
		)
		(if (== prevRoomNum south)
			(= bottomToX (= bottomFromX (- 319 (ego x?))))
		)
		(if (and (== prevRoomNum 160) (Btst 157)) (= inOut 3))
		(if (not (Btst 28)) (ego init:))
		(super init:)
		(self overlay: curRoomNum)
		(proc1_31 leftAlleyDoor rightAlleyDoor)
		(DrawFeature guildSign mosaic windowL windowR)
		(if (not isNightTime)
			(if (== currentDay 3) ((ScriptID 322 1) init:))
		else
			(doorL palette: 2)
			(doorR palette: 2)
		)
		(cond 
			(
				(and
					(== prevRoomNum 160)
					(== currentDay 10)
					(not isNightTime)
					(ego has: 50)
					(not (Btst 151))
				)
				(self entranceScript: saurusAndGuard west: 290)
				(saurus init:)
				(DrawFeature theGuard)
				(guardMouth init:)
			)
			(
				(and
					[skills 11]
					(< tightropeWins 3)
					(not isNightTime)
					(OneOf currentDay 2 4 8 11 16)
				)
				((ScriptID 321 0) init:)
			)
			(
			(and (not isNightTime) (OneOf currentDay 1 3 13)) ((ScriptID 322 0) init:) (DrawFeature carpet))
		)
		(cond 
			((and (== prevRoomNum 160) (Btst 157))
				(doorL cel: 3 init:)
				(doorR cel: 3 init:)
				(ego setScript: thrownOut)
			)
			((== prevRoomNum 160)
				(doorL cel: 3 init: setScript: closeDoors)
				(doorR cel: 3 init:)
			)
			(else
				(doorL cel: 0 init: stopUpd:)
				(doorR cel: 0 init: stopUpd:)
			)
		)
		(if (Btst 28)
			(proc1_19)
			(ego posn: 160 165 init:)
			(Bclr 28)
		)
	)
	
	(method (doit)
		(cond 
			((ego script?))
			(
				(and
					(== inOut 3)
					(& (ego onControl: 1) $0010)
					(not isNightTime)
				)
				(ego setScript: toGuildHall)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(if (not (Btst 160)) (Bset 160))
		(Bclr 15)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(super handleEvent: pEvent)
		(if
			(or
				(Said 'search,look,examine[<at,around][/room,area][/!*]')
				(Said 'look,examine/courtyard')
			)
			(HighPrint 320 0)
		)
	)
	
	(method (cue)
		(super cue:)
		(if (addToPics contains: carpet)
			(ego illegalBits: (| (ego illegalBits?) $1000))
		)
		(if
			(and
				(not isNightTime)
				(== currentDay 3)
				(not (& (ego illegalBits?) $0800))
			)
			(ego illegalBits: (| (ego illegalBits?) $0800))
		)
	)
)

(instance carpet of PicView
	(properties
		x 217
		y 115
		noun '/carpet,carpet'
		description {the carpet beneath Rakeesh}
		lookStr {The carpet beneath Rakeesh looks well-worn and comfortable.}
		view 168
		loop 9
		priority 0
		signal $4010
	)
)

(instance guildSign of PicView
	(properties
		x 159
		y 37
		noun '/sign[<hall,club,adventurer]'
		description {the Sign of the Adventurer's Guild}
		lookStr {The sign would indicate that the door beneath it is the entrance to the Adventurer's Guild.}
		view 301
		loop 2
		priority 6
		signal $0010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance mosaic of PicView
	(properties
		x 159
		y 189
		noun '/mosaic,tile'
		description {the tile mosaic}
		lookStr {The mosaic tile work is exceptionally well-crafted.}
		view 301
		loop 8
		priority 0
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance windowL of PicView
	(properties
		x 69
		y 51
		noun '/window'
		description {the window}
		lookStr {The window has an outstanding view of the Plaza.}
		view 300
		loop 1
		priority 3
		signal $0010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance windowR of PicView
	(properties
		x 252
		y 51
		noun '/window'
		description {the window}
		lookStr {What a view of the Plaza this window has!}
		view 300
		loop 2
		cel 1
		priority 3
		signal $0010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance doorL of TargActor
	(properties
		x 145
		y 90
		noun '/door[<wooden,hall,club,adventurer]'
		description {the wooden door}
		lookStr {According to the sign above it, this is the entrance to the Adventurer's Guild.}
		view 320
		loop 5
		priority 6
		signal $0010
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(2
				(cond 
					((> (ego distanceTo: self) 35) (Print 320 3))
					(isNightTime (Print 320 4))
					(else (ego setScript: toGuildHall))
				)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
	
	(method (hurtMe)
		(HighPrint 320 1)
		(return 1)
	)
	
	(method (openMe)
		(HighPrint 320 2)
		(return 1)
	)
)

(instance doorR of TargActor
	(properties
		x 173
		y 90
		description {the wooden door}
		lookStr {According to the sign above it, this is the entrance to the Adventurer's Guild.}
		view 320
		loop 4
		priority 6
		signal $0010
	)
	
	(method (hurtMe)
		(HighPrint 320 1)
		(return 1)
	)
	
	(method (openMe)
		(HighPrint 320 2)
		(return 1)
	)
)

(instance saurus of Actor
	(properties
		x 250
		y 144
		noun '/saurii'
		description {your saurus}
		yStep 3
		view 11
		loop 1
		xStep 5
	)
)

(instance theGuard of PicView
	(properties
		x 122
		y 100
		view 294
		loop 2
		cel 5
		priority 7
		signal $0010
	)
)

(instance guardMouth of Talker
	(properties
		x 123
		y 60
		view 294
		loop 4
		priority 8
		signal $4010
		cycleSpeed 1
		illegalBits $0000
		tLoop 4
		said '[/guard,guard]>'
		title {Guard:}
		back 11
	)
	
	(method (init)
		(super init:)
		(= tWindow BotWindow)
	)
)

(instance leftAlleyDoor of Feature
	(properties
		x 5
		y 124
		noun '/door,sign[<alley,bearing,street]'
		nsTop 92
		nsBottom 156
		nsRight 13
		description {the alley door}
		lookStr {You see a dark passage leading South.__The street sign reads "Khanjar Tarik," which means "Dagger Street."}
	)
)

(instance rightAlleyDoor of Feature
	(properties
		x 312
		y 124
		noun '/door,sign[<alley,bearing,street]'
		nsTop 89
		nsLeft 305
		nsBottom 159
		nsRight 320
		description {the alley door}
		lookStr {You see a dark passage leading North.__The street sign reads "Saif Darb," which means "Sword Avenue."}
	)
)

(instance saurusAndGuard of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setHeading: 90)
				(saurus setCycle: Walk setMotion: MoveTo 200 118 self)
				(gSpareMusic number: 291 loop: 1 play:)
				(Print 320 5 #at -1 120 #time 3 #dispose)
			)
			(1
				(ego hide:)
				(saurus
					view: 297
					loop: 1
					cel: 0
					posn: (+ (ego x?) 34) (- (ego y?) 1)
					cycleSpeed: 1
					setCycle: CT 5 1 self
				)
			)
			(2
				(gSpareMusic number: 292 loop: 1 play: self)
				(saurus setCycle: End)
			)
			(3 (Say guardMouth self 320 6))
			(4
				(saurus
					view: 11
					setLoop: 1
					cel: 0
					cycleSpeed: 0
					posn: 200 118
				)
				(ego show: setMotion: MoveTo -5 170 self)
				(= cycles 10)
			)
			(5
				(saurus
					illegalBits: 0
					setCycle: Walk
					setMotion: Follow ego 20
				)
			)
			(6
				(Bset 149)
				(Bset 151)
				(curRoom newRoom: 290)
			)
		)
	)
)

(instance closeDoors of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles 5))
			(1
				(doorL setCycle: Beg self)
				(doorR setCycle: Beg)
			)
			(2
				(doorL stopUpd:)
				(doorR stopUpd:)
				(self dispose:)
			)
		)
	)
)

(instance thrownOut of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 49
					setLoop: 0
					setCel: 0
					posn: 158 95
					setCycle: End self
				)
			)
			(1
				(doorL setCycle: Beg)
				(doorR setCycle: Beg)
				(= cycles 8)
			)
			(2
				(doorL stopUpd:)
				(doorR stopUpd:)
				(ego
					setLoop: 1
					setCel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(3
				(ego posn: (+ (ego x?) 32) (+ (ego y?) 19))
				(proc1_19)
				(= cycles 1)
			)
			(4
				(HighPrint 320 7)
				(self dispose:)
			)
		)
	)
)

(instance toGuildHall of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(doorL setCycle: End self)
				(doorR setCycle: End)
			)
			(1
				(ego illegalBits: 0 setMotion: MoveTo 160 93 self)
			)
			(2
				(= gTopExit (curRoom topExit?))
				(curRoom newRoom: 160)
				(self dispose:)
			)
		)
	)
)
