;;; Sierra Script 1.0 - (do not remove this comment)
(script# 460)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use RasPlaza)
(use n095)
(use Feature)
(use LoadMany)
(use Motion)
(use Actor)
(use System)

(public
	rm460 0
)

(local
	local0
	local1
)
(instance rm460 of RasPlaza
	(properties
		style $0006
		north 703
		south 400
		west 703
		topExit 2
		bottomExit 4
		leftExit 1
	)
	
	(method (init)
		(LoadMany 128 0 4 380 450 31 445)
		(if
			(or
				(== prevRoomNum 610)
				(and (Btst 28) (>= currentDay 30))
			)
			(= currentDay 30)
			(SetGameTime 21 0)
		)
		(if (Btst 96)
			(= gGDftSC gAllSC)
			(Bset 28)
			(= inOut 3)
			(ego view: 4 loop: 4 cel: 0 posn: 72 115)
		)
		(super init:)
		(if (Btst 96)
			(ego init: hide:)
			(gCMusic number: 520 loop: -1 priority: 0 playBed:)
		)
		(if (Btst 96) (self setScript: backWithDjinn))
		(proc1_31 topAlleyDoor leftAlleyDoor)
		(DrawFeature rightDoorBlock lWindow rWindow mosaic)
	)
	
	(method (doit)
		(cond 
			(
				(and
					(Btst 96)
					(not local0)
					local1
					(or (< (ego x?) 6) (< (ego y?) 93))
				)
				(ego
					setMotion: 0
					x: (if (< (ego x?) 100) (+ (ego x?) 5) else (ego x?))
					y: (if (< (ego x?) 100) (ego y?) else (+ (ego y?) 5))
				)
				(= local0 1)
				(DjinniSpeaks 460 0)
			)
			((and local0 (< (ego y?) 93))
				(ego setMotion: 0 posn: (ego x?) (+ (ego y?) 2))
				(ego setScript: toPalace)
			)
			((and local0 (< (ego x?) 6))
				(ego setMotion: 0 posn: (+ (ego x?) 2) (ego y?))
				(ego setScript: fromAlley)
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(Bclr 28)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look,examine<up')
				(if (> currentTimeZone 4)
					(HighPrint 460 1)
				else
					(HighPrint 460 2)
				)
			)
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/courtyard')
				)
				(HighPrint 460 3)
			)
			((Said 'look,examine<down') (HighPrint 460 4))
		)
	)
)

(instance mosaic of PicView
	(properties
		x 159
		y 191
		noun '/mosaic,pattern'
		description {the cracked and dirty}
		lookStr {The mosaic is cracked and dirty.}
		view 450
		loop 1
		priority 1
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance lWindow of PicView
	(properties
		x 74
		y 52
		noun '/window'
		description {the window}
		lookStr {Once, this window overlooked a clean and busy Plaza.}
		view 450
		loop 2
		cel 1
		priority 14
		signal $0010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance rWindow of PicView
	(properties
		x 251
		y 52
		description {the window}
		lookStr {No one has looked out of this window onto the Plaza for a long, long time.}
		view 450
		loop 3
		cel 1
		priority 14
		signal $0010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance sparkle of Prop
	(properties
		x 72
		y 118
		description {the magical light}
		view 31
		loop 4
		signal $6000
	)
)

(instance sharaf of Actor
	(properties
		view 445
		loop 4
	)
)

(instance backWithDjinn of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(sparkle init: cycleSpeed: 2 setCycle: End self)
			)
			(1
				(sparkle dispose:)
				(ego posn: 72 115 loop: 4 show:)
				(= seconds 2)
			)
			(2
				(DjinniSpeaks 460 5)
				(= seconds 2)
			)
			(3
				(DjinniSpeaks 460 6)
				(DjinniSpeaks 460 7)
				(DjinniSpeaks 460 8)
				(= local1 1)
				(= seconds 1)
			)
			(4
				(if (Btst 94)
					(self cue:)
				else
					(LockEgo)
					(self dispose:)
				)
			)
			(5
				(HighPrint 460 9)
				(= seconds 1)
			)
			(6
				(HighPrint 460 10 80 {Sharaf:})
				(= seconds 1)
			)
			(7
				(sharaf
					posn: -9 187
					init:
					setLoop: 4
					setCycle: Walk
					setMotion: MoveTo 111 120 self
				)
			)
			(8
				(sharaf setLoop: 1 setMotion: MoveTo 105 112 self)
			)
			(9
				(HighPrint 460 11 80 {Sharaf:})
				(= seconds 3)
			)
			(10
				(sharaf
					setCycle: Walk
					setLoop: 4
					illegalBits: 0
					setMotion: MoveTo 205 74
				)
				(= seconds 3)
			)
			(11
				(sharaf dispose:)
				(HighPrint 460 12 103 25 4)
				(= seconds 1)
			)
			(12 (LockEgo) (= seconds 5))
			(13 (self dispose:))
		)
	)
)

(instance toPalace of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setCycle: Walk
					setMotion: MoveTo (ego x?) (+ (ego y?) 20) self
				)
			)
			(1
				(if (and (== currentDay 30) (> currentTimeZone 4))
					(DjinniSpeaks 460 13)
				else
					(DjinniSpeaks 460 14)
				)
				(= seconds 1)
			)
			(2 (self dispose:))
		)
	)
)

(instance fromAlley of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					setCycle: Walk
					setMotion: MoveTo (+ (ego x?) 15) (ego y?) self
				)
			)
			(1
				(if (and (== currentDay 30) (> currentTimeZone 4))
					(DjinniSpeaks 460 13)
				else
					(DjinniSpeaks 460 14)
				)
				(= seconds 1)
			)
			(2 (self dispose:))
		)
	)
)

(instance rightDoorBlock of PicView
	(properties
		x 314
		y 156
		noun '/door,sign,barricade,board,alley[<alley,bearing,street]'
		description {the barricade}
		lookStr {The alley is securely blocked by a barricade of boards.__You can barely discern a sign reading:\n"All Fed-Ex packages must be out by 2:30!"}
		view 384
		loop 3
		priority 11
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance leftAlleyDoor of Feature
	(properties
		x 5
		y 124
		noun '/door,sign,barricade,board,alley[<alley,bearing,street]'
		nsTop 92
		nsBottom 156
		nsRight 13
		description {the alley leading North}
		lookStr {You see a dark foreboding passage leading North.__The street sign reads:\n"Any order from a guard is a rule!"}
	)
)

(instance topAlleyDoor of Feature
	(properties
		x 158
		y 67
		noun '/door,sign,barricade,board,alley[<alley,bearing,street]'
		nsTop 38
		nsLeft 132
		nsBottom 91
		nsRight 185
		description {the alley leading East}
		lookStr {You see a dark foreboding passage leading East.__The street sign reads:\n"Everything not mandatory is forbidden!"}
	)
)
