;;; Sierra Script 1.0 - (do not remove this comment)
(script# 860)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Intrface)
(use Feature)
(use LoadMany)
(use Motion)
(use Game)
(use Actor)

(public
	rm860 0
)

(local
	local0
	local1
	local2
	[newASaury 10]
	[newANearDude 5]
	[newAFarDude 5]
	local23
)
(procedure (localproc_000c theDefaultPalette &tmp temp0)
	(= defaultPalette theDefaultPalette)
	(curRoom drawPic: 663 8)
	(if
	(or (== theDefaultPalette 1) (== theDefaultPalette 2))
		(= temp0 2)
	else
		(= temp0 1)
	)
	(waist palette: temp0)
	(saurTop palette: temp0)
	(saurBottom palette: temp0)
	(DrawFeature waist saurTop saurBottom)
)

(procedure (localproc_006a)
	(= [newANearDude local1] (aNearDude new:))
	([newANearDude local1]
		init:
		setCycle: Fwd
		setMotion: MoveTo 330 122
	)
	(return (++ local1))
)

(procedure (localproc_0097)
	(= [newAFarDude local2] (aFarDude new:))
	([newAFarDude local2]
		init:
		setCycle: Fwd
		setMotion: MoveTo 330 118
	)
	(return (++ local2))
)

(procedure (localproc_00c4)
	((= [newASaury local0] (aSaury new:))
		loop:
			(cond 
				((or (== local0 0) (== local0 5)) 10)
				((or (== local0 1) (== local0 6)) 8)
				(else 11)
			)
		init:
		setCycle: Fwd
		setMotion: MoveTo 330 120
	)
	(return (++ local0))
)

(instance aSaury of Actor
	(properties
		x 48
		y 120
		description {the caravan}
		view 861
		priority 2
		signal $4810
		xStep 1
	)
	
	(method (doit)
		(if (== (self x?) 63)
			(if (< local0 (+ 2 (* gSeconds 2))) (localproc_00c4))
			(if (== (self loop?) 10) (localproc_0097))
			(if (== (self loop?) 8) (localproc_006a))
		)
		(super doit:)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(1
				(cond 
					((== loop 10) (HighPrint 860 0))
					((== loop 11) (HighPrint 860 1))
					(else (HighPrint 860 2))
				)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance aNearDude of Actor
	(properties
		x 69
		y 122
		noun '/man,ride,member'
		description {the rider}
		lookStr {One of the riders of the caravan.}
		view 861
		loop 8
		priority 2
		signal $4810
		xStep 1
	)
)

(instance aFarDude of Actor
	(properties
		x 69
		y 118
		noun '/man,ride,member'
		description {the rider}
		lookStr {One of the riders of the caravan.}
		view 861
		loop 8
		priority 2
		signal $4810
		illegalBits $0000
		xStep 1
	)
)

(instance rm860 of Rm
	(properties
		picture 2
		style $0007
	)
	
	(method (init)
		(LoadMany 128 860 861)
		(Load rsPIC 663)
		(Load rsSOUND 790)
		(ego get: 50)
		(super init:)
		(UnlockEgo)
		(self setScript: startIt)
	)
	
	(method (doit)
		(cond 
			((not local23))
			((-- local23))
			(else (curRoom newRoom: 861))
		)
		(super doit:)
	)
)

(instance sun of Actor
	(properties
		x 200
		y 100
		yStep 3
		view 860
		loop 8
		signal $0010
	)
)

(instance torso of Prop
	(properties
		x 138
		y 178
		noun 'ya,hero'
		description {yourself}
		lookStr {What a dashing foreign devil you are!}
		view 860
		loop 4
		priority 15
		signal $0010
	)
)

(instance waist of PicView
	(properties
		x 140
		y 189
		noun 'ya,hero'
		description {yourself}
		lookStr {What a buffed-out dude you are!}
		view 860
		loop 7
		priority 15
		signal $4010
	)
)

(instance egoHead of Prop
	(properties
		x 142
		y 130
		noun 'ya,hero'
		description {yourself}
		lookStr {What a dashing foreign devil you are!}
		view 860
		priority 14
		signal $0010
	)
)

(instance leftArm of Prop
	(properties
		x 161
		y 186
		noun 'ya,hero'
		description {yourself}
		lookStr {Check out those biceps!}
		view 860
		loop 2
		priority 14
		signal $0010
	)
)

(instance rightArm of Prop
	(properties
		x 111
		y 180
		noun 'ya,hero'
		description {yourself}
		lookStr {Check out those biceps!}
		view 860
		loop 3
		priority 14
		signal $0010
	)
)

(instance reins of Prop
	(properties
		x 74
		y 146
		noun '/rein'
		description {the reins}
		lookStr {Used for manual guidance of this type of ATV.}
		view 860
		loop 1
		priority 14
		signal $0010
		cycleSpeed 1
	)
)

(instance saurTop of PicView
	(properties
		x 40
		y 118
		noun 'head,saurii'
		description 'the&saurii'
		lookStr {A "ship of the desert?"}
		view 860
		loop 5
		priority 15
		signal $0010
	)
)

(instance saurBottom of PicView
	(properties
		x 34
		y 189
		noun 'saurii'
		description 'the&saurii'
		lookStr {Mighty muscular.}
		view 860
		loop 6
		priority 15
		signal $0010
	)
)

(instance rock of Feature
	(properties
		x 233
		y 147
		noun '/boulder'
		nsTop 140
		nsLeft 209
		nsBottom 154
		nsRight 258
		description {the rock}
		lookStr {A rock by any other name....}
	)
)

(instance sky of Feature
	(properties
		x 200
		y 33
		noun '/sky'
		nsLeft 81
		nsBottom 66
		nsRight 319
		description {the crisp, morning sky}
		lookStr {The crisp, beautiful sky makes you feel glad to be alive.}
	)
)

(instance sky2 of Feature
	(properties
		x 40
		y 21
		noun '/sky'
		nsBottom 43
		nsRight 80
		description {the crisp, morning sky}
		lookStr {The crisp, beautiful sky makes you feel glad to be alive.}
	)
)

(instance dunes of Feature
	(properties
		x 200
		y 86
		noun '/hill,dune,sand'
		nsTop 67
		nsLeft 81
		nsBottom 106
		nsRight 319
		description {sand dunes}
		lookStr {The ever-changing, shifting dunes of the desert are ever shifting and changing.}
	)
)

(instance startIt of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 4))
			(1 (Print 860 3) (= seconds 1))
			(2 (Print 860 4) (= seconds 1))
			(3 (Print 860 5) (= seconds 1))
			(4 (Print 860 6) (= seconds 1))
			(5
				(gCMusic number: 790 loop: -1 priority: 0 playBed:)
				(localproc_000c 1)
				(egoHead palette: 2 init:)
				(torso palette: 2 init:)
				(rightArm palette: 2 init:)
				(leftArm palette: 2 init:)
				(reins palette: 2 init:)
				(if (> gSeconds 0)
					(egoHead setCycle: Fwd)
					(torso setCycle: Fwd)
					(rightArm setCycle: Fwd)
					(leftArm setCycle: Fwd)
					(reins setCycle: Fwd)
				else
					(egoHead stopUpd:)
					(torso stopUpd:)
					(rightArm stopUpd:)
					(leftArm stopUpd:)
					(reins stopUpd:)
				)
				(if gSeconds (= seconds gSeconds) else (= cycles 1))
			)
			(6
				(localproc_000c 2)
				(if gSeconds (= seconds gSeconds) else (= cycles 1))
			)
			(7
				(localproc_000c 3)
				(egoHead palette: 1 forceUpd:)
				(torso palette: 1 forceUpd:)
				(rightArm palette: 1 forceUpd:)
				(leftArm palette: 1 forceUpd:)
				(reins palette: 1 forceUpd:)
				(sun
					init:
					setLoop: 8
					setCycle: Fwd
					setMotion: MoveTo 160 -50
				)
				(if gSeconds (= seconds gSeconds) else (= cycles 1))
			)
			(8
				(sun setMotion: 0 stopUpd:)
				(localproc_000c 0)
				(proc1_31 rock sky sky2 dunes)
				(= local23 150)
				(localproc_00c4)
				(if gSeconds
					(= seconds (/ (+ gSeconds 1) 2))
				else
					(= cycles 1)
				)
			)
			(9
				(= currentDay 18)
				(SetGameTime 9 0)
				(self dispose:)
			)
		)
	)
)
