;;; Sierra Script 1.0 - (do not remove this comment)
(script# 872)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Intrface)
(use Feature)
(use LoadMany)
(use Motion)
(use Game)
(use Actor)

(public
	rm872 0
)

(instance saury1 of Actor
	(properties
		x -10
		y 125
		noun '/centaur,leader'
		description {the Centaur}
		lookStr {Of course the Centaur survived the battle.}
		view 861
		loop 10
		signal $4800
		illegalBits $0000
		xStep 1
	)
)

(instance saury2 of Actor
	(properties
		x -20
		y 125
		noun '/saurii'
		description {the caravaner}
		lookStr {At least part of the caravan survived the battle.}
		view 861
		loop 11
		signal $4800
		illegalBits $0000
		xStep 1
	)
)

(instance saury3 of Actor
	(properties
		x -30
		y 125
		noun '/beast'
		description {the caravaner on this side}
		lookStr {At least part of the caravan survived the battle.}
		view 861
		loop 11
		signal $4800
		illegalBits $0000
		xStep 1
	)
)

(instance nearDude of Actor
	(properties
		x -25
		y 127
		noun '/man'
		description {the caravaner on that side}
		lookStr {This guy survived the battle.}
		view 861
		loop 8
		signal $4800
		illegalBits $0000
		xStep 1
	)
)

(instance farDude of Actor
	(properties
		x -5
		y 123
		noun '/man'
		description {the survivor}
		lookStr {This guy survived the battle.}
		view 861
		loop 8
		signal $4800
		illegalBits $0000
		xStep 1
	)
)

(instance rm872 of Rm
	(properties
		picture 664
		style $0006
	)
	
	(method (init)
		(LoadMany 129 2 780)
		(LoadMany 128 13 861 12 780)
		(Load rsPIC 2 780)
		(Load rsSOUND 790)
		(super init:)
		(gCMusic number: 790 loop: -1 priority: 0 playBed:)
		(self setScript: truckin)
	)
)

(instance truckin of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= currentDay 27)
				(SetGameTime 9 0)
				(proc1_31 sky hills sand)
				(ego
					view: 13
					setLoop: 0
					posn: -12 127
					init:
					xStep: 1
					yStep: 1
					cycleSpeed: 0
					setMotion: MoveTo 300 127
				)
				(saury1 init: setCycle: Walk setMotion: MoveTo 300 125)
				(if (> gSeconds 0)
					(saury2 init: setCycle: Walk setMotion: MoveTo 300 125)
					(farDude init: setCycle: Walk setMotion: MoveTo 300 123)
					(if (> gSeconds 1)
						(saury3 init: setCycle: Walk setMotion: MoveTo 300 125)
						(nearDude init: setCycle: Walk setMotion: MoveTo 300 127)
					)
				)
				(= seconds 1)
			)
			(1 (= seconds 8))
			(2
				(ego hide:)
				(saury1 dispose:)
				(if (> gSeconds 0)
					(saury2 dispose:)
					(farDude dispose:)
					(if (> gSeconds 1)
						(saury3 dispose:)
						(nearDude dispose:)
					)
				)
				(sky dispose:)
				(hills dispose:)
				(sand dispose:)
				(curRoom drawPic: 2)
				(= seconds 2)
			)
			(3 (Print 872 0) (= seconds 1))
			(4 (Print 872 1) (= seconds 1))
			(5 (Print 872 2) (= seconds 1))
			(6 (Print 872 3) (= seconds 1))
			(7
				(curRoom drawPic: 780)
				(SetGameTime 14 0)
				(DrawFeature raseir)
				(proc1_31 sky2 sand2 hill2 hill3)
				(ego
					view: 12
					setLoop: 3
					setPri: 10
					posn: 148 250
					yStep: 3
					show:
					setMotion: MoveTo 148 138 self
				)
			)
			(8
				(ego setPri: 2 setMotion: MoveTo 148 196 self)
			)
			(9
				(ego
					view: 13
					loop: 3
					yStep: 1
					posn: 148 166
					setMotion: MoveTo 148 104 self
				)
			)
			(10
				(ego setPri: 1 setMotion: MoveTo 148 120 self)
			)
			(11
				(= currentDay 27)
				(gCMusic fade:)
				(curRoom newRoom: 380)
				(self dispose:)
			)
		)
	)
)

(instance raseir of PicView
	(properties
		x 135
		y 90
		description {the city}
		lookStr {Ah, Raseir.}
		view 780
		loop 2
		cel 1
		priority 0
		signal $4010
	)
)

(instance sky of Feature
	(properties
		x 159
		y 24
		noun '/sky'
		nsBottom 49
		nsRight 319
		description {the sky}
		lookStr {It's a clear blue sky out here.}
	)
)

(instance hills of Feature
	(properties
		x 159
		y 74
		noun '/hill'
		nsTop 49
		nsBottom 99
		nsRight 318
		description {hill}
		lookStr {The hills around here are stark and dry, just like Coarsegold.}
	)
)

(instance sand of Feature
	(properties
		x 159
		y 144
		noun '/sand'
		nsTop 99
		nsBottom 189
		nsRight 318
		description {the sand}
		lookStr {Nothing but sand, sand, and more sand.}
	)
)

(instance sky2 of Feature
	(properties
		x 159
		y 23
		noun '/sky'
		nsBottom 46
		nsRight 318
		description {the sky}
		lookStr {Different picture, same sky.}
	)
)

(instance sand2 of Feature
	(properties
		x 166
		y 141
		noun '/sand'
		nsTop 94
		nsLeft 53
		nsBottom 189
		nsRight 275
		description {sand}
		lookStr {Sand, sand and more sand.}
	)
)

(instance hill2 of Feature
	(properties
		x 25
		y 90
		noun '/hill'
		nsTop 46
		nsBottom 135
		nsRight 51
		description {the hill}
		lookStr {The hills are stark barren rock.}
	)
)

(instance hill3 of Feature
	(properties
		x 296
		y 95
		noun '/hill'
		nsTop 45
		nsLeft 275
		nsBottom 146
		nsRight 318
		description {the hill}
		lookStr {The hills are stark barren rock.}
	)
)
