;;; Sierra Script 1.0 - (do not remove this comment)
(script# 330)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use Talker)
(use TargActor)
(use Flame)
(use Plaza)
(use Merchant)
(use MsgMerchant)
(use PlazaDoor)
(use Polygon)
(use Motion)
(use Actor)
(use System)

(public
	rmSPlazaFightersE 0
)

(local
	gEgoView
	gEgoLoop
	gEgoCel
	gEgoCycler
	local4
	local5
	[local6 8] = [161 '//cloth,clothes,veil,merchandise' 162 '//bag[<cloth,about]' 163 '//family,tiram,tashtari,toshar,sloree,sava,sashanan,nephew,kiram']
	[local14 8] = [152 '//leather,leatherwork,merchandise' 153 '//belt,boot' 154 '//waterbag']
)
(instance rmSPlazaFightersE of Plaza
	(properties
		north 704
		south 320
		topExit 2
		bottomExit 4
	)
	
	(method (init)
		(self
			addObstacle:
				(poly1
					init:
						0
						178
						0
						0
						319
						0
						319
						188
						284
						132
						239
						132
						201
						105
						199
						94
						173
						93
						170
						8
						146
						8
						146
						93
						87
						100
						54
						118
						63
						140
						44
						167
						20
						178
					yourself:
				)
		)
		(super init:)
		(= gLevMe (= gGetBellows getBellows))
		(= global166 70)
		(= global168 20)
		(if
			(and
				(<= 0 currentTimeZone)
				(<= currentTimeZone 4)
				(not (proc80_0))
			)
			(mirak init:)
			(kiram init:)
			(= saveIllegal -20480)
		)
		(weaponsShopDoor init:)
		(if (not (Btst 85))
			(bellows palette: (if isNightTime 2 else 1) init:)
		)
		(DrawFeature
			mosaic
			rightWindow
			alleySign
			weaponsShopSign
			doorFrame
		)
	)
	
	(method (dispose)
		(= gLevMe (= gGetBellows 0))
		(super dispose: &rest)
	)
)

(instance weaponsShopDoor of PlazaDoor
	(properties
		x 67
		y 114
		noun '/door[<shop,weapon,issur]'
		description {the door to the Weapons Shop}
		lookStr {The sign above it indicates that the door leads to the Weapons Shop.}
		view 301
		loop 4
		priority 6
		signal $4010
		entranceTo 140
		exitDir 1
		xOut 37
		yOut 111
		xIn 84
		yIn 111
	)
	
	(method (init)
		(super init: &rest)
		(= barred (Btst 115))
	)
	
	(method (cue)
		(if (and (Btst 115) (== state 1)) (HighPrint 330 0))
		(super cue:)
	)
	
	(method (enter)
		(if (Btst 25)
			(curRoom inOut: 3)
			(= xIn 55)
			(= yIn 110)
			(self setScript: thrownIn curRoom)
		else
			(super enter:)
		)
	)
)

(instance kiram of MsgMerchant
	(properties
		x 239
		y 111
		description {a clothing merchant}
		lookStr {Kiram is the local clothing merchant.}
		loop 1
		cel 3
		priority 7
		signal $4010
		myName '//kiram,(merchant[<clothes,about]),catperson'
		title {Kiram:}
		isSeated 0
		isOnLeft 0
		clothesColor 5
		firstMsgNum 155
	)
	
	(method (init)
		(super init:)
		(DrawFeature cloth clothes clothesStand)
		(self addWares: clothBag)
		(= lastMsgSaid gLastMsgSaid_5)
	)
	
	(method (dispose)
		(= gLastMsgSaid_5 lastMsgSaid)
		(super dispose:)
	)
	
	(method (showSelf)
		(Say self 330 9)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((Said 'ask//leather,leatherwork,waterbag') (Say self 330 3))
			((Said 'ask//mirak') (Say self 330 4))
			((Said 'ask//issur,weapon,blade,dagger,shield') (Say self 330 5))
			((Said 'tell>')
				(if
				(and (Said '//elemental<earth>') (not (Btst 84)))
					(Say self 330 6)
					(TestSkill 13 100)
					(AddToScore 625 7)
					(ego get: 38)
					(Bset 84)
					(= local5 1)
				else
					(Say self 330 7)
				)
				(pEvent claimed: 1)
			)
			((and (Said 'thank>') local5)
				(SkillUsed 13 30)
				(SkillUsed 14 50)
				(SayThanks self 330 8)
				(= local5 0)
				(pEvent claimed: 1)
			)
		)
		(if (not (pEvent claimed?))
			(super handleEvent: pEvent)
		)
		(pEvent claimed?)
	)
	
	(method (has)
		(return
			(cond 
				((or (Said '/clothes') (Said '//clothes')) (HighPrint 330 1) (return -1))
				(
				(or (Said '/cloth,veil') (Said '//cloth,veil')) (HighPrint 330 2) (return -1))
				(else (return (super has:)))
			)
		)
	)
	
	(method (sell)
		(if (== curWare clothBag) (AddToScore 625 7))
		(super sell: &rest)
	)
	
	(method (sayBargainSuccess)
		(Say self self 330 10)
	)
	
	(method (sayBargainFailure)
		(Say self self 330 11)
	)
	
	(method (atIndividualSpec param1)
		(return [local6 param1])
	)
)

(instance clothBag of Class_84_1
	(properties
		invItem 38
		noun '//bag[<cloth,about,for]>'
		price 50
		lowPrice 20
	)
)

(instance clothesStand of PicView
	(properties
		x 247
		y 126
		noun '/stand,stall[<clothes]'
		description {a clothing stand}
		lookStr {It is the stand of Kiram, the local clothing merchant.}
		view 335
		loop 1
		signal $4000
	)
)

(instance cloth of PicView
	(properties
		x 249
		y 112
		noun '/cloth,good'
		description {cloth goods}
		lookStr {The cloth looks very well made, indeed.}
		view 330
		priority 8
		signal $4010
	)
)

(instance clothes of PicView
	(properties
		x 270
		y 98
		noun '/clothes'
		description {clothing}
		lookStr {The clothing looks very well made, indeed.}
		view 330
		cel 1
		priority 9
		signal $4010
	)
)

(instance mirak of MsgMerchant
	(properties
		x 11
		y 161
		description {Mirak, the leather merchant}
		lookStr {Mirak is the local leather merchant.}
		priority 11
		signal $4010
		myName '//mirak,(merchant[<leather]),catperson'
		title {Mirak:}
		clothesColor 2
		firstMsgNum 146
	)
	
	(method (init)
		(super init:)
		(DrawFeature leather leatherGoods leatherStand)
		(self addWares: waterskin)
		(= lastMsgSaid gLastMsgSaid_6)
	)
	
	(method (dispose)
		(= gLastMsgSaid_6 lastMsgSaid)
		(super dispose:)
	)
	
	(method (showSelf)
		(Say self 330 12)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((Said 'ask//cloth,clothes,veil') (Say self 330 15))
			((Said 'ask//kiram') (Say self 330 16))
			((Said 'ask//issur,weapon,blade,dagger,shield') (Say self 330 5))
			((Said 'tell>')
				(if
					(and
						(Said '//plant,(elemental<fire),(elemental<water)>')
						(not (Btst 83))
					)
					(Say self 330 17)
					(ego get: 37)
					(Bset 83)
					(= local4 1)
				else
					(Say self 330 18)
				)
				(pEvent claimed: 1)
			)
			((and (Said 'thank>') local4)
				(SkillUsed 13 30)
				(SkillUsed 14 30)
				(SayThanks self 330 19)
				(= local4 0)
				(pEvent claimed: 1)
			)
		)
		(if (not (pEvent claimed?))
			(super handleEvent: pEvent)
			(if
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/courtyard')
				)
				(HighPrint 330 20)
			)
		)
		(pEvent claimed?)
	)
	
	(method (has)
		(return
			(if
				(or
					(Said '/belt,boot,leather')
					(Said '//belt,boot,leather')
				)
				(HighPrint 330 2)
				(return -1)
			else
				(return (super has:))
			)
		)
	)
	
	(method (sayBargainSuccess)
		(Say self self 330 13)
	)
	
	(method (sayBargainFailure)
		(Say self self 330 14)
	)
	
	(method (atIndividualSpec param1)
		(return [local14 param1])
	)
)

(instance waterskin of Class_84_1
	(properties
		invItem 37
		noun '//waterbag,skin>'
		price 100
		lowPrice 50
	)
)

(instance leatherStand of PicView
	(properties
		x 25
		y 166
		noun '/stand,stall[<leather]'
		description {the stand of Mirak, the leather merchant}
		lookStr {It is the stand of Mirak, the local leather merchant.}
		view 300
		loop 8
		priority 11
		signal $4010
	)
)

(instance leatherGoods of PicView
	(properties
		x 33
		y 166
		z 21
		noun '/good,item[<leather]'
		description {leather goods}
		lookStr {Very fine saurus skin.}
		view 300
		loop 7
		cel 2
		priority 11
		signal $4010
	)
)

(instance leather of PicView
	(properties
		x 9
		y 120
		noun '/good,item[<leather]'
		description {leather goods}
		lookStr {Very fine saurus hide.}
		view 300
		loop 7
		cel 3
		priority 11
		signal $4010
	)
)

(instance weaponsShopSign of PicView
	(properties
		x 65
		y 56
		noun '/sign[<shop,weapon,issur]'
		description {the sign of the Weapons Shop}
		lookStr {According to the sign, the door below it must lead to the Weapons Shop.}
		view 301
		cel 4
		priority 6
		signal $0010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance alleySign of PicView
	(properties
		x 160
		y 46
		shiftClick 0
		view 310
		loop 2
		cel 1
		priority 6
		signal $0010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance rightWindow of PicView
	(properties
		x 252
		y 51
		noun '/window'
		description {a window}
		lookStr {The window commands a view of the entire plaza.}
		view 300
		loop 2
		cel 1
		priority 6
		signal $0010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance bellows of TargActor
	(properties
		x 64
		y 35
		noun '/bellows'
		description {the bellows}
		lookStr {The emblem of the bellows above the door looks like the real thing.}
		view 330
		cel 2
		priority 7
		signal $0010
	)
	
	(method (init)
		(super init:)
		(self stopUpd:)
	)
	
	(method (fetchMe)
		(AddToScore 609 7)
		(ego get: 25)
		(SkillUsed 14 -100)
		(Bset 85)
		(return 1)
	)
	
	(method (hurtMe param1 param2)
		(if (OneOf (param2 type?) 25 27)
			(bellowsFlame init: (param2 x?) (param2 y?))
		)
		(return 0)
	)
)

(instance doorFrame of PicView
	(properties
		x 51
		y 116
		shiftClick 0
		view 301
		loop 7
		priority 6
		signal $0010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance mosaic of PicView
	(properties
		x 159
		y 189
		noun '/mosaic,tile'
		description {the tile mosaic}
		lookStr {The mosaic tile work is exceptionally well-crafted.}
		view 301
		loop 8
		priority 7
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance getBellows of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (not (ego inRect: 53 96 121 131))
					(HighPrint 330 21)
					(= caller 0)
					(client dispose:)
				else
					(ego setMotion: MoveTo 96 123 self)
				)
			)
			(1 (ego setHeading: 270 self))
			(2 (= caller 0) (client cue:))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((< state 2))
			((Said 'get,acquire/bellows')
				(cond 
					((Btst 85) (HighPrint 330 22))
					((> (- (ego y?) (ego z?)) 75) (HighPrint 330 23))
					(else (self setScript: grabBellows))
				)
			)
		)
		(pEvent claimed?)
	)
)

(instance grabBellows of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= gEgoView (ego view?))
				(= gEgoLoop (ego loop?))
				(= gEgoCel (ego cel?))
				(= gEgoCycler (ego cycler?))
				(ego
					view: 6
					setLoop: 7
					cel: 0
					cycler: 0
					setCycle: End self
				)
			)
			(1 (= cycles 5))
			(2
				(ego setCycle: Beg self)
				(AddToScore 609 7)
				(SkillUsed 14 -100)
				(ego get: 25)
				(Bset 85)
				(bellows dispose:)
			)
			(3
				(ego
					view: gEgoView
					setLoop: gEgoLoop
					setCycle: gEgoCycler
					cel: gEgoCel
				)
				(self dispose:)
			)
		)
	)
)

(instance thrownIn of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(UnlockEgo)
				(curRoom inOut: 1)
				(client savePri: (client priority?))
				(client setPri: 2)
				(ego
					setPri: 3
					illegalBits: 0
					view: 49
					loop: 0
					cel: 1
					illegalBits: 0
					posn: 55 110
					setCycle: End self
				)
			)
			(1 (client close:))
			(2 (= cycles 10))
			(3
				(ego loop: 1 cel: 0 cycleSpeed: 1 setCycle: End self)
			)
			(4
				(ego
					view: 4
					loop: 4
					cel: 0
					posn: (+ (ego x?) 34) (+ (ego y?) 19)
					cycleSpeed: 0
					heading: 135
				)
				(client setPri: (client savePri?))
				(proc1_19)
				(LockEgo 1)
				(self dispose:)
			)
		)
	)
)

(instance bellowsFlame of Fire
	(properties)
	
	(method (init theX theY)
		(super init:)
		(UnlockEgo)
		(= x theX)
		(= y theY)
		(self setPri: 15)
		(= burnTime 60)
	)
	
	(method (dispose)
		(super dispose: delete:)
		(bellows hide:)
		(SetUpEgo)
		(HighPrint 330 24)
		(= currentDay 9)
		(curRoom newRoom: 340)
	)
)

(instance poly1 of Polygon
	(properties
		type $0002
	)
)
