;;; Sierra Script 1.0 - (do not remove this comment)
(script# 335)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use HandsOffScript)
(use Talker)
(use Plaza)
(use KattaMerchant)
(use Polygon)
(use LoadMany)
(use Avoider)
(use Motion)
(use Actor)
(use System)

(public
	rmSPlazaPalace 0
)

(local
	local0
	local1
	local2
	local3
	local4
	[local5 6] = [36 '//carpet,merchandise' 37 '//carpet<magic']
	[local11 10] = [-2 '//gem,gem,necklace,bracelet,gold,silver,merchandise' -1 '//pin,sapphire' 42 '//cost' 43 '//gift']
	[local21 25] = [8 53 335 0 335 1 2 51 335 2 335 3 4 52 335 4 335 5 6 54 335 6 335 7 -1]
)
(instance sayEntranceSpeeches of Script
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(= temp0 0)
				(while (!= [local21 temp0] -1)
					(if
						(and
							(== elementalsStatus [local21 temp0])
							(not (Btst [local21 (+ temp0 1)]))
						)
						(= local2 [local21 (+ temp0 1)])
						(Say
							tiram
							self
							[local21 (+ temp0 2)]
							[local21 (+ temp0 3)]
						)
						(= local0 [local21 (+ temp0 4)])
						(= local1 [local21 (+ temp0 5)])
						(break)
					)
					(= temp0 (+ temp0 6))
				)
				(if (== [local21 temp0] -1) (self dispose:))
			)
			(1
				(Say sashanan self local0 local1)
			)
			(2
				(if (== local2 53)
					(self setScript: givePin self)
				else
					(self cue:)
				)
			)
			(3
				(Bset local2)
				(self dispose:)
			)
		)
	)
)

(instance givePin of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Say sashanan self 335 8))
			(1
				(ego setAvoider: Avoid setMotion: MoveTo 212 123 self)
			)
			(2
				(FaceObject ego sashanan 1)
				(= seconds 2)
			)
			(3
				(AddToScore 627 5)
				(ego setAvoider: 0 get: 27)
				(Bset 148)
				(HighPrint 335 9)
				(if [skills 9] (HighPrint 335 10))
				(= local3 1)
				(self dispose:)
			)
		)
	)
)

(instance rmSPlazaPalace of Plaza
	(properties
		north 704
		east 704
		south 240
		west 704
		topExit 4
		bottomExit 2
		rightExit 1
		leftExit 3
	)
	
	(method (init)
		(LoadMany 128 335 310 350 300 301)
		(self
			addObstacle:
				(poly1
					init:
						0
						161
						0
						0
						319
						0
						319
						161
						305
						161
						277
						132
						234
						132
						221
						132
						183
						101
						171
						101
						172
						10
						148
						10
						147
						57
						147
						101
						114
						112
						77
						142
						32
						158
					yourself:
				)
		)
		(super init:)
		(DrawFeature westSign rightWindow leftWindow mosaic)
		(cond 
			(
				(and
					(<= 0 currentTimeZone)
					(<= currentTimeZone 4)
					(not (proc80_0))
				)
				(sashanan init:)
				(tiram init:)
				(= entranceScript sayEntranceSpeeches)
			)
			((== elementalsStatus 3) ((ScriptID 241 0) init:))
		)
	)
)

(instance sashanan of KattaMerchant
	(properties
		x 232
		y 108
		description {Sashanan, the jewelry merchant}
		lookStr {It is Sashanan, the jewelry merchant.}
		myName '//sashanan,catperson,(merchant[<gem,gem,necklace,bracelet])'
		title {Sashanan:}
		isSeated 0
		isOnLeft 0
		clothesColor 4
	)
	
	(method (init)
		(super init:)
		(DrawFeature jewelryStand jewelry)
	)
	
	(method (doit)
		(super doit:)
		(if (not (& (ego illegalBits?) $1000))
			(ego illegalBits: (| (ego illegalBits?) $1000))
		)
		(if (curRoom script?) (return))
		(if
			(and
				(not (Btst 50))
				(< (ego distanceTo: sashanan) 50)
			)
			(Say self 335 20)
			(Bset 50)
		)
	)
	
	(method (showSelf)
		(Say self 335 21)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if (== (pEvent type?) evSAID)
			(= temp0 local4)
			(= local4 0)
		else
			(= temp0 0)
		)
		(cond 
			((Said 'ask//carpet') (Say self 335 11))
			((Said 'ask//tiram') (Say self 335 12))
			(temp0
				(if
					(or
						(Said 'affirmative')
						(Said 'bargain/pin')
						(Said 'bargain//pin')
					)
					(HighPrint 335 13)
				)
				(Say self 335 14)
				(pEvent claimed: 1)
			)
			((and local3 (not (Btst 148)) (Said 'thank')) (Bset 148) (curRoom setScript: thanksForPin))
			((Said 'buy,bargain/gem,gem,necklace,bracelet') (self showText: -2))
			(
			(or (Said 'buy,bargain/pin') (Said 'bargain//pin'))
				(if (Btst 148)
					(Say self 335 15)
				else
					(Say self 335 16)
					(= local4 1)
				)
			)
			((Said 'get,acquire,look,examine/pin')
				(if (Btst 148)
					(HighPrint 335 17)
				else
					(HighPrint 335 18)
				)
			)
			((super handleEvent: pEvent) 0)
			(
				(or
					(Said 'search,look,examine[<at,around][/room,area][/!*]')
					(Said 'look,examine/courtyard')
				)
				(HighPrint 335 19)
			)
		)
		(pEvent claimed?)
	)
	
	(method (showText param1)
		(switch param1
			(-2
				(if (ego has: 27)
					(super showText: 38)
				else
					(super showMany: 38 39)
				)
			)
			(-1
				(if (ego has: 27)
					(super showText: 41)
				else
					(super showText: 40)
				)
			)
			(else  (super showText: param1))
		)
	)
	
	(method (atIndividualSpec param1)
		(return [local11 param1])
	)
)

(instance jewelryStand of PicView
	(properties
		x 242
		y 123
		noun '/stand[<gem,gem,necklace,bracelet]'
		description {the jewelry stand of Sashanan}
		lookStr {It is Sashanan's jewelry stand.}
		view 335
		loop 1
		signal $4000
	)
)

(instance jewelry of PicView
	(properties
		x 228
		y 105
		noun '/gem,gem,necklace,bracelet'
		description {jewelry}
		lookStr {It is very lovely jewelry, indeed.}
		view 335
		loop 1
		cel 1
		priority 7
		signal $4010
	)
)

(instance tiram of KattaMerchant
	(properties
		x 81
		y 120
		description {Tiram, the carpet merchant}
		lookStr {It is Tiram, the carpet merchant.}
		myName '//tiram,catperson,(merchant[<carpet])'
		title {Tiram:}
		clothesColor 3
	)
	
	(method (init)
		(super init:)
		(DrawFeature rugStand pole cart)
	)
	
	(method (doit)
		(super doit:)
		(if (not (& (ego illegalBits?) $2000))
			(ego illegalBits: (| (ego illegalBits?) $2000))
		)
		(if (curRoom script?) (return))
		(if
		(and (not (Btst 49)) (< (ego distanceTo: tiram) 60))
			(Say self 335 25)
			(Bset 49)
		)
	)
	
	(method (showSelf)
		(Say self 335 26)
	)
	
	(method (handleEvent pEvent)
		(return
			(cond 
				((Said 'ask//family') (self showSelf:))
				(
				(Said 'ask//gem,gem,necklace,bracelet,gold,silver') (Say self 335 22))
				((Said 'ask//sashanan') (Say self 335 23))
				(
					(or
						(Said 'buy,bargain/carpet')
						(Said 'buy,bargain//carpet')
					)
					(Say self 335 24)
				)
				((super handleEvent: pEvent) 0)
			)
		)
	)
	
	(method (atIndividualSpec param1)
		(return [local5 param1])
	)
)

(instance thanksForPin of HandsOffScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SkillUsed 13 40)
				(SkillUsed 14 50)
				(SayThanks sashanan self 335 27)
			)
			(1 (Say tiram self 335 28))
			(2 (Say sashanan self 335 29))
			(3 (self dispose:))
		)
	)
)

(instance rugStand of PicView
	(properties
		x 65
		y 129
		noun '/carpet,stand[<carpet]'
		description {the carpet stand of Tiram}
		lookStr {Tiram's carpet stand displays fine rugs of Shapeir.}
		view 335
		signal $4000
	)
)

(instance pole of PicView
	(properties
		x 94
		y 113
		shiftClick 0
		view 335
		cel 2
		priority 8
		signal $4010
	)
)

(instance cart of PicView
	(properties
		x 110
		y 101
		noun '/cart,barrow'
		description {the carpet merchant's cart}
		lookStr {It is Tiram's cart, filled with carpets.}
		view 335
		cel 1
		signal $4000
	)
)

(instance westSign of PicView
	(properties
		x 160
		y 46
		shiftClick 0
		view 310
		loop 2
		cel 2
		priority 6
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance rightWindow of PicView
	(properties
		x 252
		y 51
		noun '/window'
		description {a window}
		lookStr {There is an exceptional view of the Plaza from the window.}
		view 300
		loop 2
		cel 2
		priority 6
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance leftWindow of PicView
	(properties
		x 69
		y 51
		noun '/window'
		description {a window}
		lookStr {This window has exceptional southern exposure, depending on which way it's facing.}
		view 300
		loop 1
		cel 2
		priority 6
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance mosaic of PicView
	(properties
		x 159
		y 189
		noun '/mosaic,tile'
		description {the tile mosaic}
		lookStr {The mosaic tile work is exceptionally well-crafted.}
		view 301
		loop 8
		cel 1
		priority 0
		signal $4010
	)
	
	(method (init)
		(super init: &rest)
		(if
			(not
				(if (<= 0 currentTimeZone) (<= currentTimeZone 4))
			)
			(= palette 2)
		)
	)
)

(instance poly1 of Polygon
	(properties
		type $0002
	)
)
