;;; Sierra Script 1.0 - (do not remove this comment)
(script# 429)
(include sci.sh)
(use Main)
(use n001)
(use Stage)
(use LoadMany)
(use Motion)
(use Actor)

(public
	room 0
)

(instance room of Stage
	(properties
		picture 700
		style $0009
		south 703
		west 430
		bottomFromX 158
		bottomFromY 179
		bottomExit 4
		bottomToX 158
		bottomToY 147
		leftFromX 73
		leftFromY 147
		leftExit 1
		leftToX 140
		leftToY 147
	)
	
	(method (init)
		(= defaultPalette 2)
		(LoadMany 128 700 701)
		(ego init:)
		(proc1_19)
		(super init:)
		(door init:)
		(if (or (== prevRoomNum 430) (Btst 142))
			(door cel: 2)
		)
		(= saveIllegal -384)
		(if (Btst 142) (= saveIllegal (& saveIllegal $f7ff)))
		(DrawFeature barricade)
	)
	
	(method (doit)
		(if (== inOut 3)
			(cond 
				((& (ego onControl:) $0800) (= edgeHit 4))
				((>= (ego y?) 179) (= edgeHit 3))
			)
		)
		(super doit:)
	)
	
	(method (dispose)
		(= defaultPalette 0)
		(super dispose:)
	)
	
	(method (cue)
		(if (== inOut 1)
			(cond 
				((== prevRoomNum 430) (door setCycle: Beg))
				((Btst 142)
					(= saveIllegal (& saveIllegal $f7ff))
					(HighPrint 429 0)
					(proc1_15
						5
						{Please, enter quickly before the guards come!}
						80
						{Woman}
						103
					)
				)
			)
		)
		(super cue:)
	)
)

(instance barricade of PicView
	(properties
		x 160
		y 79
		noun '/sign,barricade'
		description {barricade}
		lookStr {This street has been barricaded off.__The sign reads 'Road closed by order of Khaveen'.}
		view 700
		loop 6
		cel 3
		palette 3
	)
	
	(method (handleEvent pEvent)
		(if (Said 'read/sign')
			(self doVerb: 1)
		else
			(super handleEvent: pEvent)
		)
	)
)

(instance door of Prop
	(properties
		x 100
		y 160
		noun '/door'
		description {the door}
		view 701
		loop 6
		priority 9
		signal $4010
		palette 3
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(2
				(if (== (door cel?) 2)
					(HighPrint 429 1)
				else
					(HighPrint 429 2)
				)
			)
			(1
				(if (== (door cel?) 2)
					(HighPrint 429 3)
				else
					(HighPrint 429 4)
				)
			)
			(else  (super doVerb: theVerb))
		)
	)
)
