;;; Sierra Script 1.0 - (do not remove this comment)
(script# 364)
(include sci.sh)
(use Main)
(use n001)
(use n002)
(use n003)
(use Talker)
(use Timer)
(use Motion)
(use Actor)
(use System)

(public
	ugarte 0
	ugarteTimer 1
)

(local
	[local0 38] = [15 16 17 14 14 14 14 14 14 14 18 14 19 14 20 14 14 14 21 22 14 14 14 23 24 14 14 14 14 14 25 14 26 14 14 14 14 14]
	[local38 28] = [0 '//service' 1 '//water' 2 '//info' 3 '//customer' 4 '//khaveen' 6 '//lackey' 7 '//someone' 8 '//people' 9 '//due' 10 '//prediction' 11 '//dungeon' 12 '//ferrari' 13 '//ad[<ad]']
)
(instance ugarteLeaves of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (not (ego script?))
					(Say ugarte self 364 0)
				else
					(= cycles 1)
				)
			)
			(1
				(= approachCode 0)
				(ugarte
					setLoop: -1
					setCycle: Walk
					setMotion: MoveTo 180 200 self
				)
			)
			(2
				(ugarte setMotion: MoveTo 160 250 self)
			)
			(3
				(ugarte dispose:)
				(ugarteMouth dispose:)
				(ugarteTimer dispose:)
				(self dispose:)
			)
		)
	)
)

(instance waterMsg of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ugarte
					setLoop: 5
					setCel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(1
				(ugarte
					setLoop: 4
					setCel: 0
					cycleSpeed: 1
					setCycle: End self
				)
			)
			(2 (ugarte setCycle: Beg self))
			(3
				(ugarte setLoop: 0)
				(Say ugarte self (ugarte msgFile?) 1)
			)
			(4
				(proc1_32 ugarteTimer 15)
				(self dispose:)
			)
		)
	)
)

(instance buyWaterS of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ugarte
					setLoop: 5
					setCel: 0
					cycleSpeed: 2
					setCycle: End self
				)
			)
			(1
				(ugarte setLoop: 0)
				(cond 
					((not register) (Say ugarte self 364 1) (= register 20))
					((TestSkill 13 100) (Say ugarte self 364 2) (= register 15))
					(else (Say ugarte self 364 3) (= register 0))
				)
			)
			(2
				(switch (proc3_1 (* register 100))
					(1
						(Say ugarte self 364 4)
						(= register 0)
					)
					(0
						(Say ugarte self 364 5)
						(= register 0)
					)
					(2
						(proc3_2 (* register 100))
						(= cycles 1)
					)
				)
			)
			(3
				(if (not register)
					(self changeState: 6)
				else
					(ugarte
						setLoop: 4
						setCel: 0
						cycleSpeed: 1
						setCycle: End self
					)
				)
			)
			(4
				(HighPrint 364 6)
				(= currentWater (+ currentWater 10))
				(= cycles 1)
			)
			(5
				(ugarte setLoop: 5 setCycle: Beg self)
			)
			(6
				(proc1_32 ugarteTimer 15)
				(ugarte setLoop: 0)
				(self dispose:)
			)
		)
	)
)

(instance ugarte of Talker
	(properties
		description {Ugarte}
		lookStr {He smiles at you and you are reminded of a weasel.__He speaks, and you think of snakes.}
		view 362
		tLoop -1
		talkSpeed 1
		myName '//ugarte,man'
		title {Ugarte:}
		color 5
		msgFile 362
	)
	
	(method (init)
		(super init: &rest)
		(Load rsVIEW 362)
		(Load rsTEXT 362)
		(ugarteMouth init: hide:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(or (Said 'buy/water') (Said 'bargain//water'))
				(cond 
					(mover)
					((not (Btst 111)) (Say self 364 7))
					(else (self setScript: buyWaterS))
				)
			)
		)
	)
	
	(method (respond param1)
		(if (and (== global295 3) (not (Btst 111)))
			(param1 claimed: 1)
			(Say self 364 8)
		else
			(proc1_32 ugarteTimer 15)
			(super respond: param1 &rest)
		)
	)
	
	(method (atSpec param1)
		(return [local38 param1])
	)
	
	(method (atGen param1)
		(return [local0 param1])
	)
	
	(method (showText param1)
		(if (== param1 1)
			(self setScript: waterMsg)
		else
			(super showText: param1 &rest)
		)
	)
	
	(method (messages)
		(ugarteMouth
			x: (+ (ugarte x?) 4)
			y: (- (ugarte y?) 34)
			setCycle: Fwd
			show:
		)
		(super messages: &rest)
	)
	
	(method (endTalk)
		(ugarteMouth hide:)
		(super endTalk: &rest)
	)
)

(instance ugarteMouth of Prop
	(properties
		view 362
		loop 6
		priority 15
		signal $0010
		cycleSpeed 1
	)
)

(instance ugarteTimer of Timer
	(properties)
	
	(method (cue)
		(ugarte setScript: ugarteLeaves)
		(self dispose:)
	)
)
